Package: bigmelon
Type: Package
Title: Illumina methylation array analysis for large experiments
Version: 1.37.0
Authors@R: c(
    person(c("Tyler", "J."), "Gorrie-Stone", role="aut"),
    person("Ayden", "Saffari", role="aut"),
    person("Karim", "Malki", role="aut"),
    person(c("Leonard", "C."), "Schalkwyk", role=c("cre", "aut"), email="lschal@essex.ac.uk")
    )
Description: Methods for working with Illumina arrays using gdsfmt.
License: GPL-3
Depends: R (>= 3.3), wateRmelon (>= 1.25.0), gdsfmt (>= 1.0.4),
        methods, minfi (>= 1.21.0), Biobase, methylumi
Imports: stats, utils, GEOquery, graphics, BiocGenerics, illuminaio
Suggests: BiocGenerics, RUnit, BiocStyle, minfiData, parallel,
        IlluminaHumanMethylation450kanno.ilmn12.hg19,
        IlluminaHumanMethylationEPICanno.ilm10b2.hg19, bumphunter
LazyLoad: yes
Collate: zzz.R es2gds.R dasenGds.R dbGdsn.R dfsfitGdsn.R gds2mlumi.R
        gdsnclass_methods.R inout.R pfilterGds.R prcompGdsn.R
        pwodGdsn.R qnGdsn.R comboGds.R ranknorm.R GEOtoGDS.R ecc.gdsn.R
        bumphunterGdsn.R chainsaw.R
biocViews: DNAMethylation, Microarray, TwoChannel, Preprocessing,
        QualityControl, MethylationArray, DataImport, CpGIsland
NeedsCompilation: no
RoxygenNote: 7.3.1
git_url: https://git.bioconductor.org/packages/bigmelon
git_branch: devel
git_last_commit: 142a0e8
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
Packaged: 2025-11-04 21:25:46 UTC; biocbuild
Author: Tyler J. Gorrie-Stone [aut],
  Ayden Saffari [aut],
  Karim Malki [aut],
  Leonard C. Schalkwyk [cre, aut]
Maintainer: Leonard C. Schalkwyk <lschal@essex.ac.uk>

# bigmelon
Memory Efficient Methods for DNA Methylation Analysis

## Software status

| Resource:     | Bioconductor        | Travis CI     |
| ------------- | ------------------- | ------------- |
| _Platforms:_  | _Multiple_          | _Linux_       |
| R CMD check   | <a href="http://bioconductor.org/checkResults/release/bioc-LATEST/bigmelon/"><img border="0" src="http://bioconductor.org/shields/build/release/bioc/bigmelon.svg" alt="Build status"></a> (release)</br><a href="http://bioconductor.org/checkResults/devel/bioc-LATEST/bigmelon/"><img border="0" src="http://bioconductor.org/shields/build/devel/bioc/bigmelon.svg" alt="Build status"></a> (devel) | <a href="https://travis-ci.org/tjgorrie/bigmelon"><img src="https://travis-ci.org/tjgorrie/bigmelon.svg" alt="Build status"></a> |

## Installation
We are constantly updating both bigmelon and wateRmelon and will try to keep the github inline with the bioconductor mirror as much as possible. However if you want the latest features before they are committed to bioconductor you can install both wateRmelon and bigmelon using the code below. 

When we introduce functionality into bigmelon this will also be mirrored in wateRmelon and will often require the absolute latest version.

```
library(devtools)
devtools::install_git('https://github.com/schalkwyk/wateRmelon')
devtools::install_git('https://github.com/tjgorrie/bigmelon')
```

## Authors

Tyler J. Gorrie-Stone and Leonard C. Schalkwyk

School of Biological Sciences
University of Essex
Colchester, UK

## Citation
If you use bigmelon for your analyses, please use citation() within R or cite [our paper](10.1093/bioinformatics/bty713) as:

Tyler J Gorrie-Stone, Melissa C Smart, Ayden Saffari, Karim Malki, Eilis Hannon, Joe Burrage, Jonathan Mill, Meena Kumari, Leonard C Schalkwyk, Bigmelon: tools for analysing large DNA methylation datasets, Bioinformatics, Volume 35, Issue 6, 15 March 2019, Pages 981–986, https://doi.org/10.1093/bioinformatics/bty713 

## Abstract
DNA methylation analyses are getting ever bigger.With the release of the HumanMethylationEpic microarray by Illumina and datasets reaching into the thousands, analysis of these large datasets using popular R packages is becoming impractical due to memory requirements and even the time required to read the data from disk. As such there is an increasing need for computationally efficient methods to perform meaningful analysis on high dimension data.

The bigmelon R package provides a memory-efficient work-flow that enables users to perform complex, large scale analyses required in EWAS without huge RAM. Building on the CoreArray Genome Data Structure (.gds) file format and libraries packaged in 'gdsfmt', we provide a familiar wateRmelon-like work flow that facilitates reading-in, preprocessing, quality control and statistical analysis.

To demonstrate large-scale data analyses, we stored the entire contents of the marmal-aid database (>14,500 samples) in a .gds file and demonstrate quality measures and principal components analysis.

Overall, bigmelon provides a familiar environment for users to perform large-scale analyses where  convention methods would run out of memory. Bigmelon shows reasonable performance in speed compared to conventional methods.

dasen.gds <-   function(gds,
                        node,
                        mns,
                        uns,
                        onetwo,
                        roco,
                        fudge,
                        ret2
                        ){ # {{{  
    # Assuming that mns and uns are 1 element character strings!not gdsn.nodes
    if(length(mns) == 1) mns <- index.gdsn(gds, mns)
    if(length(uns) == 1) uns <- index.gdsn(gds, uns)
    if(length(onetwo) == 1)  onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    # NORMALIZING
    dfsfit.gdsn(f, targetnode = mns, roco = roco, newnode = "mnsc",
                onetwo = onetwo)
    dfsfit.gdsn(f, targetnode = uns, roco = NULL, newnode = "unsc",
                onetwo = onetwo)
    ## Splitting arrays by probe Type
    # Initiliazing new nodes
    mI  <- add.gdsn(f, "metI" , storage = "float64", 
                valdim = c(sum(onetwo=='I'), 0),val = NULL, replace = TRUE)
    mII <- add.gdsn(f, "metII" , storage = "float64", 
                valdim = c(sum(onetwo=='II'), 0), val = NULL, replace = TRUE)
    uI  <- add.gdsn(f, "umeI" , storage = "float64", 
                valdim = c(sum(onetwo=='I'), 0), val = NULL, replace = TRUE)
    uII <- add.gdsn(f, "umeII" , storage = "float64", 
                valdim = c(sum(onetwo=='II'), 0), val = NULL, replace = TRUE)
    # Separating probes into type I and II and appending to object col by col.
    for(x in 1:dim[2]){
        append.gdsn(mI , readex.gdsn(index.gdsn(f, "mnsc"),
                    sel = list(onetwo=='I' , x)))
        append.gdsn(mII, readex.gdsn(index.gdsn(f, "mnsc"),
                    sel = list(onetwo=='II', x)))
        append.gdsn(uI , readex.gdsn(index.gdsn(f, "unsc"),
                    sel = list(onetwo=='I' , x)))
        append.gdsn(uII, readex.gdsn(index.gdsn(f, "unsc"),
                    sel = list(onetwo=='II', x)))
    }
    # Normalize seperately using qn.gdsn
    qn.gdsn(f, target = mI , newnode = "metIqn" )
    qn.gdsn(f, target = mII, newnode = "metIIqn")
    qn.gdsn(f, target = uI , newnode = "umeIqn" )
    qn.gdsn(f, target = uII, newnode = "umeIIqn")
    # Relcalculating betas 
    # Creating new node where normalized betas will be stored. / replacement
    n.t <- add.gdsn(gds, name = node, storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        meth   <- rep(x = NA, times = dim[1])
        unmeth <- rep(x = NA, times = dim[1])
        meth[onetwo == 'I']    <- readex.gdsn(index.gdsn(f,   "metIqn"),
                                            sel = list(NULL , x))
        meth[onetwo == 'II']   <- readex.gdsn(index.gdsn(f,  "metIIqn"),
                                            sel = list(NULL , x))
        unmeth[onetwo == 'I']  <- readex.gdsn(index.gdsn(f,   "umeIqn"),
                                            sel = list(NULL , x))
        unmeth[onetwo == 'II'] <- readex.gdsn(index.gdsn(f,  "umeIIqn"),
                                            sel = list(NULL , x))
        beta <- meth/(meth + unmeth + fudge)
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, meth)
            append.gdsn(n.u, unmeth)
        }
    }
    closefn.gds(f)
    unlink("temp.gds", force = TRUE)
} # }}}

naten.gds <-  function( gds,
                        node,
                        mns,
                        uns,
                        fudge,
                        ret2
                        ){ # {{{
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    ## NORMALIZING
    qn.gdsn(f, target = mns, newnode = "natenmeth")
    qn.gdsn(f, target = uns, newnode = "natenunmeth")
    ## Recalculating Betas  
    # Creating new node for betas.
    n.t <- add.gdsn(gds, name = node , storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        mn <- readex.gdsn(index.gdsn(f , "natenmeth"), sel = list(NULL, x))
        un <- readex.gdsn(index.gdsn(f,"natenunmeth"), sel = list(NULL, x))
        beta <- mn / ( mn + un + fudge )
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, mn)
            append.gdsn(n.u, un)
        }
    }  
    closefn.gds(f)
    unlink("temp.gds", force = TRUE) 
} # }}}

danen.gds <-  function( gds,
                        node,
                        mns,
                        uns,
                        onetwo,
                        roco,
                        fudge,
                        ret2
                        ){ # {{{  
    if(length(onetwo) == 1)  onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    ## NORMALIZING
    dfsfit.gdsn(f, targetnode = mns, roco = roco,
                newnode = "mnsc", onetwo = onetwo)
    dfsfit.gdsn(f, targetnode = uns, roco = NULL,
                newnode = "unsc", onetwo = onetwo)
    ## Recalculating Betas
    # Creating new node for betas
    n.t <- add.gdsn(gds, name = node , storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        mn <- readex.gdsn(index.gdsn(f, "mnsc"), sel = list(NULL, x))
        un <- readex.gdsn(index.gdsn(f, "unsc"), sel = list(NULL, x))
        beta <- mn / ( mn + un + fudge )
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, mn)
            append.gdsn(n.u, un)
        }
    }
    closefn.gds(f)
    unlink("temp.gds", force = TRUE) 
} # }}}

daten1.gds <-  function(gds,
                        node,
                        mns,
                        uns,
                        onetwo,
                        roco,
                        fudge,
                        ret2
                        ){ # {{{
    if(length(onetwo) == 1)  onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    ## NORMALIZING
    dfsfit.gdsn(f,  targetnode = mns, roco = roco, 
                newnode = "mnsc", onetwo = onetwo)
    dfsfit.gdsn(f,  targetnode = uns, roco = NULL,
                newnode = "unsc", onetwo = onetwo)
    qn.gdsn(f, target = index.gdsn(f,"mnsc"), newnode = "daten1meth")
    qn.gdsn(f, target = index.gdsn(f,"unsc"), newnode = "daten1unmeth") 
    ## Recalculating Betas
    # Creating new node for betas
    n.t <- add.gdsn(gds, name = node , storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        mn <- readex.gdsn(index.gdsn(f, "daten1meth"), sel = list(NULL, x))
        un <- readex.gdsn(index.gdsn(f, "daten1unmeth"), sel = list(NULL, x))
        beta <- mn / ( mn + un + fudge )
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, mn)
            append.gdsn(n.u, un)
        }
    }
    closefn.gds(f)
    unlink("temp.gds", force = TRUE)
} # }}}

daten2.gds <-  function(gds,
                        node,
                        mns,
                        uns,
                        onetwo,
                        roco,
                        fudge,
                        ret2
                        ){ # {{{
    if(length(onetwo) == 1)  onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo) 
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    ## NORMALIZATION
    dfsfit.gdsn(f,  targetnode = mns, roco = roco,
                newnode = "mnsc", onetwo = onetwo)
    dfsfit.gdsn(f,  targetnode = uns, roco = roco,
                newnode = "unsc", onetwo = onetwo)
    qn.gdsn(f, target = index.gdsn(f,"mnsc"), newnode = "daten2meth")
    qn.gdsn(f, target = index.gdsn(f,"unsc"), newnode = "daten2unmeth")
    ## Recalculating Betas
    # Adding new node for betas
    n.t <- add.gdsn(gds, name = node, storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){ 
        mn <- readex.gdsn(index.gdsn(f, "daten2meth"), sel = list(NULL, x))
        un <- readex.gdsn(index.gdsn(f, "daten2unmeth"), sel = list(NULL, x))
        beta <- mn / ( mn + un + fudge )
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, mn)
            append.gdsn(n.u, un)
        }
    }
    closefn.gds(f)
    unlink("temp.gds", force = TRUE)
} # }}}

nasen.gds <-  function(gds ,
                        node,
                        mns,
                        uns,
                        onetwo,
                        fudge,
                        ret2
                        ){ # {{{
    if(length(onetwo) == 1)  onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    ## Normalization
    ## Splitting arrays by probe Type
    # Initiliazing new nodes
    mI  <- add.gdsn(f, "metI" , storage = "float64", 
        valdim = c(sum(onetwo=='I'), 0), val = NULL, replace = TRUE)
    mII <- add.gdsn(f, "metII" , storage = "float64", 
        valdim = c(sum(onetwo=='II'), 0), val = NULL, replace = TRUE)
    uI  <- add.gdsn(f, "umeI" , storage = "float64", 
        valdim = c(sum(onetwo=='I'), 0), val = NULL, replace = TRUE)
    uII <- add.gdsn(f, "umeII" , storage = "float64", 
        valdim = c(sum(onetwo=='II'), 0), val = NULL, replace = TRUE)
    # Separating probes
    for(x in 1:dim[2]){
        append.gdsn(mI , readex.gdsn(mns, sel = list(onetwo == 'I' , x)))
        append.gdsn(mII, readex.gdsn(mns, sel = list(onetwo == 'II', x)))
        append.gdsn(uI , readex.gdsn(uns, sel = list(onetwo == 'I' , x)))
        append.gdsn(uII, readex.gdsn(uns, sel = list(onetwo == 'II', x)))
    }
    # Norm
    qn.gdsn(f, target = mI , newnode = "metIqn" )
    qn.gdsn(f, target = mII, newnode = "metIIqn")
    qn.gdsn(f, target = uI , newnode = "umeIqn" )
    qn.gdsn(f, target = uII, newnode = "umeIIqn")
    ## Recalculating Betas
    # Adding new node
    n.t <- add.gdsn(gds, name = node, storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        meth   <- rep(x = NA, times = dim[1])
        unmeth <- rep(x = NA, times = dim[1])
        meth[onetwo == 'I']    <- readex.gdsn(index.gdsn(f,   "metIqn"),
                                            sel = list(NULL , x))
        meth[onetwo == 'II']   <- readex.gdsn(index.gdsn(f,  "metIIqn"),
                                            sel = list(NULL , x))
        unmeth[onetwo == 'I']  <- readex.gdsn(index.gdsn(f,   "umeIqn"),
                                            sel = list(NULL , x))
        unmeth[onetwo == 'II'] <- readex.gdsn(index.gdsn(f,  "umeIIqn"),
                                            sel = list(NULL , x))
        beta <- meth/(meth + unmeth + fudge)
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, meth)
            append.gdsn(n.u, unmeth)
        }
    }
    closefn.gds(f)
    unlink("temp.gds", force = TRUE)
} # }}}

nanet.gds <-  function( gds,
                        node,
                        mns,
                        uns,
                        fudge,
                        ret2
                        ){ # {{{
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    ## Normalization
    db.gdsn(f, mns, uns)
    ## Recalculating Betas
    # Adding new node for betas
    n.t <- add.gdsn(gds, name = node , storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE) 
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        mn <- readex.gdsn(index.gdsn(f, "db.meth"), sel = list(NULL, x))
        un <- readex.gdsn(index.gdsn(f, "db.unmeth"), sel = list(NULL, x))
        beta <- mn / ( mn + un + fudge )
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, mn)
            append.gdsn(n.u, un)
        }
    }
    closefn.gds(f)
    unlink("temp.gds", force = TRUE)
} # }}}

danet.gds <- function(  gds,
                        node,
                        mns,
                        uns,
                        onetwo,
                        roco,
                        fudge,
                        ret2
                        ){ # {{{
    if(length(onetwo) == 1) onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    ## Normalization
    dfsfit.gdsn(f, targetnode = mns, roco = roco,
                newnode = "mnsc", onetwo = onetwo)
    dfsfit.gdsn(f, targetnode = uns, roco = roco,
                newnode = "unsc", onetwo = onetwo)
    db.gdsn(f, mns = index.gdsn(f, "mnsc"), uns = index.gdsn(f, "unsc"))
    ## Recalculating Betas
    # Adding new node for betas
    n.t <- add.gdsn(gds, name = node, storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated", storage = "float64",
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        mn <- readex.gdsn(index.gdsn(gds, "db.meth"), sel = list(NULL, x))
        un <- readex.gdsn(index.gdsn(gds, "db.unmeth"), sel = list(NULL, x))
        beta <- mn / ( mn + un + fudge )
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, mn)
            append.gdsn(n.u, un)
        }
    }
    closefn.gds(f)
    unlink("temp.gds", force = TRUE)
} # }}}

nanes.gds <- function(  gds,
                        node,
                        mns,
                        uns,
                        onetwo,
                        fudge,
                        ret2
                        ){ # {{{
    if(length(onetwo) == 1) onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    met <- mns
    ume <- uns
    dim <- objdesp.gdsn(met)$dim
    ## Splitting arrays by probe Type
    # Initiliazing new nodes
    mI  <- add.gdsn(f, "metI" , storage = "float64", 
                valdim = c(sum(onetwo == 'I'), 0), val = NULL, replace = TRUE)
    mII <- add.gdsn(f, "metII" , storage = "float64", 
                valdim = c(sum(onetwo == 'II'), 0), val = NULL,replace = TRUE)
    uI  <- add.gdsn(f, "umeI" , storage = "float64", 
                valdim = c(sum(onetwo == 'I'), 0), val = NULL, replace = TRUE)
    uII <- add.gdsn(f, "umeII" , storage = "float64", 
                valdim = c(sum(onetwo == 'II'), 0), val = NULL,replace = TRUE)
    # Separating probes
    for(x in 1:dim[2]){
        append.gdsn(mI , readex.gdsn(met, sel = list(onetwo == 'I' , x)))
        append.gdsn(mII, readex.gdsn(met, sel = list(onetwo == 'II', x)))
        append.gdsn(uI , readex.gdsn(ume, sel = list(onetwo == 'I' , x)))
        append.gdsn(uII, readex.gdsn(ume, sel = list(onetwo == 'II', x)))
    }
    ## Normalization per nanes method
    qn.gdsn(f, target = index.gdsn(f,"metI"), newnode = "metIqn")
    qn.gdsn(f, target = index.gdsn(f,"umeI"), newnode = "umeIqn")
    db.gdsn(f, mns = index.gdsn(f,"metII"), uns = index.gdsn(f, "umeII"))
    ## Recalculating Betas
    # Initialising nodes for betas, meth and unmeth
    n.t <- add.gdsn(gds, name = node , storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    if(ret2 == TRUE){
        n.m <- add.gdsn(gds, "methylated" , storage = "float64", 
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
        n.u <- add.gdsn(gds, "unmethylated" , storage = "float64", 
                        valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    }
    for(x in 1:dim[2]){
        meth <- rep(x = NA, times = dim[1])
        unmeth <- rep(x = NA, times = dim[1])
        meth[onetwo == 'I']    <- readex.gdsn(index.gdsn(f,   "metIqn"),
                                                sel = list(NULL , x))
        meth[onetwo == 'II']   <- readex.gdsn(index.gdsn(f,  "db.meth"),
                                                sel = list(NULL , x))
        unmeth[onetwo == 'I']  <- readex.gdsn(index.gdsn(f,   "umeIqn"),
                                                sel = list(NULL , x))
        unmeth[onetwo == 'II'] <- readex.gdsn(index.gdsn(f,"db.unmeth"),
                                                sel = list(NULL , x))
        beta <- meth/(meth + unmeth + fudge)
        append.gdsn(n.t, beta)
        if(ret2 == TRUE){
            append.gdsn(n.m, meth)
            append.gdsn(n.u, unmeth)
        }
    } 
    closefn.gds(f)
    unlink("temp.gds", force = TRUE)
} # }}}

danes.gds <-  function( gds,
                        node,
                        mns,
                        uns,
                        onetwo,
                        fudge,
                        ret2,
                        ...
                        ){ # {{{
    if(length(onetwo) == 1)  onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f.f <- createfn.gds("tempdanes.gds", allow.duplicate = TRUE)
    ## Normalization
    dfsfit.gdsn(gds = f.f, targetnode = mns, newnode = "mnsc",
                onetwo = onetwo, ...) # roco = NULL?
    dfsfit.gdsn(gds = f.f, targetnode = uns, newnode = "unsc",
                onetwo = onetwo, ...) # roco = NULL?
    nanes.gds(  gds = gds,
                node = node,
                mns = index.gdsn(f.f,"mnsc"),
                uns = index.gdsn(f.f,"unsc"), 
                onetwo = onetwo,
                fudge = fudge,
                ret2 = ret2
                )
    closefn.gds(f.f)
    unlink("tempdanes.gds", force = TRUE)
} # }}}

.onLoad <- function(libname = find.package("bigmelon"), pkgname="bigmelon"){
    options(runLast = TRUE)
    .GlobalEnv$.Last <- function(x = ls(.GlobalEnv)){
        for(i in x){
            if(inherits(get(i), "gds.class")){
            a <- try(closefn.gds(get(i)), silent = TRUE)
            }
        }
    }
}

# combo.gds
# Difficult, uncompromising and insulting. Like me in the morning. #TGS
# Forcefully coerces secondary gds node to mirror primarys dimensions forcing 
# NAs(if necessary).
# TODO: Make coherent pData combination.
combo.gds <- function(file, primary, secondary){
    # file = newgds file
    # Primary = gds.class object
    # Secondary = gds.class object
    # Assumes both objects are bigmelon made gds.classes!
    # Preliminary Safety Checks
    # Are they gds objects
    if(!class(primary) == "gds.class") stop("Primary is not a gds object!")
    if(!class(secondary) == "gds.class") stop("Secondary is not a gds object!")
    history.submitted <- as.character(Sys.time())  
    if(!(file_test('-f', file))){
        message(paste(file, "doesn't exist, creating new file"))
        bmln <- newgds(file)
    } else if((file_test('-f', file))){
        stop('File already exists')
    }
    primnod <- ls.gdsn(primary)
    seconod <- ls.gdsn(secondary)
    # Identify Common Nodes
    sharenod <- primnod[primnod %in% seconod]
    names(sharenod) <- sharenod
    # forces row length of primary gds object
    forcerow <- rownames(primary)
    primdim <- objdesp.gdsn(index.gdsn(primary, "betas"))$dim
    secodim <- objdesp.gdsn(index.gdsn(secondary, "betas"))$dim
    for(x in c("betas", "pvals", "methylated", "unmethylated", "NBeads")){
        if(x %in% sharenod){
            # Determines trait class of sharenodes and uses same storage
            if(getTrait(index.gdsn(primary, x)) == 
                getTrait(index.gdsn(secondary, x))
                ){
                trait <- tolower(getTrait(index.gdsn(primary, x))) 
            } else { 
                trait <- "float64"
            }
            n.t <- add.gdsn(bmln, x, valdim = c(primdim[1], 0),
                            val = NULL, storage = trait, replace = TRUE)
            message(paste("Appending", x, "from primary node to", file))
            for(m in 1:primdim[2]){ # This will coerce NA's for missing probes
                val <- index.gdsn(primary, x)[forcerow, m, name = FALSE]
                append.gdsn(n.t, val)
            }
            message(paste("Appending", x, "from secondary node to:", file))
            for(k in 1:secodim[2]){
                val <- index.gdsn(secondary, x)[forcerow, k, name = FALSE]
                append.gdsn(n.t, val)
            }  
        }
    }
    if(!"fData" %in% sharenod){
        # If fData is missing from one node, do not append fData(?). Assumption
        # is if fData is missing, this operation cannot be completed anyway.
    } else {
        fDPrim <- fData(primary)[forcerow, ]
        message("Creating fData node...")
        add.gdsn(bmln, "fData", val = fDPrim)
        message("Appending fData...")
    }
    pD <- data.frame(t(rbind(c(colnames(primary), colnames(secondary)))))
    colnames(pD) <- "barcode"
    #Current pData only combines column names.
    message("Creating pData node...")
    add.gdsn(bmln, "pData", val = pD)
    message("Appending pData...")
    for(x in c("QCmethylated", "QCunmethylated")){
        if(x %in% sharenod){
            message(paste("Creating", x, "node..."))
            n.t <- add.gdsn(bmln, x, valdim = c(length(QCrownames(primary)),0),
                            val = NULL, replace = TRUE, storage="int32")
            message(paste("Appending Primary Node to:", file))
            for(m in 1:primdim[2]){
                val <- readex.gdsn(index.gdsn(primary, x), sel = list(NULL, m))
                append.gdsn(n.t, val, check = FALSE)
            }
            message(paste("Appending Secondary Node to:", file))
            for(k in 1:secodim[2]){
                val <- readex.gdsn(index.gdsn(secondary, x), sel=list(NULL, k))
                append.gdsn(n.t, val, check = FALSE)
            }  
        }
    }
    add.gdsn(bmln, "QCrownames", val = QCrownames(primary))
    history.finished <- as.character(Sys.time())
    history.command <- paste0("Combo of: ",
                                primary[[1]], " and ", secondary[[1]], ".")
    h <- data.frame(submitted = history.submitted, 
                    finished = history.finished, 
                    command = history.command,   
                    stringsAsFactors = FALSE)
    add.gdsn(bmln, "history", val = h)
    add.gdsn(bmln, "paths", val = c("fData/Probe_ID", "pData/barcode"))
    return(bmln)
}

getTrait <- function(x){
    objdesp.gdsn(x)$trait
}

# Arguments: See ?wateRmelon::pfilter
# NOTE: One change in how bab is computed, rather than apply beadc to matrix
# supplied we assume that a beadcount matrix is an integer matrix and remove
# values IF the supplied matrix is of integers. This is IF beadcount are
# not supplied, the betas are used instead.
pfilter.gds <- function(mn = NULL, un = NULL, bn = NULL, da = NULL, pn, bc,
                        perCount = NULL, pnthresh = NULL, perc = NULL,
                        pthresh = NULL){
    # TODO: Get rid of this mess
    if(!is.null(list(pn, bc))){
        if(is.null(perCount)){
            perCount = 5
        }
        if(is.null(pnthresh)){
            pnthresh = 0.05
        }
        if(!is.null(pnthresh)){
            pnthresh = pnthresh
        }
        if(is.null(perc)){
            perc = 1
        }
        if(!is.null(perc)){
            perc = perc
        }
        if(is.null(pthresh)){
            pthresh = 1
        }
        if(!is.null(pthresh)){
            pthresh = pthresh
        }
        dim <- objdesp.gdsn(pn)$dim
        goodsamps <- apply.gdsn(node = pn,
                                margin = 2,
                                FUN = function(x, y, z){
                                    (sum(x>y, na.rm = TRUE)) < ((sum(!is.na(x))*z)/100)
                                },
                                as.is = "logical",
                                y = pnthresh,
                                z = perc
                                )
        bab <- apply.gdsn(node = bc,
                            margin = 1,
                            as.is = "integer",
                            FUN = function(x, y){
                            if((class(x)=="integer")) x[x<3] <- NA
                            # Incase betas are supplied instead of NBeads
                            length(which(is.na(x[y])=="TRUE"))
                            },
                            y = goodsamps
                            )
        nsamples <- apply.gdsn(node = bc,
                            margin = 1,
                            as.is = "integer",
                            FUN = function(x, y){
                            sum(!is.na(x[y]))
                            },
                            y = goodsamps
                            )
        badbead_log <- bab > ((nsamples * perCount)/100)
        badbead <- which(badbead_log)
        bap <- apply.gdsn(node = pn,
                            margin = 1,
                            as.is = "logical",
                            FUN = function(x, y, z, p){
                                sum(x[y] > z) > ((length(x) * p/100))
                            },
                            y = goodsamps,
                            z = pnthresh,
                            p = pthresh
                            )
        badp <- which(bap)
        message(sum(!goodsamps), " samples having", perc,
            "% of sites with a detection p-value greater than ",
            pnthresh, " were removed.")
        message("Samples removed: ", colnames(bc)[!goodsamps])
        message(length(badbead), " sites were remove as beadcount <3 in ",
            perCount, "% of samples.")
        message(length(badp), " sites having ", pthresh,
            "% of samples with a detection p-value greater than ",
            pnthresh, " were removed.")
        # Only does logical return.
        return(list(probes = (!bap & !badbead_log), samples = goodsamps))
    }
}

.getEstimate2 <- function(mat, design, coef, B = NULL, permutations = NULL, full = FALSE){
  # mat = node (i.e betas)
  p <- objdesp.gdsn(mat)$dim[2]
  n <- objdesp.gdsn(mat)$dim[1]
  v <- design[, coef]
  A <- design[, -coef, drop = FALSE]
  qa <- qr(A)
  S <- diag(nrow(A)) - tcrossprod(qr.Q(qa)) # ncol * ncol matrix, "small"
  vv <- if(is.null(B)){
    matrix(v, ncol = 1)
  } else {
    if (is.null(permutations)) {
      replicate(B, sample(v))
    } else {
      apply(permutations, 2, function(i) v[i])
    }
  }
  sv <- S %*% vv
  vsv <- diag(crossprod(vv, sv))
  #### Code Changes here!
  if(full){
    df.residual <- p - qa$rank - 1
    if(is.null(B)){
      o <- apply.gdsn(node = mat, margin = 1, as.is = 'list',
      #target.node = list(n.b, n.r),
          FUN = function(x, S, vv, vsv, sv, df.residual){
            sy <- x %*% S
            b <- (x %*% crossprod(S, vv))/vsv
            tcross <- tcrossprod(b, sv)
            sigma <- sum((sy - tcross)^2)/df.residual
            list('B'=b, 'sigma'= sigma)
          }, 
          S = S, vv = vv, vsv = vsv, sv = sv, 
          df.residual = df.residual
      )
    } else {
      o <- apply.gdsn(node=mat, margin=1, as.is = 'list', 
      #target.node = list(n.b, n.r),
         FUN = function(x, S, vv, vsv, sv, B, df.residual){
           tmp <- sy <- x %*% S
           sigma <- b <- (x %*% crossprod(S, vv))/vsv
           for(j in seq_len(B)){
             tmp <- tcrossprod(b[,j], sv[,j])
             sigma[j] <- sum((sy-tmp)^2)
           }
           sigma <- sqrt(sigma/df.residual)
           list('B'= b, 'sigma'=sigma)
         }, S = S, vv = vv, vsv = vsv, sv = sv, 
         df.residual = df.residual, B = B
      )
    }
    coef <- if(is.null(B)) sapply(o, '[[', 'B') else t(sapply(o, '[[', 'B'))
    sigma <- if(is.null(B)) sapply(o, '[[', 'sigma') else t(sapply(o, '[[', 'sigma'))
    out <- list(coef = coef, # n * B big
        sigma = sigma, # n * B big
        stdev.unscaled = sqrt(1/vsv), 
        df.residual = df.residual)
    if(is.null(B)) out$stdev <- as.numeric(out$stdev)
  } else {
    out <- apply.gdsn(node=mat, margin = 1, as.is = 'list',
       FUN = function(x, S, vv, vsv){
          b <- (x %*% crossprod(S, vv))/vsv
        },
        S = S, vv = vv, vsv = vsv
    )
    out <- do.call(rbind, out)
  }
  return(out)
}


bumphunterEngine.gdsn <-function(mat, design, chr = NULL, pos,
   cluster = NULL, coef = 2,
   cutoff = NULL, pickCutoff = FALSE,
   pickCutoffQ = 0.99,
   maxGap = 500,
   nullMethod = c("permutation","bootstrap"),
   smooth = FALSE,
   smoothFunction = locfitByCluster,
   useWeights = FALSE,
   B = ncol(permutations),
   permutations = NULL,
   verbose = TRUE, ...){
      nullMethod  <- match.arg(nullMethod)
      n <- objdesp.gdsn(mat)$dim[1]
      p <- objdesp.gdsn(mat)$dim[2]
      if (is.null(B))  B = 0
      if (!is.matrix(permutations) & !is.null(permutations)) stop(
         "permutations must be NULL or a matrix."
      )
    if (!is.null(permutations)) {
    if (nrow(design) != nrow(permutations)) stop(
     "Number of rows of 'design' must match number of rows of 'permutations'."
    )
    if (B != ncol(permutations)) {
      warning("Ignoring the supplied B. Using 'ncol(permutations)' instead.")
      B = ncol(permutations)
    }
  }
  if (ncol(design) > 2 & B > 0 & nullMethod == "permutation"){
    message("[bumphunterEngine] The use of the permutation test is not recommended with multiple covariates, (ncol(design)>2). Consider changing 'nullMethod' changed to 'bootstrap' instead. See vignette for more information.")
    warning("The use of the permutation test is not recommended with multiple covariates, (ncol(design)>2). Consider changing 'nullMethod' changed to 'bootstrap' instead. See vignette for more information.")
  }
  if (p != nrow(design))
    stop("Number of columns of 'mat' must  match number of rows of 'design'")
  if (B < 0)
    stop("'B' has to be an integer greater or equal to zero")
  if (!(is.null(cutoff) || length(cutoff) %in% 1:2))
    stop("'cutoff' has to be either NULL or a vector of length 1 or 2")
  if (length(cutoff) == 2)
    cutoff <- sort(cutoff)
  if (is.null(cutoff) && !pickCutoff)
    stop("Must pick a cutoff, either using 'cutoff' or 'pickCutoff'")
  if (!is.null(cutoff) && pickCutoff) {
    pickCutoff <- FALSE
    warning("'cutoff' was supplied so ignoring 'pickCutoff=TRUE'")
  }
  if (pickCutoff && (length(pickCutoffQ) != 1 || pickCutoff <  0 || pickCutoffQ > 1))
    stop("Using `pickCutoff = TRUE' requires that 'pickCutoffQ' is a single number between 0 and 1")
  if (pickCutoff && B < 1)
    stop("Must do at least one permution to pick a cutoff")
  ####
  if (!getDoParRegistered())
    registerDoSEQ()
  workers <- getDoParWorkers()
  backend <- getDoParName()
  version <- getDoParVersion()
  ####
  subverbose <- max(as.integer(verbose) - 1L, 0)
  if (verbose) {
    if (workers == 1) {
      mes <- "[bumphunterEngine] Using a single core (backend: %s, version: %s)."
      message(sprintf(mes, backend, version))
    }
    else {
      mes <- "[bumphunterEngine] Parallelizing using %s workers/cores (backend: %s, version: %s)."
      message(sprintf(mes, workers, backend, version))
    }
  }
  if (is.null(chr))
    chr <- rep("Unspecified", length(pos))
  if (is.factor(chr))
    chr <- as.character(chr)
  if (is.null(cluster))
    cluster <- bumphunter::clusterMaker(chr, pos, maxGap = maxGap)
  if (verbose)
    message("[bumphunterEngine] Computing coefficients.")
  if (useWeights & smooth) { 
    tmp <- .getEstimate2(mat = mat, design = design,
                         coef = coef, full = TRUE)
    rawBeta <- tmp$coef
    weights <- 1/tmp$sigma
    rm(tmp)
  } else {
    rawBeta <- .getEstimate2(mat = mat, design = design, coef = coef,
                             full = FALSE)
    weights <- NULL
  }
  if (smooth) {
    if (verbose)
      message("[bumphunterEngine] Smoothing coefficients.")
    beta <- smoother(y = rawBeta, x = pos, cluster = cluster,
                     weights = weights, smoothFunction = smoothFunction,
                     verbose = subverbose, ...)
    Index <- which(beta$smoothed)
    beta <- beta$fitted
  } else {
    beta <- rawBeta
    Index <- seq(along = beta)
  }
  if (B > 0) {
    if (nullMethod == "permutation"){
      if (verbose)
        message("[bumphunterEngine] Performing ", B, " permutations.")
      if (useWeights && smooth) {
        tmp <- .getEstimate2(mat, design, coef, B,
            permutations, full = TRUE
        )
        permRawBeta <- tmp$coef
        weights <- tmp$sigma
        rm(tmp)
      }
      else {
        permRawBeta <- .getEstimate2(mat, design, coef, B, 
           permutations, full = FALSE
        )
        weights <- NULL
      }
      NullBeta<-as.matrix(permRawBeta)	
    }
    if (nullMethod == "bootstrap"){
      message("[bumphunterEngine] Performing ", B, " bootstraps.")
      qr.X <- qr(design)
      ##rescale residuals
      h <- diag(tcrossprod(qr.Q( qr(design))))
      ##create the null model to which we add bootstrap resids
      design0 <- design[,-coef,drop=FALSE]
      qr.X0 <- qr(design0)
      boots <- createfn.gds('bs.gds', allow.duplicate = TRUE)
      res <- add.gdsn(node = boots, name='resids', val = NULL, 
         storage = 'float64', valdim = c(p,0)
      )
      null <- add.gdsn(node = boots, name='null', val = NULL, 
         storage = 'float64', valdim = c(p,0)
      )
      apply.gdsn(node = mat, margin = 1, as.is = 'gdsnode', 
         target.node = list(x=res, y=null), 
         FUN = function(x, s1, s2, n1){
            res <- t(s1 %*% x)/s2
                null <- t(n1 %*% x)
                list(x=res, y=null)
         },
         s1 = t(diag(nrow(design)) - tcrossprod(qr.Q(qr.X))),
         s2 = sqrt(1-h), n1 = tcrossprod(qr.Q(qr.X0)) )

      ##Now do the boostraps
      chunksize <- ceiling(B/workers) 
      bootIndexes<-replicate(B, sample(1:p,replace=TRUE),simplify=TRUE)
      
      # Tyler is here :(
      tmp <- lapply(seq_len(ncol(bootIndexes)),
          FUN = function(x, resids, null, s1,s2,s3,s4,s5,coef, useWeights){
            outList <- apply.gdsn(list(x=resids, y=null), margin=c(2,2), as.is='list',
              FUN = function(X, j, s1, s2, s3, s4, s5, useWeights, coef){
                # create null model
                matstar <- X$y + X$x[j]
                # compute estimate
                nullbetas <- backsolve(s1, crossprod(s2, matstar))[coef]
                if(useWeights) {
                  # compute sigma
                  sigma <- sqrt(sum((s4%*%matstar)^2)/s5)
                  outList <- list(coef = nullbetas, sigma = sigma)
                } else {
                  outList <- nullbetas
                }
                return(outList)
              }, j = bootIndexes[,x], 
              s1 = s1, 
              s2 = s2, 
              s3 = s3, 
              s4 = s4,
              s5 = s5, 
              useWeights = useWeights, 
              coef = coef
            )
            if(useWeights) return(list(
               coef = sapply(outList, '[[', 'coef'), 
               sigma = sapply(outList, '[[', 'sigma'))
            )
            else return(unlist(outList))
          }, 
          resids = index.gdsn(boots, 'resids'), 
          null = index.gdsn(boots, 'null'), 
          s1 = qr.R(qr.X), 
          s2 = qr.Q(qr.X), 
          useWeights = useWeights, 
          coef = coef, 
          s3 = tcrossprod(qr.Q(qr.X)), 
          s4 = t(diag(nrow(design))-tcrossprod(qr.Q(qr.X))), 
          s5 =  (nrow(design) - qr.X$rank))
      if (useWeights && smooth) { # Here...
        bootRawBeta <- do.call(Map, c(cbind, tmp))$coef 
        # or sapply(tmp, '[[' ,'coef')
        weights <- do.call(Map, c(cbind, tmp))$sigma
      } else {
        bootRawBeta <- do.call(cbind, tmp)
        weights <- NULL
      }
      NullBeta<-bootRawBeta
      rm(tmp)
      rm(bootRawBeta)
      closefn.gds(boots)
      unlink(boots[[1]])
    }
    
    if (verbose)
      message("[bumphunterEngine] Computing marginal ",nullMethod," p-values.")
      sumGreaterOrEqual <- rowSums(
         bumphunter:::greaterOrEqual(abs(NullBeta),
         abs(as.vector(rawBeta)))
      )
      pvs <- (sumGreaterOrEqual + 1L)/(B + 1L)
     if (smooth) {
       if (verbose)
         message("[bumphunterEngine] Smoothing ",nullMethod," coefficients.")
         permBeta <- smoother(y = NullBeta, x = pos, cluster = cluster,
         weights = weights, smoothFunction = smoothFunction,
         verbose = subverbose, ...)$fitted
    } else permBeta <- NullBeta
    if (is.null(cutoff))
      cutoff <- quantile(abs(permBeta), pickCutoffQ, na.rm = TRUE)
    if (verbose)
      message(sprintf("[bumphunterEngine] cutoff: %s",
      round(cutoff, 3)))
  }
  if (verbose)
    message("[bumphunterEngine] Finding regions.")
  tab <- regionFinder(x = beta, chr = chr, pos = pos, cluster = cluster,
      cutoff = cutoff, ind = Index, verbose = FALSE)
  if (nrow(tab) == 0) {
    if (verbose)
      message("[bumphunterEngine] No bumps found!")
    return(list(table = NA, coef = rawBeta, fitted = beta,
      pvaluesMarginal = NA))
  } else {
    if (verbose)
      message(sprintf("[bumphunterEngine] Found %s bumps.",
         nrow(tab))
      )
  }
  if (B < 1) {
    return(list(table = tab, coef = rawBeta, fitted = beta,
      pvaluesMarginal = NA))
  }
  if (verbose)
    message("[bumphunterEngine] Computing regions for each ",nullMethod,".")
  chunksize <- ceiling(B/workers)
  subMat <- NULL
  nulltabs <- foreach(subMat = iter(permBeta, by = "col", chunksize = chunksize),
    .combine = "c", .packages = "bumphunter") %dorng% {
      apply(subMat, 2, regionFinder, chr = chr, pos = pos,
            cluster = cluster, cutoff = cutoff, ind = Index,
            verbose = FALSE)
    }
  attributes(nulltabs)[["rng"]] <- NULL
  if (verbose)
    message("[bumphunterEngine] Estimating p-values and FWER.")
  L <- V <- A <- as.list(rep(0, B))
  for (i in 1:B) {
    nulltab <- nulltabs[[i]]
    if (nrow(nulltab) > 0) {
      L[[i]] <- nulltab$L
      V[[i]] <- nulltab$value
      A[[i]] <- nulltab$area
    }
  }
  computation.tots <- function(tab, V, L) {
    Lvalue <- cbind(tab$L, abs(tab$value))
    chunksize <- ceiling(nrow(Lvalue)/workers)
    subL <- NULL
    tots <- foreach(subL = iter(Lvalue, by = "row", chunksize = chunksize),
        .combine = "cbind", .packages = "bumphunter") %dorng%
        {
          apply(subL, 1, function(x) {
            res <- sapply(seq(along = V), function(i) {
              sum(bumphunter:::greaterOrEqual(L[[i]], x[1]) &
                    bumphunter:::greaterOrEqual(abs(V[[i]]),
                                                x[2]))
            })
            c(mean(res > 0), sum(res))
          })
        }
    attributes(tots)[["rng"]] <- NULL
    rate1 <- tots[1, ]
    pvalues1 <- tots[2, ]/sum(sapply(nulltabs, nrow))
    return(list(rate1 = rate1, pvalues1 = pvalues1))
  }
  ##    ptime1 <- proc.time()
  comp <- computation.tots(tab = tab, V = V, L = L)
  rate1 <- comp$rate1
  pvalues1 <- comp$pvalues1
  ##    ptime2 <- proc.time()
  computation.tots2 <- function(tab, A) {
    Avalue <- matrix(tab$area, ncol = 1)
    chunksize <- ceiling(nrow(Avalue)/workers)
    subA <- NULL
    tots2 <- t(foreach(subA = iter(Avalue, by = "row", chunksize = chunksize),
           .combine = "cbind", .packages = "bumphunter") %dorng%
           {
             sapply(subA, function(x) {
               return(sapply(seq(along = A), function(i) {
                 sum(bumphunter:::greaterOrEqual(A[[i]], x[1]))
               }))
             })
           })
    if (is.vector(tots2)) {
      tots2 <- matrix(tots2, nrow = 1)
    }
    rate2 <- rowMeans(tots2 > 0)
    pvalues2 <- rowSums(tots2)/sum(sapply(nulltabs, nrow))
    return(list(rate2 = rate2, pvalues2 = pvalues2))
  }
  ##ptime1 <- proc.time()
  comp <- computation.tots2(tab = tab, A = A)
  rate2 <- comp$rate2
  pvalues2 <- comp$pvalues2
  ##ptime2 <- proc.time()
  tab$p.value <- pvalues1
  tab$fwer <- rate1
  tab$p.valueArea <- pvalues2
  tab$fwerArea <- rate2
  tab <- tab[order(tab$fwer, -tab$area), ]
  algorithm <- list(version = packageDescription("bumphunter")$Version,
      coef = coef, cutoff = cutoff, pickCutoff = pickCutoff,
      pickCutoffQ = pickCutoffQ, smooth = smooth, maxGap = maxGap, nullMethod=nullMethod,
      B = B, permutations = permutations, useWeights = useWeights,
      smoothFunction = deparse(substitute(smoothFunction)))
  ret <- list(table = tab, coef = rawBeta, fitted = beta, pvaluesMarginal = pvs,
      null = list(value = V, length = L), algorithm = algorithm)
  class(ret) <- "bumps"
  return(ret)
}

qn.gdsn <- function(gds,
                    target,
                    newnode
                    ){ # {{{
    if(!length(newnode) == 1) stop("newnode does not have a length of 1!")
    datnod <- target
    dim <- objdesp.gdsn(datnod)$dim
    # Initialising rolling sum
    roll <- rep(0, dim[1])
    nobs <- rep(dim[1], dim[2])
    i <- (0:(dim[1]-1))/(dim[1]-1)
    # Sorting and 'growing' rolling sum.
    for(x in 1:dim[2]){
        val <- readex.gdsn(datnod, sel = list(NULL, x))
        S <- rep(NA, dim[1])
        si <- sort(val, method = "quick", index.return = TRUE)
        nobsj <- length(si$x)
        # Used later for NA's
        if(nobsj < dim[1]){
            nobs[x] <- nobsj
            S <- approx((0:(nobsj-1))/(nobsj-1), si$x, i, ties = "ordered")$y
        } else {
            S <- si$x
        }
        roll <- roll + S
    }
    # Calculating 'rowMeans'
    rm <- roll/dim[2]
    # Creating new gdsnode with 'newnode' name
    n.t <- add.gdsn(gds, newnode, storage = "float64",
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    # Reranking + Replacing Values
    for(x in 1:dim[2]){
        val <- readex.gdsn(datnod, sel = list(NULL, x))
        r <- rank(val)
        # If NAs exist - Preserving NAs
        if(nobs[x] < dim[1]) {
            isna <- is.na(val)
            val[!isna] <- approx(i, rm, (r[!isna]-1)/(nobs[x]-1),
                                ties = "ordered")$y
        } else {
            val <- approx(i, rm, (r-1)/(dim[1]-1), ties = "ordered")$y
        }
        # Writing new values to node
        append.gdsn(n.t, val)
    }
} # }}}

.sortvector <- function(vec){
    dim <- length(vec)
    i <- (0:(dim-1))/(dim-1)
    S <- rep(NA, dim)
    si <- sort(vec, method = 'quick', index.return = TRUE)
    nobsj <- length(si$x)
    if(nobsj < dim[1]){
        S <- approx((0:(nobsj-1))/(nobsj-1),
                    si$x, i, ties = 'ordered')$y
    } else {
        S <- si$x
    }
    return(S)
}
# Quite slow, think about breaking it down.
getquantilesandranks <- function(gds, node, onetwo, rank.node = NULL, perc = 1){
    if(!is.null(rank.node)&!is.character(rank.node)) stop('rank.node needs to be a character string is supplied.')
    if(!(perc <= 1 & perc > 0)) stop('perc must be greater than 0 and less than or equal to 1.')
    datnod <- node
    # If node is single element vector - index it.
    if(length(datnod) == 1) datnod <- index.gdsn(gds, as.character(datnod))
    dim <- objdesp.gdsn(datnod)$dim
    if(!length(onetwo) == dim[1]) stop('Length of onetwo and nrow of gdsn node do not match!')
    nc <- rep(TRUE, dim[2])
    if(perc < 1) nc <- which(nc)%in%sample(which(nc), round(length(nc)*perc), replace = FALSE)
    f <- createfn.gds("quickquan.gds", allow.duplicate = TRUE)
    quants <- rep(NA, dim[1])
    # Split + Sort Array by probe type
    nodeI <- add.gdsn(node = f, name = 'nodeI', storage = 'float64',
                      valdim = c( sum(onetwo=='I'), 0), val = NULL, replace = TRUE)
    nodeII <- add.gdsn(node = f, name = 'nodeII', storage = 'float64',
                        valdim = c(sum(onetwo == 'II'), 0), val = NULL, replace = TRUE)
    apply.gdsn(node = datnod,
                target.node = nodeI,
                as.is = 'gdsnode',
                margin = 2,
                selection = list(onetwo == 'I', nc),
                var.index = 'relative',
                FUN = function(index, x){ .sortvector(x) } )

    # This can be parallelized!
    quants[onetwo == 'I'] <- apply.gdsn(node = nodeI,
                                        as.is = 'double',
                                        var.index = 'none',
                                        margin = 1,
                                        FUN = mean)
    apply.gdsn(node = datnod,
                target.node = nodeII,
                as.is = 'gdsnode',
                margin = 2,
                selection = list(onetwo == 'II', nc),
                var.index = 'relative',
                FUN = function(index, x){ .sortvector(x) } )

    # This can be parallelized!!!
    quants[onetwo == 'II'] <- apply.gdsn(node = nodeII,
                                        as.is = 'double',
                                        var.index = 'none',
                                        margin = 1,
                                        FUN = mean)
    if(!is.null(rank.node)){
        rn <- add.gdsn(node = gds, name = rank.node, storage = 'float64',
                        valdim = c(length(onetwo), 0), val = NULL,
                        replace = TRUE)
        rnna <- add.gdsn(node = gds, name = paste0('isna', rank.node),
                        storage = 'int8', valdim = c(length(onetwo), 0),
                        val = NULL, replace = TRUE, visible = FALSE)
        apply.gdsn(node = datnod,
                    target.node = list(rn, rnna),
                    as.is = 'gdsnode',
                    margin = 2,
                    var.index = 'none',
                    FUN = function(x, onetwo){
                        ranks <- rep(NA, length(x))
                        ranks[onetwo=='I'] <- rank(x[onetwo=='I'])
                        ranks[onetwo=='II']<- rank(x[onetwo=='II'])
                        out <- list(ranks, as.numeric(is.na(x)))
                        return(out)
                    }, onetwo = onetwo
                    )
    }
    inter <- rep(0, dim[1])
    inter[onetwo == 'I'] <- (0:(sum(onetwo=='I')-1))/(sum(onetwo=='I')-1)
    inter[onetwo == 'II']<- (0:(sum(onetwo=='II')-1))/(sum(onetwo=='II')-1)
    if(!is.null(rank.node)){
        put.attr.gdsn(rn, 'ranked', val = TRUE)
        put.attr.gdsn(rn, 'is.na', val = paste0('isna', rank.node))
        put.attr.gdsn(rn, 'inter', val = inter)
        put.attr.gdsn(rn, 'quantiles', val = quants)
        put.attr.gdsn(rn, 'onetwo', val = onetwo)
    return(0)
    }

    closefn.gds(f)
    unlink('quickquan.gds', force = TRUE)
    output <- list(quantiles = quants, inter = inter, onetwo = onetwo)
    return(output)
}

dasenrank <- function(gds, mns, uns, onetwo, roco, calcbeta = NULL, perc = 1){# {{{
    # Assuming that mns and uns are 1 element strings, not gdsn.class
    if(length(mns) == 1) mns <- index.gdsn(gds, mns)
    if(length(uns) == 1) uns <- index.gdsn(gds, uns)
    if(length(onetwo) == 1)  onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    f <- createfn.gds('temp.gds', allow.duplicate = TRUE)
    dim <- objdesp.gdsn(mns)$dim
    # NORMALIZING
    dfsfit.gdsn(f, targetnode = mns, roco = roco, newnode = "mnsc",
                onetwo = onetwo)
    dfsfit.gdsn(f, targetnode = uns, roco = NULL, newnode = "unsc",
                onetwo = onetwo)
    # Get Rank + Quantiles
    getquantilesandranks(gds, index.gdsn(f, 'mnsc'), onetwo = onetwo,
                rank.node = 'mnsrank', perc = perc)
    getquantilesandranks(gds, index.gdsn(f, 'unsc'), onetwo = onetwo,
                rank.node = 'unsrank', perc = perc)
    # COMPLETE Return nothing
    if(is.null(calcbeta)){
        message('Run \'computebeta.gds(gds, calcbeta, \'mnsrank\', \'unsrank\', fudge = 100)\' to calculate betas!')
    } else {
        message('Calculating Betas...')
        computebeta.gds(gds, calcbeta, 'mnsrank', 'unsrank', fudge = 100)
    }
    closefn.gds(f)
    unlink('temp.gds', force = TRUE)
} # }}}

computebeta.gds <- function(gds, new.node, mns, uns, fudge = 100){ # {{{
    if(length(mns) == 1) mns <- index.gdsn(gds, mns)
    if(length(uns) == 1) uns <- index.gdsn(gds, uns)
    dim <- objdesp.gdsn(mns)$dim
    n.t <- add.gdsn(gds, new.node, storage = 'float64',
                valdim=c(dim[1],0), val = NULL, replace = TRUE)
    message('Calculating Betas')
    for(x in 1:dim[2]){
        # This may be slow, depending on the number of samples - but memory efficient.
        meth <- mns[, x, name = FALSE]
        unmeth <- uns[, x, name = FALSE]
        beta <- meth/(meth + unmeth + fudge)
        append.gdsn(n.t, beta)
    }
    message('Done!')
} # }}}

# {{{ plan LS 2023

# if the gds representation is to fulfil the ambition of acting like a MethyLumiSet (or methylset)  object, methods should
# provide the same illusion that the data is a matrix.   Currently there isn't a dim() method for gds or gdsn classes.  there
# is a `[` method for gdsn, which is the main engine for extracting data.  The `[` method for gds just hands off to gdsn 
# (ie it provides the convenience of not having to extract eg the betas before subseting but still just subsets a node).

# for usability a key point will be the distinction between extracting data and irreversibly changing the file representation.  
# users will intuitively be reluctant to make irreversible changes, but this has to be balanced by the limited number of copies 
# of large data sets that it's practical to keep.  

# The workflow model should probably be that in the dataset assembly/qc phase you work with a read/write handle to he gds file 
# and do irreversible filtering and combining ops, and in the analysis phase you work with a readonly handle.  This would argue
# for methods whose behaviour depends on the handle, (and should have clear feedback, possibly asking for confirmation for 
# irreversible ops).

# additional possibilities:  functions could check if their return is being assigned and if so return a handle to a new gds file 
# and/or create a new file if a path is given (ie default path=NULL)

# one concept that we have discussed, but I don't think we have implemented, is infrastructure facilitating filters.  An extended gds 
# object could have one or more vectors representing desired subsets of rows and columns for particular purposes

# }}}

#{{{ chainsaw
#' Chainsaw -- modify gds file by subsetting all nodes
#'
#' Currently the `[` function for the gds.class objects used by bigmelon only subsets a 
#' single node. This function does more like what you would normally expect a subsetting function 
#' to do, it returns a subset of the entire object.  It may in future be a replacement for `[.gds.class`.
#'
#' This function is intended for use in the preprocessing and QC phase of a DNA methylation workflow.
#' For efficiency, bigmelon stores data in a file, and the gds.class object is a file handle. 
#' True to its name, chainsaw chops the underlying file, this is a side affect of the function and 
#' is not affected by assignment of the return value.
#'
#' @param gfile A gds.class object.
#' @param i Specifies rows (ie probes) in the desired subset, similar to behaviour of `[`
#' @param j Specifies columns (ie sampless) in the desired subset, similar to behaviour of `[`
#' @param v If true, spew many messages.
#' @param cleanup If true, run a cleanup function that can substantially reduce the file size.

#' @return  a gds.class object.  This is a handle to the same file that the gfile argument 
#' points to.  It's not generally useful to have two handles to the same file, but it may make code 
#' more readable.  In interactive use, if not assigned, the returned object is usefully pretty-printed.

chainsaw <- function( gfile, i='', j='', v=FALSE, cleanup=TRUE ){

   history.submitted <- as.character(Sys.time())

   # is this a gds file handle?
   stopifnot(inherits(gfile, "gds.class"))
   # is the file where it's supposed to be?
   stopifnot(file.exists(gfile$file))
   # is it open RW?
   stopifnot(!gfile$readonly)



   # any useful gds file in a bigmelon workflow will have a methylated and/or betas node 
   # take the dims from that and subset all similarly dimmed nodes accordingly using `[.gdsn.class`
   # <<<< note the different approach in the S4 row and column names functions >>>>
   # paths node points to "fData/Probe_ID" "pData/barcode" as row and colnames.


   #### TOUTDOUX ###############

   # handle i == ''  check
   # handle j == ''  check
   # handle fData    check
   # handle pData    check
   # use names       check
   # add history     check

   # there is a choice here of either going through the expected nodes by name (a),
   # or walking the tree and handling each node depending on what it is (b). 
   # b is attractive because this is not a fully sealed object, and users might reasonably
   # add nodes for transformed or normalised versions of the data. 

   # current vers is a compromise that subsets top level matrices -- 
   # and deals with fData, pData and history explicitly
   # nodes with 0 columns, 0 rows or names starting with 'tmp' are skipped.
   # (there are sometimes tmp_* nodes introduced by gdsfmt, haven't found details)
   
   dimes <- sapply(ls.gdsn(gfile), function(x) dim(index.gdsn(gfile,x)))
   if (v) message(length(dimes), " nodes")
   mates <- sapply(dimes,length) ==2
   if (v) message(sum(mates), " matrices")
   d <- dimes$methylated
   if (is.null(d)) d <- dimes$betas
   if (is.null(d)) stop ('no methylated or betas node\n')
   
   if (length(i) ==1 && i=='') i <- 1:d[1]
   if (length(j) ==1 && j=='') j <- 1:d[2]

   # char rownames
   if (is.character(i)){
     i <- match( i, rownames(gfile))
     if(!any(!is.na(i))) stop("no rownames match, giving up")
     if(any(is.na(i))) message("note some rownames don't match, filling with NAs")
  }   
   
   # char coalnames
   if (is.character(j)){
     j <- match( j, colnames(gfile))
     if(!any(!is.na(j))) stop("no samplenames match, giving up")
     if(any(is.na(j))) message("note some samplenames don't match, filling with NAs")
  }   

   vict <- dimes[mates] # 
   for (nod in names(vict)) {

      if( any(vict[[nod]] ==0) || grepl('^tmp', nod) ) next
      eye <- 1:vict[[nod]][1]
      jay <- 1:vict[[nod]][2]
      if (vict[[nod]][1] == d[1]  ) {
         eye <-i
         if (v) message('subsetting rows of ', nod)
      }
      if (vict[[nod]][2] == d[2]  ) {
         jay <-j
         if (v) message('subsetting columns of ', nod)
      }
   assign.gdsn(index.gdsn(gfile,nod), seldim=list(eye, jay))
   }  
   
   #### handle fData here, subset i
   for (col in ls.gdsn(index.gdsn(gfile,'fData/'))){
      nod <- index.gdsn(gfile,paste0('fData/',col))
      if (dim(nod) == d[1]){
         if (v) message('subsetting fData ', col)
         assign.gdsn(nod, seldim=list(i))
      }
   }
   
   #### handle pData here, subset j
   for (row in ls.gdsn(index.gdsn(gfile,'pData/'))){
      nod <- index.gdsn(gfile,paste0('pData/',row))
      if (dim(nod) == d[2]){
         if (v) message('subsetting pData ',row)
         assign.gdsn(nod, seldim=list(j))
      }
   }
   
   #### handle history here, add new dim
   history.finished <- as.character(Sys.time())
   history.command <- as.character(paste( 'subset ', length(i), ' probes and ', length(j),' samples.' ))
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE)
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/", j, sep = "")
            h_child_n <- index.gdsn(gfile, h_index_str, silent = TRUE)
            append.gdsn(h_child_n, val = h[ ,h_coln])
        }

   message( gfile$filename , " has been modified ")
   #### return gfile (will print new structure)
   if(cleanup) cleanup.gds(gfile$filename)
   gfile
}

#}}}

#{{{ dim.gds.class
#' dim.gds.class  S3 method returning dimensions of data represented by a gds file handle.

dim.gds.class <- function (gfile, v=FALSE){
   # note v=TRUE works only if called directly, generic dim doesn't allow 2 arrghs
   # is this a gds file handle
   # is the file where it's supposed to be

   # any useful gds file in a bigmelon workflow will have a methylated and/or betas node 
   dimes <- sapply(ls.gdsn(gfile), function(x) dim(index.gdsn(gfile,x)))
   if (v) message(length(dimes), " nodes")
   mates <- sapply(dimes,length) ==2
   if (v) message(sum(mates), " matrices")
   d <- dimes$methylated
   if (is.null(d)) d <- dimes$betas
   if (is.null(d)) stop ('no methylated or betas node\n')
   if (v) {
      message (d[1], ' probes, ', d[2], ' samples')
      invisible(d)
   }
   
   d

     
}   

#}}}

#{{{ dim.gdsn.class
# dim.gdsn.class S3 method returning dimensions of gds nodes if a matrix

dim.gdsn.class <- function (obj){

   # is obj a gds node
   stopifnot(inherits(obj, "gdsn.class"))
   # is the node a matrix (don't need to test, returns "", NULL, or length

   objdesp.gdsn(obj)$dim

}

#}}}

dfsfit.gdsn <- function(gds,
                        targetnode,
                        newnode,
                        roco,
                        onetwo
                        ){ # {{{
    # Converting supplied 'nodes' into environment
    if(length(onetwo) == 1) onetwo <- read.gdsn(index.gdsn(gds, onetwo))
    if(class(onetwo) == 'gdsn.class') onetwo <- read.gdsn(onetwo)
    if(length(roco) == 1) roco <- read.gdsn(index.gdsn(gds, roco))
    if(class(roco) == 'gdsn.class')   roco <- read.gdsn(roco)
    datnod <- targetnode
    dim <- objdesp.gdsn(datnod)$dim
    # Replicating: dfs2.R 'apply(mn, 2, dfs2, onetwo)'
    mdf <- apply.gdsn(datnod, margin = 2, FUN = function(val, onetwo){
        one <- density(val[onetwo == 'I'], na.rm = TRUE, n = 2^15,
                        from = 0, to = 5000)
        two <- density(val[onetwo == 'II'], na.rm = TRUE, n = 2^15,
                        from = 0, to = 5000)
        one$x[which.max(one$y)] - two$x[which.max(two$y)] 
        }, as.is = "double", onetwo = onetwo)
    # Replicating: dfsfit.R 
    if(!is.null(roco)){
        scol <- as.numeric(substr(roco,6,6))
        srow <- as.numeric(substr(roco,3,3))
        fit  <- try(  lm(mdf ~ srow + scol ), silent=TRUE) 
        if(!inherits(fit, "try-error")){ 
            mdf <- fit$fitted.values
        } else { 
            message ('Sentrix position model failed, skipping') 
        }
    }
    # Creating newnode:
    n.t <- add.gdsn(gds, newnode, storage = "float64", 
                    valdim = c(dim[1],0), val = NULL, replace=TRUE) 
    for(x in 1:dim[2]){
        val <- readex.gdsn(datnod, sel = list(NULL, x)) 
        val[onetwo=='I'] <- val[onetwo=='I'] - rep(mdf[x], sum(onetwo=='I'))
        # Commit to New Node.
        append.gdsn(n.t, val)
    }
} # }}}

# newgds -- generate a gdsfile stub {{{
newgds <- function(file){
    message('creating gdsfile...' )
    bmln <- createfn.gds(file)
    n <- add.gdsn(bmln, name = "description")
    put.attr.gdsn(n, "FileFormat", "DNA_Methylation")
    bmln
} # AS - OK }}}

# findgdsobj -- function to check if file is already linked to by an existing gds object {{{
# in the current workspace (global env)
findgdsobj <- function(gds){
    fhandle <- gds
    for(obj in ls(envir = .GlobalEnv)){
        if(inherits(get(obj), 'gds.class') &&
            get(obj)$filename == normalizePath(gds)){
            temp <- deparse(obj)
            temp <- gsub("[[:blank:]\"]", "", temp)
            warning(paste(get(obj)$filename,
                    "is already open, appending to the linked gds object"))
            return(fhandle <- get(obj))
        }
    }
    fhandle
} # AS - OK }}}

# handle -- take a gds.class object, the name of a gds.class object or a gds filename {{{
# and return a writable gds.class object
handle <- function(gds){
    newfile <- as.logical(0)
    # gds can be a filepath or gds.class object or an object name
    # gds.class object given -> use as handle
    if(inherits(gds, 'gds.class' ) && file_test('-f', gds$filename)){
        handle <- gds
    } else if(inherits(gds, 'character')){ # Filepath given
        #file saved in global env
        if(exists(gds) && inherits(g <- get(gds), 'gds.class')){
            g <- get(gds)
            handle <- openfn.gds(g$filename, readonly=FALSE, allow.duplicate=TRUE, allow.fork=TRUE)
        } else if(file_test('-f', gds)){ # On Disk
            #file exists, try to open
            # if this fails, check if it is already linked by a gds object
            handle <- tryCatch({
                openfn.gds(gds, readonly=FALSE, allow.duplicate=TRUE, allow.fork=TRUE)
                }, error = function(e){
                    return(findgdsobj(gds))
                }, finally = {
                })
        } else if(!(file_test('-f', gds))){ # Need to create file
            #handle <- newgds(gds)
            handle <- gds
            newfile <- as.logical(1)
        }
    #gds is not a valid gds.class object or filepath
    } else {
        stop(paste(substitute(gds),
            "is not a valid gds.class object or filepath"))
    }
    list(handle,newfile)
} #}}}

# app2gds -- append one or more arrays of data to gdsfile {{{
# Not functioning for minfi objects!
app2gds <- function(m, bmln){
    history.submitted <- as.character(Sys.time())
    # check that m is a methylumi set
    if(!(inherits(m, 'MethyLumiSet'))){
        stop(paste(deparse(substitute(m)), "is not a MethyLumiSet object"))
    }

    # call handle to deal with file checks
    rehandle <- handle(bmln)
    bmln <- rehandle[[1]]
    newfile <- rehandle[[2]]
    if(!(newfile)){
        if(! length(rownames(bmln)) == dim(m)[1]){
            stop(paste(deparse(substitute(m)), "has a different length to bmln"))
        }
        # More rigid checks of rownames need to be down prior to importing
        message(paste('appending to', bmln$filename))
        if(exists("betas", assayData(m))){
            message('betas... ' )
            append.gdsn(index.gdsn(bmln, "betas"), val = betas(m))
        }
        if(exists("pvals", assayData(m))){
            message('pvals... ' )
            append.gdsn(index.gdsn(bmln, "pvals"), val = pvals(m))
        }
        if(exists("methylated", assayData(m))){
            message('methylated... ' )
            append.gdsn(index.gdsn(bmln, "methylated"), val = methylated(m))
        }
        if(exists("unmethylated", assayData(m))){
            message('unmethylated... ' )
            append.gdsn(index.gdsn(bmln, "unmethylated"),
                        val = unmethylated(m))
        }
        if(exists("NBeads", assayData(m))){
            message('NBeads... ' )
            append.gdsn(index.gdsn(bmln, "NBeads"),
                        val = assayDataElement(m, "NBeads"))
        }
        # fData should be the same for the appended data, no need to add
        message('fData... ' )
        # deal with blank col names in fData
        nb_col <- which(colnames(fData(m)) == "")
        colnames(fData(m))[nb_col] <- nb_col
        message('pData... ' )
        mpdat <- data.frame(lapply(pData(m), as.character),
                            stringsAsFactors = FALSE)
        for(i in colnames(mpdat)){
            # iterate through colnames in m
            pData_coln <- i
            # select corresponding child node of pData in the gds file
            pData_index_str <- paste("pData/", i, sep = "")
            pData_child_n <- index.gdsn(bmln, pData_index_str, silent = TRUE)
            # append
            append.gdsn(pData_child_n, val = mpdat[ , pData_coln])
        }
        if(!is.null(m@QC)){ # If QC is null, not appended.
            message('qcdata... ' )
            if(class(index.gdsn(bmln,
                                'QCmethylated', silent = TRUE)) != 'NULL'){
                append.gdsn(index.gdsn(bmln, "QCmethylated"),
                            val = methylated(QCdata(m)))
            }
            if(class(index.gdsn(bmln,
                                'QCunmethylated', silent = TRUE)) != 'NULL'){
                append.gdsn(index.gdsn(bmln, "QCunmethylated"),
                            val = unmethylated(QCdata(m)))
            }
        }
        # add append operation to history
        numsamp <- nrow(pData(m))
        history.finished <- as.character(Sys.time())
        history.command <- as.character(paste(numsamp,
                                            "arrays appended (bigmelon)"))
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE)
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/", j, sep = "")
            h_child_n <- index.gdsn(bmln, h_index_str, silent = TRUE)
            append.gdsn(h_child_n, val = h[ ,h_coln])
        }
        # include history from arrays that have been added
        mhist <- data.frame(lapply(m@history, as.character),
                            stringsAsFactors = FALSE)
    for (k in colnames(mhist)){
        hist_coln <- k
        hist_index_str <- paste("history/",k,sep="")
        hist_child_n <- index.gdsn(bmln,hist_index_str,silent=TRUE)
            append.gdsn(hist_child_n, val=mhist[,hist_coln])
    }
    } else {
    # call es2gds to create new file
    bmln <- es2gds(m,bmln)
    }
    # Close and open in write mode?
    closefn.gds(bmln)
    bmln <- openfn.gds(bmln[[1]], readonly=FALSE, allow.duplicate=TRUE, allow.fork=TRUE)

    return(bmln)
} #}}}

# iadd2 -- add data from all idat files that are stored within a single directory to a gds file {{{
iadd2 <- function(path, gds, chunksize = NULL, force=TRUE,...){
    rown <- TRUE
    if(force){
        thefile <- try(openfn.gds(gds, allow.duplicate=TRUE), silent=T)
        if(!inherits(thefile, 'try-error')){
            # TODO this needs fixing see iadd function
            rown <- read.gdsn(index.gdsn(thefile, 'fData/Probe_ID'))
            closefn.gds(thefile)
        }
    }
    gdsfile <- gds
    barcodes <- bfp(path)
    if(is.null(chunksize) & length(barcodes) > 500){
    chunksize <- 500
    message('More than 500 barcodes identified. Switching to batch mode!')
    }
    if(!is.null(chunksize)){
        if(!is.numeric(chunksize)) stop("chunksize must be numeric!")
        chunks <- seq(1, length(barcodes), chunksize)
        for(i in chunks){
            sets <- barcodes[i:(i+(chunksize-1))]
            # TODO this needs fixing see iadd function
            ml <- methylumIDATepic(barcodes = sets[!is.na(sets)],
                                    n = TRUE, oob = FALSE, idatPath = path, force=force)[rown,]
            gdsfile <- app2gds(ml, gdsfile)
        }
    } else {
        ml <- methylumIDATepic(barcodes, n = TRUE,
                                oob = FALSE, idatPath = path, force=force)[rown,]
        gdsfile <- app2gds(ml, gdsfile)
    }
    gdsfile
} #}}}

# iadd -- add data from multiple, specified, idat files providing to a specified gds file. {{{
iadd <- function (bar, gds, n = TRUE, force=TRUE, target_cpgs = NULL, idatpath=NULL, ...){
    rown <- TRUE
    if(is.null(target_cpgs)){
      #  if(force){
            thefile <- try(openfn.gds(gds, allow.duplicate=TRUE), silent=T)
            if(!inherits(thefile, 'try-error')){
                rown <- read.gdsn(index.gdsn(thefile, 'fData/Probe_ID'))
                closefn.gds(thefile)
       #     }
        }
    } else {
        rown <- target_cpgs
    }
    ifile <- basename(bar)
    if(is.null(idatpath)) idatpath <- dirname(bar[1])

    ### this assumes only 2 underscores, fails when names have _ in prefix, eg from GEO
    ### need to count from end instead or just chop off [Red|Grn].idat
    #pieces <- strsplit(ifile, "[_.]")
    #slide <- sapply(pieces, '[', 1)
    #pos <- sapply(pieces, '[', 2)
    #bar <- paste(slide, pos, sep = "_")
    
    bar <- sub('_Red.idat','', sub('_Grn.idat','',ifile))
    mlu <- methylumIDATepic(barcodes = bar, n=n, force=force, idatpath=idatpath, ...)
    mlu <- mlu[rown,] 
 #   if(force){
        # TODO ensure that rows get forced to match original gds rownames
        # This is too unstable...
    #    recon <- names(assayData(mlu))
     #   results <- list()
      #  for(tabl in recon){
        #     christly christ
        #     results[[tabl]] <- t(t(assayDataElement(mlu, tabl)[,1][rown]))
     #        results[[tabl]] <- assayDataElement(mlu, tabl)[rown,]
  #      }
  #      assayData(mlu) <- results
   #     fData(mlu) <- fData(mlu)[rown,]
    #}
    output <- app2gds(mlu, gds)
    return(output)
}

finalreport2gds <- function(finalreport, gds, ...){
    mset <- methylumiR(finalreport, ...)
    bmln <- es2gds(mset, gds)
    return(bmln)
} #}}}

# idats2gds -- idats2gds will add data from a set of barcodes into the same gds {{{
idats2gds <- function(barcodes, gds, n=TRUE, force=FALSE, ...){

    if(force){
        # Get a list of Greens.
        grns <- sprintf('%s_Grn.idat', barcodes)
        message('Determining IDAT lengths and ChipType')
        idx <- lapply(grns,function(x){
            f <- illuminaio::readIDAT(x)
            r <- rownames(f$Quants)
            return(list(chip=f$ChipType, rn=r))
        })
        chiptype <- unique(sapply(idx, '[[', 'chip'))
        if(length(chiptype) > 1) stop('idats2gds cannot process arrays from two separate platforms')
        manifest <- switch(chiptype,
            'BeadChip 8x5' = 'IlluminaHumanMethylationEPIC',
            'BeadChip 12x8' = 'IlluminaHumanMethylation450k',
            'BeadChip 12x1' = 'IlluminaHumanMethylation27k',
        )
        if (ChipType == "BeadChip 8x5" && length(idx$rn) > 1.1e+06) {
            manifest = "IlluminaHumanMethylationEpicv2"
        }
        manifest <- minfi::getManifest(manifest)
        cpgs_a <- cpgs_b <- c(getProbeInfo(manifest, type = "I")$Name, getProbeInfo(manifest, type = "II")$Name)
        names(cpgs_a) <- c(getProbeInfo(manifest, type = "I")$AddressA, getProbeInfo(manifest, type = "II")$AddressA)
        names(cpgs_b) <- c(getProbeInfo(manifest, type = "I")$AddressB, getProbeInfo(manifest, type = "II")$AddressB)
        message('Determining CpG intersection')
        tot_cpgs <- lapply(idx, function(y, cpgs_a, cpgs_b){
            unique(na.omit(c(cpgs_a[y[[2]]], cpgs_b[y[[2]]])))
        }, cpgs_a=cpgs_a, cpgs_b=cpgs_b)

        target_cpgs <- sort(Reduce(intersect, tot_cpgs))
        names(target_cpgs) <- target_cpgs
        message(sprintf('Expected Number of CpGs: %s (Number may be lower!)', length(target_cpgs)))
    }

    for(bar in barcodes){
        message(sprintf('Processing: %s...', bar))
        output <- iadd(bar, gds = gds, n = n, force = force, target_cpgs = target_cpgs, ...)
    }

    return(output)
} # }}}

# tea.gds  -  (stub) tell all about a gds object {{{

#' tea.gds - description and validation for gds objects
#' 
#' @description
#' Checks the validity, file location and read/write status of a gds object
#'
#' @details
#' For DNAm use
#' with the bigmelon package.  For interactive use the default verbose 
#' option also prints
#' further details. Returns a list.

#tea.gds <- function (gds){
# trying to be more helpful than just 'not a gds obj'
#if(
# error - this is a filepath, open it first with openfn.gdsn
# error - this is a node, give me the gds object it comes from
# error - this is some other non-gds object
# error - this is a gds handle but it is closed

# info - filepath
# info - file permissions on disk
# info - opened readonly?
# info - dimensions
# info - has raw intensities M
# info - has raw intensities U
# info - has betas
# info - pData
# info - has design type, colname:
# info - has Chr, colname


#}



#}}}

#{{{ bigpepo -- derived from iadd2: add data from all idat files that are 
# in a single directory to a gds file with explicit manifest specification

bigpepo <- function(path, gds, manifest, chunksize = NULL, force=TRUE,...){
    rown <- TRUE # recycles, this is for the default case where row 
                 #names aren't matched
    if(force){
        thefile <- try(openfn.gds(gds, allow.duplicate=TRUE), silent=T)
        if(!inherits(thefile, 'try-error')){
            # TODO this needs fixing see iadd function
            rown <- read.gdsn(index.gdsn(thefile, 'fData/Probe_ID'))
            closefn.gds(thefile)
        }
    }
    gdsfile <- gds
    barcodes <- bfp(path)
    if(is.null(chunksize) & length(barcodes) > 500){
    chunksize <- 500
    message('More than 500 barcodes identified. Switching to chunk mode!')
    }
    if(!is.null(chunksize)){
       if(!is.numeric(chunksize)) stop("chunksize must be numeric!")
          chunks <- seq(1, length(barcodes), chunksize)
          for(i in chunks){
             sets <- barcodes[i:(i+(chunksize-1))]
             # TODO this needs fixing see iadd function
             ml <- readPepo(barcodes = sets[!is.na(sets)], manifest=manifest,
                n = TRUE, oob = FALSE, idatdir = path, )[rown,]
            gdsfile <- app2gds(ml, gdsfile)
        }
    } else {
        ml <-  readPepo(barcodelist=barcodes, manifest=manifest,
           n = TRUE, oob = FALSE, idatdir = path)[rown,]
        gdsfile <- app2gds(ml, gdsfile)
    }
    gdsfile
} #}}}

#TODO - unit tests for non-numeric accessors, & all normalisation methods

# unit test stubs, the  idea is that whenever we work on a function
# we create a unit test. any function for strictly internal use should be moved
# to test_internal.R

# TODO: dasenGds.R dbGdsn.R dfsfitGdsn.R
#       ecc.gdsn.R es2gds.R gds2mlumi.R gdsnclass_methods.R
#       GEOtoGDS.R inout.R pfilterGds.R prcompGdsn.R pwodGdsn.R
#       qnGdsn.R ranknorm.R zzz.R
#dbgdsn.R
#dfsfitGdsn.R
#ecc.gdsn.R

# es2gds.R
test_es2gds      <- function(m, file, qc = TRUE){
	data(cantaloupe)
	#t1 - basic tests to ensure function creates object and linked file
	d <- es2gds(cantaloupe,'t0.gds')
	checkTrue(file_test('-f', d$filename))
	checkTrue(inherits(d,'gds.class'))

	#e1 - error condition 1 - use existing filename
	checkException(e <- es2gds(cantaloupe,'t0.gds'))

	#e2 - error condition 2 - use non methylumi set object
	checkException(e <- es2gds(pData(cantaloupe),'t1.gds'))

	closefn.gds(d)
    unlink('t0.gds')
}

# inout.R
test_app2gds 	 <- function(m, bmln){
	data(cantaloupe)

	f <- es2gds(cantaloupe,'t2.gds')
	numsamp <- length(colnames(f))

	#t1 - append to an existing gds.class object
	f <- app2gds(cantaloupe,f)
	checkTrue(length(colnames(f)) == numsamp * 2)

	#close all opened GDS files (for test 3)
	#rv <- showfile.gds()
	#nm <- NULL; rd <- NULL
	#for (i in 1:length(rv)){
	#  names(rv[[i]]) <- c("filename", "id", "root", "readonly")
	#  class(rv[[i]]$root) <- "gdsn.class"
	#  class(rv[[i]]) <- "gds.class"
	#  nm <- c(nm, rv[[i]]$filename)
	#  rd <- c(rd, rv[[i]]$readonly)
	#}
	#for (i in 1:length(rv)){
	#  closefn.gds(rv[[i]])
	#}
	#rm(rv,nm,f)

	#t2 - append to existing file (already linked to by another gds object)
	#test doesn't work: I'm not able to recreate this scenario in test (works for user
	#though)
	#e <- es2gds(cantaloupe,'t1.gds')
	#g <- app2gds(cantaloupe,'t1.gds')
	#checkTrue(file_test('-f', g$filename))
	#checkTrue(inherits(g,'gds.class'))
	#checkTrue(length(colnames(g)) == numsamp * 2)

	#t3 - append to existing file not already linked
	#test doesn't work: I'm not able to recreate this scenario, due to the
	#close.fn function not cleaning up properly, which makes the file look as if it's
	#still open (this wont be the case for the user)
	#h <- app2gds(cantaloupe,'t2.gds')
	#checkTrue(file_test('-f', h$filename))
	#checkTrue(inherits(h,'gds.class'))
	#checkTrue(length(colnames(h)) == numsamp * 3)

	#t4 - append to new file
	i <- app2gds(cantaloupe,'t3.gds')
	checkTrue(file_test('-f', i$filename))
	checkTrue(inherits(i,'gds.class'))
	checkTrue(length(colnames(i)) == numsamp)

	#e1 - error condition 1 - try to use non gds.class object
	checkException(j <- app2gds(cantaloupe,cantaloupe))

	unlink("t1.gds", force=TRUE)
	unlink("t2.gds", force=TRUE)
	unlink("t3.gds", force=TRUE)

}

#test_iadd  <- function( bar, ipath=NULL, gds ){
  # Will test mset and minfi methods and will test fot!
#  if(require('minfiData')){
#    bd <- system.file('extdata', package='minfiData')
#    setwd(file.path(bd, '5723646052'))
#    gfile <- iadd2('./', gds = 'mi.gds')
#    gfile <- iadd(bfp('./')[1], gds = 'mi.gds')
#    rg <- read.metharray(bfp('./'))
#    gf <- eset2gds(rg, 'mi2.gds')
# 
#    checkTrue(length(fot(gfile)) > 1)
#    checkTrue(length(fot(gf)) > 1)
#    closefn.gds(gf)
#    closefn.gds(gfile)
#    unlink('mi2.gds')
#    unlink('mi.gds')
	#commented out as need to have idat files to test
	#m <- methylumIDAT("barcode1")
	#n <- es2gds(m,"midat.gds")
	#o <- iadd("barcode2",n)
	#unlink("midat.gds", force=TRUE)
#   }
#}

test_beta        <- function(object            ){
	data(cantaloupe)
	tempB <- head((betas(cantaloupe)))
	rownames(tempB) <- NULL
	colnames(tempB) <- NULL
	j <- es2gds(cantaloupe,'t4.gds')
	checkEqualsNumeric(head(betas(j)),tempB)
}
test_methylated  <- function(object            ){
	data(cantaloupe)
	tempB <- head((methylated(cantaloupe)))
	rownames(tempB) <- NULL
	colnames(tempB) <- NULL
	k <- es2gds(cantaloupe,'t5.gds')
	checkEqualsNumeric(head(methylated(k)),tempB)
}
test_unmethylated<- function(object            ){
	data(cantaloupe)
	tempB <- head((unmethylated(cantaloupe)))
	rownames(tempB) <- NULL
	colnames(tempB) <- NULL
	l <- es2gds(cantaloupe,'t6.gds')
	checkEqualsNumeric(head(unmethylated(l)),tempB)
}
test_pvals       <- function(object            ){
	data(cantaloupe)
	tempB <- head((pvals(cantaloupe)))
	rownames(tempB) <- NULL
	colnames(tempB) <- NULL
	m <- es2gds(cantaloupe,'t7.gds')
	checkEqualsNumeric(head(pvals(m)),tempB)
}
#test_fData       <- function(object            ){}
#test_pData       <- function(object            ){}
test_QCmethylated<- function(object            ){
	data(cantaloupe)
	tempB <- head(methylated(QCdata(cantaloupe)))
	rownames(tempB) <- NULL
	colnames(tempB) <- NULL
	n <- es2gds(cantaloupe,'t8.gds')
	checkEqualsNumeric(head(QCmethylated(n)),tempB)
}
test_QCunmethylated<- function(object            ){
	data(cantaloupe)
	tempB <- head(unmethylated(QCdata(cantaloupe)))
	rownames(tempB) <- NULL
	colnames(tempB) <- NULL
	o <- es2gds(cantaloupe,'t9.gds')
	checkEqualsNumeric(head(QCunmethylated(o)),tempB)
}
#test_QCrownames  <- function(object            ){}
#test_getHistory    <- function(object            ){}
#test_colnames1   <- function(x, do.NULL=TRUE, prefix=NULL){}
#test_rownames1   <- function(x, do.NULL=TRUE, prefix=NULL){}
#test_exprs		 <- function(object            ){}
#
#test_betaqn      <- function(bn                ){}
#test_naten       <- function(mn, fudge=100     ){}
#test_nanet       <- function(mn, fudge=100     ){}
#test_zot         <- function(x                 ){}
#test_nanes       <- function(mns, fudge=100    ){}
#test_danes       <- function(mn, fudge=100, ...){}
#test_danet       <- function(mn, fudge=100, ...){}
#test_daten1      <- function(mn, fudge=100, ...){}
#test_daten2      <- function(mn, fudge=100, ...){}
#test_nasen       <- function(mns, fudge=100    ){}
#test_dasen       <- function(mns, fudge=100, roco=NULL){}
#test_danen       <- function(mns, fudge=100, ...){}
#test_tost1       <- function(mn                 ){}
#test_fuks1       <- function(data               ){}
#test_swan1       <- function(mn, da=NULL        ){}
#
#test_genki1      <- function(bn, se=TRUE        ){}
#test_dmrse1      <- function(betas, idmr=iDMR() ){}
#test_dmrse_row1  <- function(betas, idmr=iDMR() ){}
#test_dmrse_col1  <- function(betas, idmr=iDMR() ){}
#test_seabi1      <- function( bn, stop=1, sex, X){}
#test_pfilter1    <- function( mn                ){}
#test_BMIQ1       <- function(x                  ){}
#test_normalizeQuantiles.gdsn.class <- function (node, selection){}
#test_dfsfit.gdsn.class.1 <- function (mn, roco  ){}
#test_dasen2      <- function(mns, fudge=100, roco=NULL){}

pwod.gdsn <- function(node, mul = 4){ # {{{
    # create temporary file in working directory
    f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
    dim <- objdesp.gdsn(node)$dim
    # Create new node in "temp.gds"
    n.t <- add.gdsn(node = getfolder.gdsn(node),
                    name = paste0("pwod_", objdesp.gdsn(node)$name),
                    storage = "float64",
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    # pwod.R outputs to created node.
    apply.gdsn(node,
                margin = 1,
                FUN = function(x,y){
                    # pwod.R compute row by row
                    quan <- fivenum(x)
                    iqr <- quan[4] - quan[2]
                    bounds <- c(quan[4] + (iqr * y),
                    quan[2] - (iqr * y))
                    # Upper Bound is [1], Lower Bound is [2]
                    d <- x > bounds[1] | x < bounds[2]
                    x[d] <- NA
                    x
                    },
                y = mul,
                as.is = "gdsnode",
                target.node = n.t
                )
    #copyto.gdsn(node = getfolder.gdsn(node), source = index.gdsn(f, "pwod"),
    #            name = paste0("pwod_", objdesp.gdsn(node)$name))
    # Close + Delete temp file
    #closefn.gds(f)
    #unlink("temp.gds")
} # }}}

# gds.class "method" for prcomp
# Notable changes: 
# [1] Scaling and centering is NOT performed by default as
#     prcomp is usually performed on normalized data.
#     Notable Time save as samples are expected to be normalized already.
# [2] Number of learned principal components is optional,
#     5 are default, however this is assuming that majority of variance can be
#     found in the first few PCs hence why the output is slimmed down.
#     No Notable time save (May affect timesave when retx=T) 
#     Due to how the principal components are learned 
#     it is not a memory efficient operation
#     Therefore the forthcoming approach is chosen:
# [3] Perform pca on a subset of data (optionally), by default we opt for 1% 
#     As it is felt that considering the wide berth of probes 1% is enough to
#     learn the rough indication of the principal components. 
#     Notable Time save (obviously), limits memory usage as svd is performed
#     on a small subset. 
# 
prcomp.gds.class <- function(x, node.name, center = FALSE, scale. = FALSE, 
                            rank. = NULL, retx=FALSE, tol = NULL,
                            perc = 0.01, npcs = NULL, 
                            parallel = NULL, method = c('quick', 'sorted'),
                            verbose = FALSE, ...){
    method <- match.arg(method)
    if(method=="quick") parallel <- NULL
    # Parallel only amenable to calculating variance for sorted method.
    if(!is.null(parallel)){
        if(!inherits(parallel, 'cluster')){
            if(requireNamespace('parallel') & as.integer(parallel) > 1){
                if(verbose) message('Making Cluster of ', parallel, ' cores.')
                parallel <- parallel::makeCluster(parallel)
            } else {
                message('Cannot make cluster, continuing on single core.')
                parallel <- NULL
            }
        }
    }

    # x = gfile
    # node.name = node to pca
    # method = quick or sorted
    # parallel = if Multicore to be used for applicable steps!
    x0 <- x # Original gfile 
    x <- inode <- index.gdsn(x, node.name)
    dim <- objdesp.gdsn(x)$dim

    f <- createfn.gds("temp.gds", allow.duplicate=TRUE)
    n.t <- add.gdsn(f, val = NULL, valdim = c(dim[1], 0),
                    replace = TRUE, name = "scale", storage = "float64")
    cen <- NULL
    sc <- NULL
    if(center|scale.){ # If normalized Center | Scale = FALSE
        if(verbose) message('Scaling data... ')
#        if(!is.null(parallel)){
#           censc <- clusterApply.gdsn(cl = parallel,
#                              gds.fn = x0$filename,
#                              node.name = node.name,
#                              margin = 2,
#                              as.is="double",
#                              FUN=function(val, center, scale.,n.t){
#                              y <- scale(val, center=center, scale=scale.)
#                              append.gdsn(n.t, y)
#                              if(!is.null(attr(y, "scaled:center"))){
#                              out <- attr(y, "scaled:center")
#                              }
#                              if(!is.null(attr(y, "scaled:scale"))){
#                              names(out) <- attr(y, "scaled:scale")
#                              }
#                              }, center=center, scale.=scale., n.t = n.t)
#        } else {
#           censc <- apply.gdsn(x, margin = 2, as.is='double', FUN=function(val, center, scale., n.t){
#                               y <- scale(val, center=center, scale=scale.)
#                              append.gdsn(n.t, y)
#                              if(!is.null(attr(y, "scaled:center"))){
#                              out <- attr(y, "scaled:center")
#                              }
#                              if(!is.null(attr(y, "scaled:scale"))){
#                              names(out) <- attr(y, "scaled:scale")
#                              }
#                              }, center=center, scale.=scale., n.t = n.t)
#        }
         # apply.gdsn could work but getting cen and sc is difficult.
       for(i in 1:dim[2]){
            val <- readex.gdsn(x, sel = list(NULL, i))
            y <- scale(val, center = center, scale = scale.)
            if(!is.null(attr(y, "scaled:center"))){
                cen[i] <- attr(y, "scaled:center")
            }
            if(!is.null(attr(y, "scaled:scale"))){
                sc[i] <- attr(y, "scaled:scale")
            }
            append.gdsn(n.t, y)
        }
        x <- n.t 
    }
    n <- dim[1]
    p <- dim[2]
    k <- if(!is.null(rank.)) {
        stopifnot(length(rank.) == 1, is.finite(rank.),
                    as.integer(rank.) > 0)
        min(as.integer(rank.), n, p, npcs)
            ## Note that La.svd() *still* needs
            # a (n x p) and a (p x p) auxiliary
        } else {
        min(npcs, n, p)
        }
    # Current method would be to run a % of probes and learn a fewer pcs...
    
    sel <- rep(FALSE, times = n)
    if(method == "sorted"){
        if(verbose) message('Identifying largest variance in rows...')
        if(!is.null(parallel)){
            if(center|scale.){
              closefn.gds(f)
              f <- openfn.gds('temp.gds', allow.duplicate = TRUE)
              x <- n.t <- index.gdsn(f, 'scale') 
            }
            variances <- clusterApply.gdsn(cl = parallel,
                                           gds.fn = if(center | scale.) 'temp.gds' else x0$filename,
                                           node.name = if(center | scale.) 'scale' else node.name,
                                           margin = 1,
                                           as.is = 'double',
                                           FUN = function(val){
                                           isna <- sum(is.na(val))>0
                                           fn <- quantile(val, na.rm = TRUE)
                                           if(isna) out <- NA else out <- fn[4] - fn[2]
                                           out
                                           } )
        } else { 
            variances <- apply.gdsn(node = x, margin = 1, as.is = 'double', FUN = function(val){
                                           isna <- sum(is.na(val)) > 0
                                           fn <- quantile(val, na.rm = TRUE)
                                           if(isna) out <- NA else out <- fn[4] - fn[2]
                                           out
                                           } ) }
    sel[order(variances, decreasing = TRUE)[1:round(n*perc)]] <- TRUE
    } else if(method=="quick"){
        if(verbose) message('Stochastically selecting rows ... ')
        sel[sample(1:n, round(n*perc), replace = FALSE)] <- TRUE
    }
    # Not Memory efficient though!
    mat <- na.omit(readex.gdsn(node = x, sel = list(sel, NULL)))
    if(verbose) message('Learning first ', k, ' Principal components.')
    s <- svd(mat, nu = 0, nv = k)
    j <- seq_len(k)
    #    s$d <- s$d / sqrt(max(1, n - 1))
    # Incase NA's are removed, we need to account for the change selection.
    s$d <- s$d / sqrt(max(1, round(nrow(mat)*perc) - 1))
    if(!is.null(tol)){
        ## we get rank at least one even for a 0 matrix.
        rank <- sum(s$d > (s$d[1L]*tol))
        if(rank < k){
            j <- seq_len(k <- rank)
            s$v <- s$v[,j , drop = FALSE]
        }
    }
    #    dimnames(s$v) <- list(colnames(x), paste0("PC", j)) # Broken
    r <- list(sdev = s$d, rotation = s$v,
                center = if(is.null(cen)) FALSE else cen,
                scale = if(is.null(sc)) FALSE else sc)
    # There isn't a clever way to perform matrix multiplications yet.
    if (retx) {
    # Original Statement:   r$x <- x %*% s$v
    # Slow (Memory Intensive) Method:
    r$x <- read.gdsn(x) %*% s$v
    }
    closefn.gds(f)
    unlink("temp.gds")
    if(!is.null(parallel)){
        if(verbose) message('Stopping Cluster')
        parallel::stopCluster(parallel)
    }
    class(r) <- "prcomp"
    r
}

db.gdsn <- function(gds, mns, uns){ # {{{  
    dim <- objdesp.gdsn(mns)$dim
    stopifnot(dim == objdesp.gdsn(uns)$dim)
    # Creating new node for meth + unmeth combination
    n.t <- add.gdsn(node = gds, name = "methunmeth", storage = "float64",
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    # Store meth and unmeth into the same node
    for(x in 1:dim[2]){
        mnval <- readex.gdsn(mns, sel = list(NULL, x))
        append.gdsn(n.t, mnval)
        unval <- readex.gdsn(uns, sel = list(NULL, x))
        append.gdsn(n.t, unval)
    }
    # Normalization
    qn.gdsn(gds = gds, target = index.gdsn(gds, "methunmeth"), newnode = "db")
    # Initializing new nodes for new normalized values
    db.m <- add.gdsn(gds, "db.meth" , storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    db.u <- add.gdsn(gds, "db.unmeth" , storage = "float64", 
                    valdim = c(dim[1], 0), val = NULL, replace = TRUE)
    # Split normalized values into new nodes.
    for(x in seq(1,(2*dim[2])-1, 2)){ 
        val <- readex.gdsn(index.gdsn(gds, path = "db"),
                            sel = list(NULL, c(x, x + 1)))
        append.gdsn(db.m, val[ ,1])
        append.gdsn(db.u, val[ ,2])
    }
} # }}}

#TODO - unit tests for non-numeric accessors, & all normalisation methods

# unit test stubs, the  idea is that whenever we work on a function
# we create a unit test. any function for strictly internal use should be moved
# to test_internal.R

# TODO: dasenGds.R dbGdsn.R dfsfitGdsn.R
#       ecc.gdsn.R es2gds.R gds2mlumi.R gdsnclass_methods.R
#       GEOtoGDS.R inout.R pfilterGds.R prcompGdsn.R pwodGdsn.R
#       qnGdsn.R ranknorm.R zzz.R

# comboGds.R

redirect.gds<- function(gds, rownames, colnames){ #{{{
    # Wrapper to change the gdsn node "paths" whererow and colnames are stored
    a <- try(index.gdsn(gds, rownames), silent = TRUE)
    if(inherits(a, "try-error")){
        stop(paste(rownames, "does not exist in gds object!"))
    }
    b <- try(index.gdsn(gds, colnames), silent = TRUE)
    if(inherits(b, "try-error")){
        stop(paste(colnames, "does not exist in gds object!"))
    }
    add.gdsn(gds, name = "paths", replace = TRUE, val = c(rownames, colnames))
    cat("Changing 'rownames' path to:", rownames, ". \n")
    cat("Changing 'colnames' path to:", colnames, ". \n")
}
#}}}


backup.gdsn <- function(gds = NULL, node){   #{{{
    # Quick function to quickly copy specific nodes into a new-folder
    # called "backup". not recommended for standard workflow. see copyto.gdsn
    if(is.null(gds)) gds <- getfolder.gdsn(node)
    if(!("backup" %in% ls.gdsn(gds))) addfolder.gdsn(gds, "backup")
    copyto.gdsn(index.gdsn(gds, "backup"), node)
}
#}}}

'[.gds.class' <- function(x, i, j, node, name = TRUE, drop = TRUE){ #{{{
    # Method of subsetting gds.class objects while specifying node.
    # Create gdsn.class for selected node
    dat <- index.gdsn(x, node)
    # Pass to '[.gdsn.class'
    dat[i = i, j = j, name = name, drop = drop]
} # }}}

# Updated for ranked norm...
'[.gdsn.class' <- function(x, i, j, name = TRUE, drop = TRUE){ # {{{
    # Method of subsetting gdsn.class objects w.o reading in entire object.
    # Wrapper for readex.gdsn
    # arg: "name": Will point towards "fData/Probe_ID" and "pData/barcode" for row and col names. (by default)
    #              name = F will enable for faster indexing.
    # TODO: [] method? a.k.a vector method.
    # TODO: Warnings, if any.
    # TODO: Look into why logical vectors are a bit funky - hard convert into integer...
    base <- getfolder.gdsn(x)
    dim <- objdesp.gdsn(x)$dim

    # x[ , ]
    if(missing(i) & missing(j)){ # {{{
        mat <- read.gdsn(x)
        if(name){
            rownames(mat) <- read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[1]))
            colnames(mat) <- read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[2]))
        }
    } # }}}

    # x[ , j]
    if(missing(i) & !missing(j)){ # {{{
        j1 <- j
        if(is.character(j1)) j <- match(j1, read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[2]))) # ok
        if(is.logical(j1))   j <- (1:objdesp.gdsn(x)$dim[2])[j1] # Potential error here?

        ncol <- j
        mat <- as.matrix(readex.gdsn(x, sel = list(NULL, ncol)))
        if(length(j)==1) mat <- as.matrix(mat)
        if(name){
            rownames(mat) <- read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[1]))
            colnames(mat) <- readex.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[2]), sel = ncol)
        }
    } # }}}

    # x[ i, ]
    if(!missing(i) & missing(j)){ # {{{
        i1 <- i
        if(is.character(i1)) i <- match(i1, read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[1]))) # ok
        if(is.logical(i1))   i <- (1:objdesp.gdsn(x)$dim[1])[i1] # Potential error here?
        nrow <- i
        if(length(i)==1){ # Calling a single row makes naming difficult this is a work-around.
            mat <- as.matrix(t(readex.gdsn(x, sel = list(nrow, NULL))))
        } else {
            mat <- as.matrix(readex.gdsn(x, sel = list(nrow, NULL)))
        }

        if(name){
            rownames(mat) <- readex.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[1]), sel = nrow)
            colnames(mat) <- read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[2]))
        }
    } # }}}

    # x[ i, j]
    if(!missing(i) & !missing(j)){ # {{{
        i1 <- i
        if(is.character(i1)) i <- match(i1, read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[1]))) # ok
        if(is.logical(i1))   i <- (1:objdesp.gdsn(x)$dim[1])[i1] # Potential error here?
        j1 <- j
        if(is.character(j1)) j <- match(j1, read.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[2]))) # ok
        if(is.logical(j1))   j <- (1:objdesp.gdsn(x)$dim[2])[j1] # Potential error here?

        nrow <- i
        ncol <- j
        mat <- readex.gdsn(x, sel = list(nrow, ncol))

        # i=1, j=1
        if( length(i) == 1 & length(j)  == 1) mat <- matrix(mat)
        # i>1, j=1
        if(!length(i) == 1 & length(j)  == 1) mat <- matrix(mat)
        # i=1, j>1
        if( length(i) == 1 & !length(j) == 1) mat <- t(matrix(mat))

        if(name){
            rownames(mat) <- readex.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[1]), sel = nrow)
            colnames(mat) <- readex.gdsn(index.gdsn(base, read.gdsn(index.gdsn(base, "paths"))[2]), sel = ncol)
        }
    } # }}}
    # It gets complicated here... ... {{{
    ranked <- get.attr.gdsn(x)[['ranked']]
    if(is.null(ranked)) ranked <- FALSE
    if(ranked){
        quantiles <- get.attr.gdsn(x)[['quantiles']]
        inter <- get.attr.gdsn(x)[['inter']]
        ot <- get.attr.gdsn(x)[['onetwo']]
        design <- FALSE
        if(!is.null(ot)) design <- TRUE
        isna <- index.gdsn(base, get.attr.gdsn(x)[['is.na']])[i, j, name = TRUE, drop = FALSE]
        for(z in 1:ncol(isna)){
            acol <- isna[,z]
            re <- rep(NA, length(acol))
            if(design){
                re[ot == 'I' & (!acol)] <-  approx(inter[ot == 'I'] , quantiles[ot == 'I'] , (mat[ot == 'I' & !acol, z] - 1) /(sum(ot == 'I' )-1), ties = "ordered")$y
                re[ot == 'II' & (!acol)] <- approx(inter[ot == 'II'], quantiles[ot == 'II'], (mat[ot == 'II' & !acol, z] - 1)/(sum(ot == 'II')-1), ties = "ordered")$y
            } else {
                re[!acol] <- approx(inter, quantiles, (mat[!acol, z]-1)/(length(inter)-1), ties = 'ordered')$y
            }
            mat[, z] <- re
        }
    }  #}}}
    # Enable dropping on 1 row or 1 column indicies
    if(any(dim(mat) == 1)) return(mat[,,drop=drop]) else return(mat)
} #}}}

#colnames <- function (x, do.NULL = TRUE, prefix = "col") {{{
setMethod(
    f = "colnames",
    signature(x = "gds.class"),
    definition = function(x, do.NULL = TRUE, prefix = NULL){
        read.gdsn(index.gdsn(x,read.gdsn(index.gdsn(x, "paths"))[2]))
    }
) # OK 

setMethod(
    f = "colnames",
    signature(x = "gdsn.class"),
    definition = function(x, do.NULL = TRUE, prefix = NULL){
        read.gdsn(index.gdsn(getfolder.gdsn(x),
           read.gdsn(index.gdsn(getfolder.gdsn(x), "paths"))[2]))
    }
) #}}}

#rownames <- function (x, do.NULL = TRUE, prefix = "col") {{{
setMethod(
    f = "rownames",
    signature(x = "gds.class"),
    definition = function(x, do.NULL = TRUE, prefix = NULL){
        read.gdsn(index.gdsn(x,read.gdsn(index.gdsn(x, "paths"))[1]))
    }
) # OK

setMethod(
    f = "rownames",
    signature(x = "gdsn.class"),
    definition = function(x, do.NULL = TRUE, prefix = NULL){
        read.gdsn(index.gdsn(getfolder.gdsn(x),
            read.gdsn(index.gdsn(getfolder.gdsn(x), "paths"))[1]))
    }
)  #}}}

dim.gds.class <- function(x){ # parasitise dimnames {{{
   sapply(dimnames(ep2.gds), length)

}

dim.gdsn.class <- function(x){ #{{{
   sapply(dimnames(ep2.gds), length)

}#}}}


# setMethod(
#    f= 'dimnames',
#    signature( x= 'gds.class' ),
#    definition = function(x){
dimnames.gds.class <- function(x){   #{{{
      list(
         probes=rownames(x),
         samples=colnames(x)
      )
}
# )  

# setMethod(
#    f= 'dimnames',
#    signature( x= 'gds.class' ),
#    definition = function(x){
dimnames.gdsn.class <- function(x){
      list(
         probes=rownames(x),
         samples=colnames(x)
      )
}
# )  }}}

# Standard eset functions to grab matrices, including indexing:   {{{
# Calling gdsn node but will allow direct subsetting with '['
# Alternative work around would be setGeneric("betas") function(object, ...)
## setGeneric("betas", function(object, ...) standardGeneric("betas"))
#  object[i, j, node = "betas", name = TRUE, drop = FALSE]
# which overwrites other "betas" methods.
# This also applies to other eset methods.

setMethod(
    f = "betas",
    signature(object = "gds.class"),
    definition = function(object){
        index.gdsn(object, 'betas')
    }
) # OK

setMethod(
    f = "methylated",
    signature(object = "gds.class"),
    definition = function(object){
        index.gdsn(object, 'methylated')
    }
) # OK

setMethod(
    f = "unmethylated",
    signature(object = "gds.class"),
    definition = function(object){
        index.gdsn(object, 'unmethylated')
    }
) # OK

setMethod(
    f = "pvals",
    signature(object = "gds.class"),
    definition = function(object){
        index.gdsn(object, 'pvals')
    }
) # OK

# These are small and can be read completely into memory.
setMethod(
    f = "fData",
    signature(object = "gds.class"),
    definition = function(object){
        fd <- index.gdsn(object, 'fData')[ , ,name = FALSE, drop = FALSE]
        rownames(fd) <- rownames(object)
        fd
    }
) # OK

setMethod(
    f = "pData",
    signature(object = "gds.class"),
    definition = function(object){
        index.gdsn(object, 'pData')[ , , name = FALSE, drop = FALSE]
    }
) # OK

setMethod(
    f = "getHistory",
    signature(object = "gds.class"),
    definition = function(object){
        read.gdsn(index.gdsn(object, 'history'))
    }
) # AS - OK

setGeneric("QCmethylated", function(object){standardGeneric("QCmethylated")})
setMethod(
    f = "QCmethylated",
    signature(object = "gds.class"),
    definition = function(object){
        out <- read.gdsn(index.gdsn(object, 'QCmethylated'))
        rownames(out) <- QCrownames(object)
        out
    }
) # AS - OK

setGeneric("QCunmethylated",function(object){
    standardGeneric("QCunmethylated")
})
setMethod(
    f = "QCunmethylated",
    signature(object = "gds.class"),
    definition = function(object){
        out <- read.gdsn(index.gdsn(object, 'QCunmethylated'))
        rownames(out) <- QCrownames(object)
        out
    }
) # AS - OK

setGeneric("QCrownames", function(object){standardGeneric("QCrownames")})
setMethod(
    f = "QCrownames",
    signature(object = "gds.class"),
    definition = function(object){
        read.gdsn(index.gdsn(object, 'QCrownames'))
    }
) # AS - OK  }}}
# normalisers {{{
setMethod(
    f = "betaqn",
    signature(bn = "gds.class"),
    definition = function(bn){
    if(bn$readonly) stop("gds object is in Read-Only mode, please reload!")
        # Create Temp Nod
        f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
        history.submitted <- as.character(Sys.time())
        # Normalise betas into Temporary object
        qn.gdsn(gds = f,
                target = index.gdsn(bn, "betas"),
                newnode = "betas")
        # Create new node in original - replacing old node.
        n.t <- add.gdsn(bn,
                        name = "betas",
                        valdim = c(objdesp.gdsn(
                                    index.gdsn(f, "betas"))$dim[1], 0),
                        val = NULL,
                        storage = "float64",
                        replace = TRUE)
        # Append new betas to original gds col by col.
        for(i in 1:dim[2]){
            val <- readex.gdsn(index.gdsn(f, "betas"), sel = list(NULL, i))
            append.gdsn(node = n.t, val = val)
        }
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with betaqn method (bigmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE)
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/", j, sep = "")
            h_child_n <- index.gdsn(bn, h_index_str, silent = TRUE)
            append.gdsn(h_child_n, val = h[,h_coln])
        }
        # Deleting Temp File.
        closefn.gds(f)
        unlink("temp.gds", force = TRUE)
    }
)

setMethod(
    f = "naten",
    signature(mn = "gds.class"),
    definition = function(mn, fudge = 100, ret2 = FALSE, node = "betas"){
    if(mn$readonly) stop("gds object is in Read-Only mode, please reload!")
        object <- mn
        history.submitted <- as.character(Sys.time())
        # Normalize using gds method - temp node created within!
        naten.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with naten method (bigmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE)
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
) # TGS

setMethod(
    f = "nanet",
    signature(mn = "gds.class"),
    definition = function(mn, fudge = 100, ret2 = FALSE, node = "betas"){
        history.submitted <- as.character(Sys.time())
        if(mn$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mn
        nanet.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with nanet method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

setMethod(
    f = "nanes",
    signature(mns = "gds.class"),
    definition = function(mns, fudge=100, ret2=FALSE, node = "betas", ...){
        history.submitted <- as.character(Sys.time())
        if(mns$readonly) stop("gds object in Read-Only mode")
        object <- mns
        nanes.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo = fot(object),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with nanes method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
) # TGS

setMethod(
    f = "danes",
    signature(mn = "gds.class"),
    definition = function(mn, fudge = 100, ret2 = FALSE, node = "betas",...){
        history.submitted <- as.character(Sys.time())
        if(mn$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mn
        danes.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo = fot(object),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with danes method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

setMethod(
    f = "danet",
    signature(mn = "gds.class"),
    definition = function(mn, fudge = 100, ret2 = FALSE, node = "betas", ...){
        history.submitted <- as.character(Sys.time())
        if(mn$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mn
        danet.gds(  gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo = fot(object),
                    roco = substring(colnames(object), regexpr("R0[1-9]C0[1-9]", colnames(object))),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with danet method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors=FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
) # TGS

setMethod(
    f = "daten1",
    signature(mn = "gds.class"),
    definition = function(mn, fudge = 100, ret2 = FALSE, node = "betas", ...){
        history.submitted <- as.character(Sys.time())
        if(mn$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mn
        daten1.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo = fot(object),
                    roco = substring(colnames(object), regexpr("R0[1-9]C0[1-9]", colnames(object))),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with daten1 method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

setMethod(
    f = "daten2",
    signature(mn = "gds.class"),
    definition = function(mn, fudge = 100,ret2 = FALSE,node = "betas", ...){
        history.submitted <- as.character(Sys.time())
        if(mn$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mn
        daten2.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo = fot(object),
                    roco = substring(colnames(object), regexpr("R0[1-9]C0[1-9]", colnames(object))),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with daten2 method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

setMethod(
    f = "nasen",
    signature(mns = "gds.class"),
    definition = function(mns, ret2 = FALSE, fudge = 100, node = "betas"){
        history.submitted <- as.character(Sys.time())
        if(mns$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mns
        nasen.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo = fot(object),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with nasen method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

setMethod(
    f = "dasen",
    signature(mns = "gds.class"),
    definition = function(mns, fudge = 100, ret2 = FALSE, node ="betas", ...){
        history.submitted <- as.character(Sys.time())
        if(mns$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mns
        dasen.gds(object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo = fot(object),
                    roco = substring(colnames(object), regexpr("R0[1-9]C0[1-9]", colnames(object))),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with dasen method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors=FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

setMethod(
    f = "danen",
    signature(mns = "gds.class"),
    definition = function(mns, fudge = 100, ret2 = FALSE, node = "betas",...){
        history.submitted <- as.character(Sys.time())
        if(mns$readonly) stop("gds object in Read-Only mode, please reload!")
        object <- mns
        danen.gds(gds = object,
                    node,
                    mns = index.gdsn(object, "methylated"),
                    uns = index.gdsn(object, "unmethylated"),
                    onetwo =  fot(object), #fData(object)[,grep('DESIGN',
                                          #  colnames(fData(object)),
                                          #  ignore.case = TRUE)[1]],
                    roco = substring(colnames(object), regexpr("R0[1-9]C0[1-9]", colnames(object))),
                    fudge,
                    ret2
                    )
        history.finished <- as.character(Sys.time())
        history.command <- "Normalized with danen method (wateRmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors=FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

#}}}

#{{{ exprs and pfilter
setMethod(
    f = "exprs",
    signature(object = "gds.class"),
    definition = function(object){
        exp <- data.frame(betas(object)[,, name = TRUE],
                            row.names = rownames(object),
                            check.rows = FALSE,
                            check.names = FALSE,
                            stringsAsFactors = FALSE)
        colnames(exp) <- colnames(object)
        exp
    }
) # AS - OK  # TGS -

setMethod(
    f = "pfilter",
    signature(mn = "gds.class"),
    definition = function(mn, perCount = NULL,
                            pnthresh = NULL, perc = NULL, pthresh = NULL ){
        if(mn$readonly) stop("gds object in Read-Only mode, please reload!")
        history.submitted <- as.character(Sys.time())
        object <- mn
        if("NBeads" %in% ls.gdsn(mn)){
            nb <- index.gdsn(object, "NBeads")
        } else {
            cat("NBeads missing, using betas instead... \n")
            nb   <- index.gdsn(object, "betas")
        }
        bc    <- nb
        mn    <- NULL
        bn    <- NULL
        un    <- NULL
        pn    <- pvals(object)
        da    <- NULL
        l    <- pfilter.gds(mn = mn, un = un, bn = bn, da = da,
                                pn = pn, bc = bc, perCount, pnthresh, perc,
                                pthresh)
        history.finished <- as.character(Sys.time())
        history.command <- "pfilter applied (bigmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors=FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
        lpro <- l$probes
        lsam <- l$samples
        subSet(object,which(lpro),which(lsam))
    }
)   # AS - OK # TGS - OK  }}}



# subset  -- compare with chainsaw  {{{
#subsetting : i = features, j = samples
# TODO: Test Logical Indexing and Character Subsetting also(?)
setGeneric("subSet",function(x,i,j,...,drop=FALSE){standardGeneric("subSet")})
setMethod(
    f = "subSet",
    signature(x = "gds.class"),
    definition = function(x, i, j, ..., drop = FALSE)  {
        if(x$readonly) stop("gds object is in Read-Only mode, please reload!")
        history.submitted <- as.character(Sys.time())
        nodules <- ls.gdsn(x) # Important!
        f <- createfn.gds("temp.gds", allow.duplicate = TRUE)
        if("betas" %in% nodules){
            # Copy node to temp node colbycol
            trait <- tolower(objdesp.gdsn(betas(x))$trait)
            n.t <- add.gdsn(f, name = "betas",
                            valdim = c(objdesp.gdsn(betas(x))$dim[1],0),
                            val = NULL, storage = trait)
            for(a in 1:objdesp.gdsn(betas(x))$dim[2]){
                append.gdsn(node = n.t, val = readex.gdsn(betas(x),
                            sel=list(NULL, a)))
            }
            # Replace Old Node with Subset colbycol
            n.n <- add.gdsn(x, name = "betas", valdim = c(length(i), 0),
                            val = NULL, replace = TRUE, storage = trait)
            for(z in j){
                append.gdsn(node = n.n, val = readex.gdsn(betas(f),
                            sel = list(i, z)))
            }
        }

        if("pvals" %in% nodules){
            trait <- tolower(objdesp.gdsn(pvals(x))$trait)
            n.t <- add.gdsn(f, name = "pvals",
                            valdim = c(objdesp.gdsn(pvals(x))$dim[1],0),
                            val = NULL, storage = trait)
            for(a in 1:objdesp.gdsn(pvals(x))$dim[2]){
                append.gdsn(node = n.t, val = readex.gdsn(pvals(x),
                            sel = list(NULL, a)))
            }
            # Replace Old Node with Subset colbycol
            n.n <- add.gdsn(x, name = "pvals", valdim = c(length(i), 0),
                            val = NULL, replace = TRUE, storage = trait)
            for(z in j){
                append.gdsn(node = n.n, val = readex.gdsn(pvals(f),
                            sel = list(i, z)))
            }
        }

        if("methylated" %in% nodules){
            trait <- tolower(objdesp.gdsn(methylated(x))$trait)
            n.t <- add.gdsn(f, name="methylated",
                            valdim=c(objdesp.gdsn(methylated(x))$dim[1],0),
                            val = NULL, storage = trait)
            for(a in 1:objdesp.gdsn(methylated(x))$dim[2]){
                append.gdsn(node = n.t, val = readex.gdsn(methylated(x),
                            sel=list(NULL,a)))
            }
            # Replace Old Node with Subset colbycol
            n.n <- add.gdsn(x, name="methylated", valdim=c(length(i), 0),
                            val=NULL, replace=TRUE, storage = trait)
            for(z in j){
                append.gdsn(node = n.n, val = readex.gdsn(methylated(f),
                            sel = list(i, z)))
            }
        }

        if("unmethylated" %in% nodules){
            trait <- tolower(objdesp.gdsn(unmethylated(x))$trait)
            n.t <- add.gdsn(f, name="unmethylated",
                            valdim=c(objdesp.gdsn(unmethylated(x))$dim[1],0),
                            val = NULL, storage = trait)
            for(a in 1:objdesp.gdsn(unmethylated(x))$dim[2]){
                append.gdsn(node = n.t, val = readex.gdsn(unmethylated(x),
                            sel=list(NULL,a)))
            }
            # Replace Old Node with Subset colbycol
            n.n <- add.gdsn(x, name="unmethylated", valdim=c(length(i), 0),
                            val = NULL, replace = TRUE, storage = trait)
            for(z in j){
            append.gdsn(node = n.n, val = readex.gdsn(unmethylated(f),
                        sel=list(i, z)))
            }
        }

        if("NBeads" %in% nodules){
            nb <- index.gdsn(x, "NBeads")
            trait <- tolower(objdesp.gdsn(nb)$trait)
            n.t <- add.gdsn(f, name="NBeads",
                            valdim=c(objdesp.gdsn(nb)$dim[1],0),
                            val = NULL, storage = trait)
            for(a in 1:objdesp.gdsn(nb)$dim[2]){
                append.gdsn(node = n.t,
                            val = readex.gdsn(nb, sel=list(NULL,a)))
            }
            # Replace Old Node with Subset colbycol
            nb2 <- index.gdsn(f, "NBeads")
            n.n <- add.gdsn(x, name="NBeads", valdim=c(length(i), 0),
                            val=NULL, replace=TRUE, storage = trait)
            for(z in j){
                append.gdsn(node = n.n,
                            val = readex.gdsn(nb2, sel=list(i, z)))
            }
        }
        # These are small enough to warrant not worrying about memory use.
        if("fData" %in% nodules){
            fdatasubs <- fData(x)[i,,drop=FALSE]
            add.gdsn(x, name="fData", valdim=dim(fdatasubs),
                    val=fdatasubs, replace=TRUE)
        }

        if("pData" %in% nodules){
            pdatasubs <- pData(x)[j,,drop=FALSE]
            add.gdsn(x, name="pData", valdim=dim(pdatasubs),
                    val=pdatasubs, replace=TRUE)
        }

        if("QCmethylated" %in% nodules){
            qcmethsubs <- QCmethylated(x)[,j]
            add.gdsn(x, name="QCmethylated", valdim=dim(qcmethsubs),
                    val= qcmethsubs, replace=TRUE)
        }

        if("QCunmethylated" %in% nodules){
            qcumethsubs <- QCunmethylated(x)[,j]
            add.gdsn(x, name="QCunmethylated", valdim=dim(qcumethsubs),
                    val = qcumethsubs, replace=TRUE)
        }

        history.finished <- as.character(Sys.time())
        dim <- objdesp.gdsn(betas(x))$dim
        history.command <- paste("Subset of", dim[1],
                                "rows and", dim[2], "samples")
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors=FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(x,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
        closefn.gds(f)
        unlink("temp.gds")
    }
) # AS - OK # TGS OKish  }}}

#prcomp R/prcompGdsn.R contains S3 method!
#setMethod(
#  f = "prcomp",
#  signature(x = "gdsn.class"),
#  definition = function(x, retx = FALSE, center = FALSE, scale. = FALSE,
#                        perc = 0.01, npcs=5, ...){
#    prcomp.gdsn(x, retx, center, scale., perc, npcs)
#  }
#)

# outlyx - instead of utilizing prcomp.gdsn (since pcout isn't bigmelon {{{
# friendly - we opt for generic use of prcomp)

setMethod(
    f = "outlyx",
    signature(x = "gdsn.class"),
    definition = function(x, iqr = TRUE, iqrP = 2, pc=1, mv = TRUE,
                            mvP = 0.15, plot = TRUE, perc = 0.01, ...){
        dimx <- objdesp.gdsn(x)$dim
        samp <- sample(1:dimx[1], dimx[1]*perc, replace=FALSE)
        outlyx(x[samp, ], iqr, iqrP, pc, mv, mvP, plot,...)
    }
)

setMethod( # Automatically select betas
    f = "outlyx",
    signature(x = "gds.class"),
    definition = function(x, iqr = TRUE, iqrP = 2, pc = 1, mv = TRUE,
                            mvP = 0.15, plot = TRUE, perc = 0.01, ...){
        outlyx(betas(x), iqr, iqrP, pc, mv, mvP, plot, perc,...)
    }
)
# }}}

# agep and smokp-  gds and gdsn methods need to both work like wateRmelon agep {{{
setMethod(
    f = "agep",
    signature(betas = "gds.class"),
    definition = function(betas, coeff, method='horvath'){
        agep(betas(betas), coeff = coeff, method=method)
    }
)

setMethod(
    f = "agep",
    signature(betas = "gdsn.class"),
    definition = function(betas, coeff, method='horvath'){
        if(is.null(coeff)){
            stop('coef is NULL, run \'data(coef)\' and supply this to agep')
            #data(coef, package='wateRmelon')
            #coeff <- coef
        }
        # Rownames method not working correctly? Kludge
        ro <- rownames(betas)
        rn <- match(names(coeff), ro)
        rn <- rn[!is.na(rn)]
        # rn <- which(rownames%in%names(coeff)[-1]) 
        betas <- betas[rn,, name = T, drop = FALSE]
        agep(betas, coeff = coeff, method=method)
    }
)

setMethod(
  f= "smokp",
  signature(betas="gds.class"),
  definition=function(betas, method='SSt', sst = NULL){
    object <- betas(betas)
    smokp(betas=object, method=method, sst=sst)
  }
)

#}}}


setGeneric(name= "qual")   #{{{
# qual (?) # Do col by col computation of metrics. Collapse output.
setMethod(
    f= "qual",
    signature(norm="gdsn.class", raw="gdsn.class"),
    definition = function(norm, raw){
        dimnorm <- objdesp.gdsn(norm)$dim
        dimraw  <- objdesp.gdsn(raw)$dim
        if(!all(dimnorm == dimraw)) stop("Nodes are not the same dimensions")
        res <- t(sapply(1:dimnorm[2], function(x){
            dif <- norm[,x,name=F] - raw[,x,name=F]
            rmsd <- sqrt(mean(dif^2, na.rm = TRUE))
            sdd  <- sd(dif, na.rm = TRUE)
            sadd <- sd(abs(dif), na.rm = TRUE)
            srms <- rmsd/sdd
            out <- c(rmsd, sdd, sadd, srms)
            out
        } ) )
        rownames(res) <- colnames(norm)
        colnames(res) <- c("rmsd", "sdd", "sadd", "srms")
        res
    }
)

# bscon see bscon_methy.R
setMethod(
    f= "bscon",
    signature(x = "gds.class"),
    definition = function(x){
        nodules <- ls.gdsn(x)
        if("QCmethylated"%in%nodules){
            green.Channel <- QCmethylated(x)
        } else {
            stop("Green channel QC data could not be found")
        }
        if("QCunmethylated"%in%nodules){
            red.Channel <- QCunmethylated(x)
        } else {
            stop("Red channel QC data could not be found")
        }
        QCrows <- QCrownames(x)
        bisulfite.green <- green.Channel[grep("(^B.*C.*)\\bI\\b.*", rownames(green.Channel)),] 
        bisulfite.red <- red.Channel[grep("(^B.*C.*)\\bI\\b.*", rownames(red.Channel)),]
        bsI.green <- bisulfite.green
        bsI.red <- bisulfite.red

        bsII.green <- green.Channel[grep("(^B.*C.*)\\bII\\b.*", rownames(green.Channel)),]    #  as above with II (subset of above)
        bsII.red <- red.Channel[grep("(^B.*C.*)\\bII\\b.*", rownames(red.Channel)),]
        if(nrow(bsI.green) > 11){ # 450K
          BSI.betas <- rbind(bsI.green[1:3,], bsI.red[7:9,])/((rbind(bsI.green[1:3,], bsI.red[7:9,])) + rbind(bsI.green[4:6,], bsI.red[10:12,]))
        } else { # EPIC (Skip the missing probe pair...)
          BSI.betas <- rbind(bsI.green[1:2,], bsI.red[6:7,])/((rbind(bsI.green[1:2,], bsI.red[6:7,])) + rbind(bsI.green[3:4,], bsI.red[ 8:9 ,]))
        }
        BSII.betas <- bsII.red/(bsII.red + bsII.green)
        apply(rbind(BSI.betas, BSII.betas), 2, median)*100
    }
)
setMethod(
    f = "pwod",
    signature(object = "gds.class"),
    definition = function(object, mul = 4){
        if(object$readonly) stop("gds in Read-Only mode, please reload!")
        history.submitted <- as.character(Sys.time())
        bet <- betas(object)
        pwod.gdsn(node = bet, mul)
        history.finished <- as.character(Sys.time())
        history.command <- "Filtered with pwod (bigmelon)"
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors=FALSE
                        )
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/",j,sep="")
            h_child_n <- index.gdsn(object,h_index_str,silent=TRUE)
            append.gdsn(h_child_n, val=h[,h_coln])
        }
    }
)

#dmrse <- function(betas, idmr=iDMR)
setMethod(
    f = "dmrse",
    signature(betas = "gds.class"),
    definition = function(betas, idmr = iDMR()){ 
        dmrse(betas(betas))
        #object <- betas
        #betas <- betas(object)[idmr, , name = TRUE]
        #dmrse(betas, idmr)
    }
) #OK

setMethod(
    f = "dmrse",
    signature(betas = "gdsn.class"),
    definition = function(betas, idmr = iDMR()){
        object <- betas
        betas <- object[idmr, ,name = TRUE]
        dmrse(betas, idmr)
    }
)

#dmrse_row <- function(betas, idmr=iDMR)
setMethod(
    f = "dmrse_row",
    signature(betas = "gds.class"),
    definition = function(betas, idmr=iDMR()){
        dmrse_row(betas(betas))
#        object <- betas
#        betas <- betas(object)[idmr, ,name = TRUE]
#        dmrse_row(betas, idmr)
    }
) # AS - OK

setMethod(
    f = "dmrse_row",
    signature(betas = "gdsn.class"),
    definition = function(betas, idmr = iDMR()){
        object <- betas
        betas <- object[idmr, ,name = TRUE]
        dmrse_row( betas, idmr )
    }
)

setMethod(
    f = "dmrse_col",
    signature(betas = "gds.class"),
    definition = function(betas, idmr = iDMR()){
        dmrse_col(betas(betas))
        #object <- betas
        #betas <- betas(object)[idmr, ,name = TRUE]
        #dmrse_col(betas, idmr)
    }
) # AS - OK

setMethod(
    f = "dmrse_col",
    signature(betas = "gdsn.class"),
    definition=function(betas, idmr = iDMR()){
        object <- betas
        betas <- object[idmr, ,name = TRUE]
        dmrse_col(betas, idmr)
    }
)

#seabi <- function (bn, stop, sex, X){
setMethod( # Not mem eff # Method not working either!
    f = "seabi",
    signature(bn = "gds.class"),
    definition = function(bn, stop = 1, sex=pData(bn)$sex,
                            X = fData(bn)$CHR == "X" ){
        object<- bn
        betasobj  <- betas(object)[,]
        seabi( betasobj, stop, sex, X )
    }
) # AS - OK

#genki <- function(bn, g=getsnp(rownames(bn)), se=TRUE ){
setMethod(
    f = "genki",
    signature(bn = "gds.class"),
    definition = function(bn, se = TRUE){
        genki(betas(bn))
#        g <- wateRmelon::getsnp(rownames(object))
#        bn <- betas(object)[g, ,name = TRUE, drop = FALSE]
#        g <- 1:length(g)
#        genki(bn, g, se)
    }
) # AS - OK

setMethod(
    f= "genki",
    signature(bn="gdsn.class"),
    definition=function(bn, se = TRUE){
        object <- bn
        g <- getsnp(rownames(object))
        bn <- object[g, , name = TRUE, drop = FALSE]
        g <- 1:length(g)
        genki(bn, g, se)
    }
)

setGeneric("fot", function(x){standardGeneric("fot")})
setMethod(
    f='fot',
    signature(x='gds.class'),
    definition = function(x){
        fd <- fData(x)
        # Create ambiguous search for Design or Type in fData - to fix minfi normalisation...
        ds <- grep("(DESIGN|TYPE)", colnames(fd), ignore.case = TRUE)
        return(fd[,ds[1]])
    }
    )
# }}}

setGeneric('predictSex', function(x, x.probes=NULL, pc=2, plot=T, irlba=T, center=F, scale.=F){standardGeneric('predictSex')}) #{{{
setMethod(
    f = 'predictSex',
    signature(x = 'gds.class'),
    definition = function(x, x.probes, pc=2, plot=TRUE, irlba=TRUE, center=FALSE, scale. = FALSE){
    if(is.null(x.probes)) stop('Please provide an index for x chromosomes probes')
    predictSex(x = bigmelon::betas(x), x.probes=x.probes, pc, plot, irlba, center, scale.)
}
)

setMethod(
    f = 'predictSex',
    signature(x = 'gdsn.class'),
    definition = function(x, x.probes, pc=2, plot=TRUE, irlba=TRUE, center=FALSE, scale. = FALSE){
    if(is.null(x.probes)) stop('Please provide an index for x chromosomes probes')
    if(is.logical(x.probes)) x.probes <- which(x.probes)
    xdat <- na.omit(x[x.probes,])
    predictSex(x=xdat, x.probes = NULL, pc, plot, irlba, center, scale.)
}
)
#}}}

gds2mlumi <- function(gds, i, j){
    history.submitted = as.character(Sys.time())
    x <- gds
    if("NBeads"%in%ls.gdsn(x)){
        aDat <- assayDataNew(
                    betas = x[i, j, node = "betas",
                                name = TRUE, drop = FALSE],
                    pvals = x[i, j, node = "pvals",
                                name = TRUE, drop = FALSE],
                    NBeads = x[i, j, node = "NBeads", 
                                name = TRUE, drop = FALSE],
                    methylated = x[i, j, node = "methylated", 
                                    name = TRUE, drop = FALSE],
                    unmethylated = x[i, j, node = "unmethylated", 
                                        name = TRUE, drop = FALSE])
    } else {
        aDat <- assayDataNew(
                    betas = x[i, j, node = "betas",
                                name = TRUE, drop = FALSE],
                    pvals = x[i, j, node = "pvals",
                                name = TRUE, drop = FALSE],
                    methylated = x[i, j, node = "methylated",
                                    name = TRUE, drop = FALSE],
                    unmethylated = x[i, j, node = "unmethylated",
                                        name = TRUE, drop = FALSE])
    }
    # Creating MethyLumiSet
    x.lumi = new("MethyLumiSet", assayData=aDat)
    pdat <- pData(x)
    rownames(pdat) <- colnames(x)
    pData(x.lumi) <- pdat[j, , drop = FALSE]
    fdat <- fData(x)
    rownames(fdat) <- rownames(x)
    fData(x.lumi) <- fdat[i, , drop = FALSE]
    if(length(grep("QC", ls.gdsn(x), ignore.case = TRUE))>1){
        qcm <- QCmethylated(x)
        qcu <- QCunmethylated(x)
        colnames(qcm) <- colnames(qcu) <- colnames(x)
        rownames(qcm) <- rownames(qcu) <- QCrownames(x)
        qc <- new("MethyLumiQC",
                    assayData = assayDataNew(
                        methylated = qcm[ , j, drop = FALSE],
                        unmethylated = qcu[ , j, drop = FALSE])
                    )
        x.lumi@QC <- qc
    }
    # Forgotton things: 
    #  x.lumi@protocolData <- protocolData(NChannelSet)
    #  x.lumi@annotation <- annotation(NChannelSet)
    #  x.lumi@QC@annotation <- annotation(NChannelSet)
    # fvarLabels(x.lumi) <- possibleLabels[1:ncol(fdat)]
    # fvarMetadata(x.lumi)[,1] <- possibleMetadata[1:ncol(fdat)]
    # pval.detect(x.lumi) <- pval # default value
    history.finished <- as.character(Sys.time())
    history.command <- "Converted to methylumi with gds2mlumi (bigmelon)"
    x.lumi@history <- rbind(getHistory(x), 
                            data.frame( submitted = history.submitted, 
                                        finished = history.finished,
                                        command = history.command))
#    rownames(x.lumi) <- rownames(x)[i]
    return(x.lumi)
}

gds2mset <- function(gds, i, j, anno = NULL){ 
    x <- gds
    if(!is.null(anno)){ 
        if(!anno %in% c("27k", "450k", "epic")){
        stop("anno needs to be: \'27k\', \'450k\', \'epic\'")
        }
    }
    M <- x[i = i, j = j,   "methylated", name = TRUE, drop = FALSE]
    U <- x[i = i, j = j, "unmethylated", name = TRUE, drop = FALSE]
    pd <- pData(x)[j, , drop = FALSE]
    rownames(pd) <- colnames(x)[j]
    #    pd <- annotatedDataFrameFrom(object = as.matrix(pd), byrow = TRUE)
    if(!is.null(anno)){
        if(anno == "27k"){
            anno <- c("IlluminaHumanMethylation27k", "ilmn12.hg19")
        } else if(anno == "450k"){ 
            anno <- c("IlluminaHumanMethylation450k", "ilmn12.hg19")
        } else if(anno == "epic"){ 
            anno <- c("IlluminaHumanMethylationEPIC", "ilmn12.hg19")
        } else if(anno == "unknown"){
            anno <- c("Unknown", "Unknown")
        }
    }
    # Guess Array Type - will not get correct array if performed on subset.
    if(is.null(anno)){
        nr <- nrow(fData(x))
        # Will guess array type based on number of rows, will fail on subsets!
        if(nr > 50000 & nr < 500000){
            anno <- c("IlluminaHumanMethylation450k", "ilmn12.hg19")
        } else if(nr >= 500000){ 
            anno <- c("IlluminaHumanMethylationEPIC", "ilmn12.hg19")
        } else if(nr <=50000){ 
            anno <- c("IlluminaHumanMethylation27k", "ilmn12.hg19")
        }
    }
    names(anno) <- c("array", "annotation")
    out <- MethylSet(Meth = M, Unmeth = U, colData = pd, annotation = anno)
    out@preprocessMethod <- c(
        rg.norm = "Converted from gdsfmt to MethylSet (bigmelon)",
        minfi = as.character(packageVersion("minfi")),
        manifest = NA #packageVersion(getManifest(anno))
        )
    out
}

getpheno <- function(geo){
    a <- GEOquery::getGEO(geo, destdir = paste0("./",geo), GSEMatrix=T,getGPL=F )
    pd <- phenoData(a[[1]])@data
    write.csv(pd, file=paste0('./',geo,'/',geo,'pheno.csv'))
    message('Removing unpacked files!')
    leftovers <- dir(paste0("./",geo), recursive = TRUE)[grepl(".gz", dir(paste0("./",geo), recursive = TRUE))]
    file.remove(paste0("./",geo,'/',leftovers))
    return(pd)
}

geotogds <- function(geo, gds=NULL, method = "wget", keepidat = F, keeptar = F, ...){
    if(is.null(gds)) gds <- sprintf('%s.gds', geo)
    if(!(grepl(x = geo, pattern='.tar.gz'))){
        url <- sprintf("https://www.ncbi.nlm.nih.gov/geo/download/?acc=%s&format=file", geo)
        tarfile <- sprintf("./%s.tar.gz", geo)
        message('Downloading %s to %s', geo, tarfile)
        download.file(url, destfile = tarfile, method = method, quiet = FALSE)
    } else {
        tarfile <- geo
        geo <- gsub('tar.gz', '', geo)
    }
    dest <- sprintf('./%s', geo)
    message(sprintf('Unpacking file to %s', geo))
    untar(tarfile, exdir = dest)
    message('Enumerating .idats!')
    barsgz <- dir(dest, recursive = TRUE)[grepl(".idat.gz", dir(dest, recursive = TRUE))]
    message('Unpacking %s .idat files', length(barsgz))
    for(z in barsgz){
        GEOquery::gunzip(filename = paste0(dest, "/", z), destname = paste0(dest, "/", gsub(x = z, pattern = ".gz", replacement='')), remove = TRUE)
    }
    # if(tidy){
    message('Removing packed files!')
    leftovers <- dir(dest, recursive = TRUE)[grepl(".gz", dir(dest, recursive = TRUE))]
    file.remove(paste0(dest,'/',leftovers))
    # }

    pda <- getpheno(geo)
    message('Reading Data!')
    gds <- iadd2(path = dest, gds = gds, ...)
    newpd <- try(cbind(pData(gds),pda), silent=T)
    if(!inherits(newpd, 'try-error')){
    add.gdsn(gds, name="pData", valdim=dim(newpd),
                    val=data.frame(lapply(newpd, as.character),
                            stringsAsFactors = FALSE), replace=TRUE)
                        }
    gc() # Release Mem
    if(!keepidat){
    message('Removing idats folder')
    unlink(dest, recursive = T, force = T)
    }
    if(!keeptar){
    message('Removing tar')
    file.remove(tarfile)
    }
    return(gds)
}

# Get quantiles of (pre/un)normalized node.
getquantiles <- function(gds, node, perc, onetwo, rank = FALSE, new.node = NULL){
    x <- index.gdsn(gds, node)
    ranked <- get.attr.gdsn(x)[['ranked']]
    if(!is.null(ranked)){
        out <- list(quantiles = get.attr.gdsn(x)[['quantiles']],
                    inter = get.attr.gdsn(x)[['inter']],
                    onetwo = get.attr.gdsn(x)[['onetwo']])
        return(out)
    } else {
       out <- getquantilesandranks(gds = gds, node = node, onetwo = onetwo, perc = perc, rank.node = NULL)
       return(out)
    }
}

# EstimateCellCounts.gds
estimateCellCounts.gds <- function(
    gds,
    gdPlatform = c("450k", "EPIC", "27k"),
    mn = NULL,
    un = NULL,
    bn = NULL,
    perc = 1,
    compositeCellType = "Blood",
#    processMethod = "auto",
    probeSelect = "auto",
    cellTypes = c("CD8T","CD4T","NK","Bcell","Mono","Gran"),
    referencePlatform = c("IlluminaHumanMethylation450k",
        "IlluminaHumanMethylationEPIC",
        "IlluminaHumanMethylation27k"),
    returnAll = FALSE,
    meanPlot = FALSE,
    verbose = TRUE,
    ...) {
    # My shameless /scopy/s implmentation of minfi::estimateCellCounts
    # For those who do not want use minfi::read.metharray
    referencePlatform <- match.arg(referencePlatform)
    rgPlatform <- gdPlatform <- match.arg(gdPlatform)
    if(rgPlatform == 'EPIC') rgPlatform <- '450k'
    # No method in bigmelon to derive annotation from object, therefore specify.
    # Sanity Checking from minfi...
    if((compositeCellType == "CordBlood") && (!"nRBC" %in% cellTypes)){
        message("[estimateCellCounts] Consider including 'nRBC' in argument 'cellTypes' for cord blood estimation.\n")
    }
    referencePkg <- sprintf("FlowSorted.%s.%s", compositeCellType, rgPlatform)
    if(!require(referencePkg, character.only = TRUE)){
        stop(sprintf("Could not find reference data package for compositeCellType '%s' and referencePlatform '%s' (inferred package name is '%s')",
                     compositeCellType, rgPlatform, referencePkg))
    }
    data(list = referencePkg)
    referenceRGset <- get(referencePkg)
    if(! "CellType" %in% names(colData(referenceRGset)))
        stop(sprintf("the reference sorted dataset (in this case '%s') needs to have a phenoData column called 'CellType'"),
             names(referencePkg))
    if(sum(colnames(gds) %in% colnames(referenceRGset)) > 0)
        stop("the sample/column names in the user set must not be in the reference data ")
    if(!all(cellTypes %in% referenceRGset$CellType))
        stop(sprintf("all elements of argument 'cellTypes' needs to be part of the reference phenoData columns 'CellType' (containg the following elements: '%s')",
                     paste(unique(referenceRGset$cellType), collapse = "', '")))
    if(length(unique(cellTypes)) < 2)
        stop("At least 2 cell types must be provided.")
    # Here is where things get different.
    # First assumption: Data is prenormalized - we will assume dasen is used.
    # Bigmelon has a wrapper that enables the quantification of quantiles for both M and U without having to rerank and re-sort data.
    # Therefore, bigmelon will check if quantiles have been computed already.
    if(is.null(mn) & !'mnsrank'%in% ls.gdsn(gds)) mn <- 'methylated'
    if(is.null(mn) & 'mnsrank' %in% ls.gdsn(gds)) mn <- 'mnsrank'
    if(is.null(un) & !'unsrank'%in% ls.gdsn(gds)) un <- 'unmethylated'
    if(is.null(un) & 'unsrank' %in% ls.gdsn(gds)) un <- 'unsrank'
    if(is.null(bn)) bn <- 'betas'
    referencePd <- colData(referenceRGset)
    referenceMset <- preprocessRaw(referenceRGset)
    if(gdPlatform == 'EPIC'){
    message('No Reference Set of EPIC, converting array to 450k...')
    message('This method is NOT memory efficient!')
    M <- gds[rownames(referenceMset), , node = mn]
    U <- gds[rownames(referenceMset), , node = un]
    rownames(M) <- rownames(U) <- rownames(referenceMset)
    ot <- getProbeType(referenceMset)
    sMI <- wateRmelon:::.normalizeQuantiles2(M[ot=='I',])
    sMII <- wateRmelon:::.normalizeQuantiles2(M[ot=='II',])
    sUI <- wateRmelon:::.normalizeQuantiles2(U[ot=='I',])
    sUII <- wateRmelon:::.normalizeQuantiles2(U[ot=='II',])
    mquan <- list(quantiles = rep(0, nrow(M)),
                    inter = rep(0, nrow(M)),
                    onetwo = ot
                )
    mquan[['quantiles']][ot == 'I'] <- sMI[[1]]
    mquan[['inter']][ot == 'I'] <- sMI[[2]]
    mquan[['quantiles']][ot == 'II'] <- sMII[[1]]
    mquan[['inter']][ot == 'II'] <- sMII[[2]]
    uquan <- list(quantiles = rep(0, nrow(M)),
                    inter = rep(0, nrow(M)),
                    onetwo = ot)
    uquan[['quantiles']][ot == 'I'] <- sUI[[1]]
    uquan[['inter']][ot == 'I'] <- sUI[[2]]
    uquan[['quantiles']][ot == 'II'] <- sUII[[1]]
    uquan[['inter']][ot == 'II'] <- sUII[[2]]
    mquan[['rn']] <- uquan[['rn']] <- rownames(M)

    } else {
    ot <- fot(gds)
    mquan <- getquantiles(gds = gds, node = mn, onetwo = ot, perc = perc)
    # rownames not working(?)
    mquan[['rn']] <- read.gdsn(index.gdsn(gds,read.gdsn(index.gdsn(gds, "paths"))[1]))
    uquan <- getquantiles(gds = gds, node = un, onetwo = ot, perc = perc)
    # rownames not working(?)
    uquan[['rn']] <- read.gdsn(index.gdsn(gds,read.gdsn(index.gdsn(gds, "paths"))[1]))
    # We can skip combining data-sets.
    # Instead preprocessRaw reference to replace data with quantiles.
    }
    nmet <- wateRmelon:::.impose(getMeth(referenceMset), mquan)
    nume <- wateRmelon:::.impose(getUnmeth(referenceMset), uquan)
    rm(referenceRGset)

    # Everything else continues as normal.
    referenceMset <- minfi::MethylSet(Meth=na.omit(nmet), Unmeth=na.omit(nume), colData=referencePd, annotation(referenceMset))

    if(verbose) message("[estimateCellCounts] Picking probes for composition estimation.\n")
    compData <- minfi:::pickCompProbes(referenceMset, cellTypes = cellTypes, compositeCellType = compositeCellType, probeSelect = probeSelect)
    coefs <- compData$coefEsts
    rm(referenceMset)

    if(verbose) message("[estimateCellCounts] Estimating composition.\n")
    coefdat <- gds[rownames(coefs),,node=bn]
    rownames(coefdat) <- rownames(coefs)
    counts <- minfi:::projectCellType(coefdat, coefs)
    # counts <- minfi:::projectCellType(gds[rownames(coefs), , node = bn ], coefs)
    if (meanPlot) {
        smeans <- compData$sampleMeans
        smeans <- smeans[order(names(smeans))]
        sampleMeans <- c(colMeans(gds[rownames(coefs),, node = bn]), smeans)
        sampleColors <- c(rep(1, ncol(coefdat)), 1 + as.numeric(factor(names(smeans))))
        plot(sampleMeans, pch = 21, bg = sampleColors)
        legend("bottomleft", c("blood", levels(factor(names(smeans)))),
               col = 1:7, pch = 15)
    }
    if(returnAll) {
        list(counts = counts, compTable = compData$compTable)
    } else {
        counts
    }
}

es2gds <- function(m, file, qc = TRUE){
    # Not memory efficient as we are working from
    # pre-loaded Expression Set derivatives.
    history.submitted <- as.character(Sys.time())
    if(!inherits(m, c('MethylSet', 'MethyLumiSet', 'RGChannelSet'))){
        stop(paste(deparse(substitute(m)),
            "is not a MethyLumiSet or MethylSet or RGChannelSet object"))
    }
    if(!(file_test('-f', file))){
        message(paste(file, "doesn't exist, creating new file"))
        bmln <- newgds(file)
    } else if ( (file_test('-f', file))){
        stop('File already exists')
    }
    # methylumi set method
    if(inherits(m, 'MethyLumiSet')){
        # check for existence of file
        # todo: check sample names for overlap
        if(exists("betas", assayData(m))){
            message('betas... ' )
            add.gdsn(bmln, "betas", val = betas(m))
        }
        if(exists("pvals", assayData(m))){
            message('pvals... ' )
            add.gdsn(bmln, "pvals", val = pvals(m))
        }
        if(exists("methylated", assayData(m))){
            message('methylated... ' )
            add.gdsn(bmln, "methylated", val = methylated(m))
        }
        if(exists("unmethylated", assayData(m))){
            message('unmethylated... ' )
            add.gdsn(bmln, "unmethylated", val = unmethylated(m))
        }
        if(exists("NBeads", assayData(m))){
            message('NBeads... ' )
            add.gdsn(bmln, "NBeads", val = assayDataElement(m, "NBeads"))
        }
        message('fData... ' )
        # deal with empty column names in fData
        nb_col <- which(colnames(fData(m)) == "")
        colnames(fData(m))[nb_col] <- nb_col
        add.gdsn(bmln, "fData",
        val = data.frame(lapply(fData(m), as.character),
                stringsAsFactors = FALSE), check = FALSE)
        message('pData... ' )
        add.gdsn(bmln, "pData",
        val = data.frame(lapply(pData(m), as.character),
                stringsAsFactors = FALSE))
        message('qcdata... ' )
        if(qc){
            if(!is.null(m@QC)){
                add.gdsn(bmln, "QCmethylated",
                        val = a <- methylated(QCdata(m)))
                add.gdsn(bmln, "QCunmethylated",
                        val = unmethylated(QCdata(m)))
                add.gdsn(bmln, "QCrownames", val = rownames(a))
            } else {
                message('   ... skipped')
            }
        }
        message('finished creating gdsfile' )
        add.gdsn(bmln, "history",
        val = data.frame(lapply(m@history, as.character),
                        stringsAsFactors = FALSE))
        history.command <- "MethylumiSet converted to gds (bigmelon)"
        history.finished <- as.character(Sys.time())
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE)
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/", j, sep = "")
            h_child_n <- index.gdsn(bmln, h_index_str, silent = TRUE)
            append.gdsn(h_child_n, val = h[ ,h_coln])
        }
    }
    #BEGIN Minfi Methods
    # BEGIN MethylSet method
    if(inherits(m, 'MethylSet')){
        # Betas
        message('betas... ' )
        add.gdsn(bmln, "betas", val = getBeta(m))
        # M
        message('methylated... ' )
        add.gdsn(bmln, "methylated", val = getMeth(m))
        # U
        message('unmethylated... ' )
        add.gdsn(bmln, "unmethylated", val = getUnmeth(m))
        # fData
        message('fData... ')
        fd <- data.frame(lapply(getAnnotation(m), as.character),
                stringsAsFactors = FALSE)
        add.gdsn(bmln, "fData", val = fd, check = FALSE)
        message('pData... ')
        # Assuming data-less pData(m)
        pd <- data.frame(lapply(cbind(rownames(colData(m)), colData(m)),
                        as.character), stringsAsFactors = FALSE)
        colnames(pd) <- c("barcode", colnames(colData(m)))
        add.gdsn(bmln, "pData", val = pd)
        # QC
        if(qc){
            message('qcdata... ')
            message('    ... skipped')
        }
        message('finished creating gdsfile' )
        add.gdsn(bmln, "history",
        val = data.frame(lapply(data.frame(submitted = "",
                                            finished = "",
                                            command = ""),
                            as.character), stringsAsFactors = FALSE))
        history.command <- "MethylSet converted to gds (bigmelon)"
        history.finished <- as.character(Sys.time())
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE)
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/", j, sep = "")
            h_child_n <- index.gdsn(bmln, h_index_str, silent = TRUE)
            append.gdsn(h_child_n, val = h[ ,h_coln])
        }
    # END MethylSet Method
    # BEGIN RGChannelSet method
    }
    if(inherits(m, 'RGChannelSet')){
        m2 <- preprocessRaw(m)
        message('betas... ')
        add.gdsn(bmln, "betas", val = getBeta(m2))
        message('methylated... ')
        add.gdsn(bmln, "methylated", val = getMeth(m2))
        message('unmethylated... ')
        add.gdsn(bmln, "unmethylated", val = getUnmeth(m2))
        if(inherits(m, 'RGChannelSetExtended')){
            message('pvals... ')
            add.gdsn(bmln, "pvals", val = detectionP(m))
            message('NBeads... ')
            add.gdsn(bmln, "NBeads", val = as.matrix(beadcount(m)))
        }
        message('fData... ')
        fd <- data.frame(lapply(getAnnotation(m), as.character),
                            stringsAsFactors = FALSE)
        add.gdsn(bmln, "fData", val = fd,check = FALSE)
        message('pData... ')
        pd <- data.frame(lapply(cbind(rownames(colData(m)), colData(m)),
                            as.character), stringsAsFactors = FALSE)
        colnames(pd) <- c("barcode", colnames(colData(m)))
        add.gdsn(bmln, "pData", val = pd)
        message('qcdata... ')
        if(qc){
            ctrls <- getProbeInfo(m, type = "Control")
            ctrls <- ctrls[ctrls$Address %in% rownames(m), ]
            add.gdsn(bmln, "QCmethylated",
                        val = a <- getGreen(m)[ctrls$Address, ])
            add.gdsn(bmln, "QCunmethylated",
                        val = getRed(m)[ctrls$Address, ])
            add.gdsn(bmln, "QCrownames", val = rownames(a))
        } else {
            message('     ...skipped')
        }
        message('finished creating gdsfile' )
        add.gdsn(bmln, "history",
                    val = data.frame(lapply(data.frame(submitted = "",
                                                    finished = "",
                                                    command = ""),
                        as.character), stringsAsFactors = FALSE)
                )
        history.command <- "RGChannelSet converted to gds (bigmelon)"
        history.finished <- as.character(Sys.time())
        h <- data.frame(submitted = history.submitted,
                        finished = history.finished,
                        command = history.command,
                        stringsAsFactors = FALSE)
        for(j in colnames(h)){
            h_coln <- j
            h_index_str <- paste("history/", j, sep = "")
            h_child_n <- index.gdsn(bmln, h_index_str, silent = TRUE)
            append.gdsn(h_child_n, val = h[ ,h_coln])
        }
    # END RGChannelSet(Extended) Method
    }
    # Point to rowcol
    # Search non-specifically for potential row and colnames
    rown <- list()
    # Change search terms - in any event!
    for(i in c("targetID", "name", "Probe_ID")){
        rown[[i]] <- grep(i, ls.gdsn(index.gdsn(bmln, "fData")),
                            ignore.case = TRUE)
    }
    rowna <- ls.gdsn(index.gdsn(bmln, "fData"))[unlist(rown)[1]]
    coln <- list()
    # Change search terms - in any event!
    for(i in c("sampleID", "barcode", "name")){
        coln[[i]] <- grep(i, ls.gdsn(index.gdsn(bmln, "pData")),
                            ignore.case = TRUE)
    }
    colna <- ls.gdsn(index.gdsn(bmln, "pData"))[unlist(coln)[1]]
    message('Directing \'rownames\' to ', paste0("fData/", rowna),
            ' by default, change with redirect.gds if incorrect.')
    message('Directing \'colnames\' to ', paste0("pData/", colna),
            ' by default, change with redirect.gds if incorrect.')
    add.gdsn(bmln, "paths", val = c(paste0("fData/", rowna),
                                    paste0("pData/", colna)))
    bmln
}

%\VignetteIndexEntry{The bigmelon Package}
%\VignetteKeywords{Illumina DNA methylation 450k array normalization epic}
%\VignettePackage{bigmelon}
% Sweave Vignette Template derived bt Leo Schalkwyk from
%% www.bioconductor.org/help/course-materials/2010/AdvancedR/BuildPackage.pdf
\documentclass[11pt]{article}

<<style-Sweave, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

%\newcommand{\Rfunction}[1]{{\texttt{#1}}}
%\newcommand{\Robject}[1]{{\texttt{#1}}}
%\newcommand{\Rpackage}[1]{{\textit{#1}}}
%\newcommand{\Rclass}[1]{{\textit{#1}}}

\title{The bigmelon Package}
\author{Tyler Gorrie-Stone, Ayden Saffari, Karim Malki and Leonard C Schalkwyk}
\begin{document}
\SweaveOpts{concordance=TRUE}
\maketitle
\section{About}
The \Rpackage{bigmelon} package for Illumina methylation data provides
a fast and convenient way to apply a variety of different normalisation methods
to your data, such as those previously described by Pidsley et al. [1]
and implemented in the package \Rpackage{wateRmelon}. Bigmelon extends the
capabilities of the \Rpackage{wateRmelon} to higher dimensional data, allowing
larger data sets containing many more arrays to be processed simultaneously, while also
providing convenient storage for data for future access and sharing with peers.
This has been achieved by adapting methods from the \Rpackage{gdsfmt} package, originally
designed for handling SNP data, which through efficient memory use and
management is able to overcome the memory overheads associated
with handling big data in \R{}.\\

\section{Quick-Start}
This section will briefly describe how to import, access and 'analyse'
data using bigmelon and the gds file format. All the functions described in this section are described in full in the later portions of this document.

<<code-block, keep.source=TRUE>>=
library(bigmelon)
data(melon)
# Convert methylumiset or methylset objects to .gds
gfile <- es2gds(melon, 'melon.gds')
# 'melon.gds' file created in current working directory
dir()
# Access data with:
betas(gfile)
# OR
index.gdsn(gfile, 'betas')
# Get betas with '[' notation
betas(gfile)[1:5,1:5]
# Or call from gfile
gfile[1:5, 1:5, node = 'methylated']
# Preprocess data with pfilter and dasen
pfilter(gfile)
dasen(gfile)
# Note you do not have to store the output
# because the functions make changes to disk

# Use apply.gdsn (or clusterApply.gdsn) to perform apply-like operations
meth <- methylated(gfile)
apply.gdsn(meth, 2, median, as.is='double', na.rm = TRUE)

# Calculating Horvath's epigenetic ages with agep
data(coef)
agep(gfile, coeff=coef)

# Close .gds file
closefn.gds(gfile)
# Open a .gds file
gfile <- openfn.gds('melon.gds')
@

<<UnseenCodeAndOutput, echo=FALSE>>=
closefn.gds(gfile)
unlink('melon.gds', force = TRUE)
@

\section{Installation}
\Rpackage{bigmelon} works with existing \Bioconductor{} packages and therefore
has a number of dependencies. The install.packages() should install the
required packages automatically, but should this not succeed for any reason,
the following commands can be used to install these manually:

<<UnevaluatedCode, eval=FALSE>>=
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install('wateRmelon', 'gdsfmt')
@

Install the latest package from a local copy (located in the current working
directory of your R session):

<<UnevaluatedCode, eval=FALSE>>=
install.packages('bigmelon_0.99.11.tar.gz', repos = NULL, type = 'source')
@

\section{Using Bigmelon}
\subsection{Loading Data to gds format}

There are multiple methods that can be used to load in
data into a gds object. These can either be from GenomeStudio
final report text files or from raw binary (.IDAT) files (preferred method).

\subsubsection{IDAT Files}
IDAT files are the raw intensities obtained from DNA methylation microarrays
and are split into two files per sample (one Red Channel and
one Green Channel). These are read into R using \Rpackage{minfi} or
\Rpackage{methylumi}. In \Rpackage{bigmelon} IDAT files can be read in using
the \Rfunction{iadd} or \Rfunction{iadd2} functions. These functions pass to
\Rfunction{methylumIDATepic} (from \Rpackage{wateRmelon}) to read in the data -
although it should be noted that the full annotation of the features are not
included when reading from idats. And can be added to the

\Rfunction{iadd} and \Rfunction{iadd2} function differently. \Rfunction{iadd}
will take a vector of barcodes, \Rfunction{iadd2} will accept a directory
pathway and extract all IDAT files within the specified path. You will need to be in the same directory as the idat files for this to work.

\Rfunction{iadd2} also has the functionality to read IDAT files in
chunks. This is useful if you are attempting to read in a lot of data at
once and do not have sufficient memory on your workstation to support this.
\textbf{This method is recommended if you are using a workstation
bounded by memory limitations.}
<<UnevaluatedCode, eval=FALSE>>=
# read in an IDAT file with barcode 'sentrixid_rnncnn'
gfile <- iadd('sentrixid_rnncnn', gds = 'melon.gds')
gfile <- iadd2('Data/IDATLocations/dataset', gds = 'melon.gds', chunksize = 100)
@

\subsubsection{ExpressionSet Objects}
You may have been given a \Rclass{MethylumiSet}, \Rclass{RGChannelSet}
or \Rclass{MethylSet} instead of idats. These can be passed to
\Rfunction{es2gds} to convert the data into a \Rclass{gds.class}. Such circumstance can arise when one wants to use a particular normalisation methodology only available to specific packages.

Henceforth we will convert the ExpressionSet data object 'melon' packaged
within \Rpackage{wateRmelon} to demonstrate further down stream analysis.

<<code-block, keep.source=TRUE>>=
data(melon)
gfile <- es2gds(melon, 'melon.gds')
@

\subsubsection{Text Files}
To read in text files, the \Rfunction{methyLumiR} function from
\Rpackage{methylumi} can be used.
If using this method, we suggest saving the
unnormalised, uncorrected version of the data. We also
recommend keeping the barcode names
(SentrixID\_RnnCnn) as the column headers or in a separate
dataframe.
Alternatively you can use the function \Rfunction{finalreport2gds} that will
output a .gds object.

<<UnevaluatedCode, eval=FALSE>>=
library(methylumi)
# read Illumina methylation data into a MethyLumiSet object
melon <- methyLumiR('finalreport.txt')
# read Illumina methylation final report into a gds.class object.
gfile <- finalreport2gds('finalreport.txt', gds='melon.gds')
@

Assuming you have used \Rfunction{methyLumiR} you would then need to
convert the resultant object to a Genomic Data Structure (GDS) data file.
This can also be achieved using the function \Rfunction{es2gds} which can
convert \Rclass{MethyLumiSet} objects (from \Rpackage{methylumi},
\Rclass{RGChannelSet} and \Rclass{MethylSet} objects (from \Rpackage{minfi})
as described above.

<<UnevaluatedCode, eval=FALSE>>=
# convert a MethyLumiSet object to a gds.class object
gfile <- es2gds(melon, 'melon.gds')
@

\section{Opening and Closing gds files}
Now that you have created a .gds file you can continue working on it within
the same R session. Or close the file for later use, or to share with others.

The functions \Rfunction{openfn.gds} and \Rfunction{closefn.gds} are used.
<<UnevaluatedCode, eval=FALSE>>=
# Closing File
closefn.gds(gfile)

# Opening File
gfile <- openfn.gds('melon.gds')
@
Recommended: See \Rfunction{?openfn.gds}
Generally only one instance of a gds can be opened per R session, this can be disabled by setting allow.fork and allow.duplicate arguments in \Rfunction{openfn.gds} to TRUE.

\section{Exploring the \Rclass{gds.class}}
The resulting \Rclass{gds.class} may be different to any other data-structure
you have previously used. Simply, it resembles an S4 object but instead of slots
there are nodes with a \Rclass{gdsn.class} class. To access these,
specialized functions need to be used as common R functionality ({@} and {\$})
are not yet existent for these objects.

When printing the \Rclass{gds.object} we are given an almost directory-like
output.

<<code-block, keep.source=TRUE>>=
print(gfile)
@

From this output we can see some useful information about our object such as
the file name, total object size and the name, size and type of each node
within the gds object.

Typically a \Rpackage{bigmelon} gds file is comprised of some common nodes
these being: betas, methylated, unmethylated, pvals, fData, pData, and History.
If you are familiar with the \Robject{MethyLumiSet} this will be immediately
familiar to you.
If not a brief description is as follows
\begin{itemize}
\item{ betas: The ratio between Methylated and Unmethylated intensities -
most commonly used for analysis}
\item{ methylated: The methylated intensities}
\item{ unmethylated: The unmethylated intensities}
\item{ pvals: The detection P values of the array }
\item{ NBeads(not shown): The total beadcount (per feature) on the array.}
\item{ fData: The feature data, which contains all relavent biological
information to CpG probes within the micro-array (rows).}
\item{ pData: The pheno data, which contains information relevant to
biological samples (columns).}
\item{ history: Brief description of operations applied to the file.}
\end{itemize}

To access the data represented in the object we need to use the function
\Rfunction{index.gdsn}
<<code-block, keep.source=TRUE>>=
index.gdsn(gfile, 'betas')
class(index.gdsn(gfile, 'betas'))
# Access nodes with additional nodes inside
index.gdsn(gfile, 'fData/TargetID')
@

Alternatively, there are some accessors written for the common object names
see \Rfunction{?'bigmelon-accessors'}.
Majority of these accessors will pass to \Rfunction{index.gdsn} but if
the object is small enough the accessor may
read the object into memory without further indexing.
<<code-block, keep.source=TRUE>>=
betas(gfile)
class(betas(gfile))
@

If the directory-tree output is hard to interpret or you wish to list all
available nodes the function \Rfunction{ls.gdsn}
allows you to view the contents of a gds file in a vector.
<<code-block, keep.source=TRUE>>=
ls.gdsn(gfile)
# Look into nodes with additional nodes
ls.gdsn(index.gdsn(gfile, 'fData'))
@

\subsection{Exploring the \Rclass{gdsn.class}}
You may ask the question - 'How do I access \textbf{that} juicy data?'.
To do this, the functions \Rfunction{read.gdsn} and
\Rfunction{readex.gdsn} are used. \Rfunction{read.gdsn} will load the entire
object represented in a gdsn.class object into memory.
While \Rfunction{readex.gdsn} allows you to specify a subset to
load into memory.

<<code-block, keep.source=TRUE>>=
# Call a gdsn.class node
anode <- betas(gfile)
anode
class(anode)
# All data
dat <- read.gdsn(anode)
dim(dat)
head(dat)
# Subset!
datsub <- readex.gdsn(anode, sel = list(1:5, 1:3))
dim(datsub)
datsub
@

You may immediately notice that the rownames and column names of the matrix
are missing.
This is an unfortunate side-effect of using \Rfunction{read.gdsn} because such
information is not stored within the specified gds node.
However within \Rpackage{bigmelon} we have written a wrapper-function for
\Rfunction{read.gdsn} (and \Rfunction{readex.gdsn})
to load data into R. This is achieved using \Rfunction{'['}. The purpose of
this is to enable similar indexing operations that most
will be familiar with.
<<code-block, keep.source=TRUE>>=
# Re-using node from previous example
anode
datsub <- anode[1:5,1:3]
dim(datsub)
datsub
# Additionally, the row and col names can be disabled
anode[1:5, 1:3, name = FALSE]
@
There are a few more tricks that are possible in \Rpackage{bigmelon} that we
will briefly explore here. Most of the indexing tricks that can be implements on matrices can be performed on gdsn.nodes.
<<code-block, keep.source=TRUE>>=
# Logical Indexing
anode[1:5,c(TRUE,FALSE,FALSE)]
# Ordering calls
anode[c(5,9,1,500,345), c(8,4,1,3)]
# Indexing by characters (and drop functionality)
anode[c('cg00000029', 'cg00000236'), '6057825008_R02C01', drop = FALSE]
# Loading entire data (no indexing)
dat <- anode[ , ] # Not recommended for large data.
dim(dat)
@

Additionally it is possible to call a gds node from a gds.class within the
\Rfunction{'['} indexing. This is particularly useful if you have a foreign matrix in your gds object with the name "foobar", it will be possible to implement the below structures to retrieve specific data.
<<code-block, keep.source=TRUE>>=
gfile[1:5, 1:3, node = 'betas', name = TRUE]
gfile[1:5, 1:3, node = 'methylated', name = TRUE]
@

As a brief side note, the row and column names are still stored within the
gds data file. Located at the bottom of each gds data file will be a node
labelled as "paths". This contains a string to where the row and column names
are stored. These are determined by default upon the creation of the gds
data file but in events where they are incorrect they can be corrected
with the \Rfunction{redirect.gds}.

<<code-block, keep.source=TRUE>>=
read.gdsn(index.gdsn(gfile, "paths"))
head(read.gdsn(index.gdsn(gfile, "fData/TargetID")))
head(read.gdsn(index.gdsn(gfile, "pData/sampleID")))
@

\section{Preprocessing}
\subsection{Quality Control}
Prior to data analysis, you may find it is necessary to perform some
quality control and normalization. Within bigmelon, we have some functions
can assist with the QC but you can use whatever functions you like.

Typical workflows involve visualizing raw intensities:
<<code-block, keep.source=TRUE>>=
rawmet <- methylated(gfile)[,]
rawume <- unmethylated(gfile)[,]
@

<<IncludeGraphic, fig=TRUE>>=
boxplot(log(rawmet), las=2, cex.axis=0.8)
@

<<IncludeGraphic1, fig=TRUE>>=
boxplot(log(rawume), las=2, cex.axis=0.8)
@

Alternatively it is possible to used some highly specialized functions
available within \Rpackage{bigmelon}.

<<code-block, keep.source=TRUE>>=
rawbet <- betas(gfile)[,]
@

<<IncludeGraphic2, fig=TRUE>>=
outlyx(rawbet, plot = TRUE)
@

If the data is too large to load into memory, one can use the
\Rpackage{bigmelon} method which determines outliers with a
small subset of data.

<<IncludeGraphic3, fig=TRUE>>=
outlyx(gfile, plot = TRUE, perc = 0.01)
@

Filtering probes/features by detection p-values also provides another
straightforward approach for removing both failed samples and probes.
The \Rfunction{pfilter} function discards samples with more than 1 \% of
probes above .05 detection p-value threshold, and probes with any samples
with beadcount under 3 or more than 1\% above the p-value threshold.

\textbf{n.b.} This will perform irreversible subsetting procedures onto
the gds file and will \textbf{not} work if the gds is in read mode.

<<code-block, keep.source=TRUE>>=
pfilter(gfile)
@
Alternatively if you do not wish to perform subsetting at this time one can use pfilter.gds to get the list of failed probes and use those for subsetting at a later time.

\subsection{Backing Up/Storing Raw data}
Before performing any function that will noticeably change the data, you may
want to create a physical back-up of the gds file so you do not have to
retrace your steps incase you lose progress. The \Rfunction{backup.gdsn}
function serves as an easy way to copy a node you may be interested in to
your gds file incase you need it for later.
<<code-block, keep.source=TRUE>>=
backup.gdsn(gds = NULL, node = index.gdsn(gfile, 'betas'))
ls.gdsn(index.gdsn(gfile, 'backup'))
@
Alternatively you can create a new gdsfile to store the copy or use
the \Rfunction{copyto.gdsn}.

<<code-block, keep.source=TRUE>>=
f <- createfn.gds('melon2.gds')
backup.gdsn(gds = f, node = index.gdsn(gfile, 'betas'))
f
copyto.gdsn(node = f, source = index.gdsn(gfile, 'betas'), name = 'betacopy')
f
copyto.gdsn(node = gfile, source = index.gdsn(gfile, 'betas'), name='betacopy')
# Close File
closefn.gds(f)
@
<<UnseenCodeAndOutput, echo=FALSE>>=
unlink('melon2.gds')
@

\subsection{Normalization}
Within \Rpackage{bigmelon} there are numerous normalisation methods that can
be used. The method \Rfunction{dasen} will work well for most data sets.
\textbf{n.b.} This will perform irreversible procedures on the data. And will
replace raw intensities with the normalised ones. This will not work if gds
file is in read mode.
<<code-block, keep.source=TRUE>>=
dasen(gfile)
# Alternatively it is possible to store normalized betas to a separate node
# If you want to keep the raw data
dasen(gfile, node="normbeta")
index.gdsn(gfile, "normbeta")
@

Due to how the normalisation process is broken down within \Rpackage{bigmelon}
there is only ever a small
amount of memory required throughout data analysis.
For example when attempting to process ~4000 EPIC array samples (>850,000
features), totalling around 28Gb of data. Simple quantile normalisation
procedures quickly use up all available memory to attempt such feat.
Whereas within bigmelon, the same analyses uses considerably less
memory and (in this circumstance) provide a 1000 fold decrease in memory use.
\includegraphics{logmemuse.pdf}

\section{Analysis}
While we cannot recommend any advice about how to perform your statistical
analysis we will demonstrate how to
make the most out of the \Rpackage{bigmelon} package.
Within \Rpackage{gdsfmt} there are many functions written that are specialized
for gds files.
Notably the \Rfunction{apply.gdsn} function is particularly useful as it will
perform functions upon specified margins efficiently instead of loading the
entire object into R to perform analysis.

<<code-block, keep.source=TRUE>>=
# Example of apply.gdsn
apply.gdsn(betas(gfile), margin = 2, as.is='double', FUN = function(x,y){
mean(x, na.rm=y)
}, y = TRUE)
@

Additional analyses that could be useful to an EWAS in particular are age 
prediction and estimating cell types, these can be done with \Rfunction{agep} 
and \Rfunction{estimateCellCounts.gds}

<<code-block, keep.source=TRUE>>=
# Age Prediction
data(coef) # Load up a set of coefficient (horvaths)
agep(gfile, coef) 
# Alternatively
agep(betas(gfile), coef) # or index.gdsn(gfile, 'foobar') for a different matrix
@



You can define your own functions to supply as an argument to FUN. Please do
explore \Rfunction{apply.gdsn} as it is extremely versatile and it can
additionally store outputs straight the a gds node if needed.

There will ofcourse be some analyses that may not be amenable to high
dimensional data but if analysis can be broken down into column/row wise
operations then it is possible.

Currently, all available methods within \Rpackage{wateRmelon} with the
exception of \Rfunction{seabi}, \Rfunction{swan}, \Rfunction{tost},
\Rfunction{fuks} and \Rfunction{BMIQ} have been optimised for memory usage.

\section{Back-Porting}
Should you find it necessary to convert your gds object back into memory
(perhaps for some specialised analyses) you can use the functions
\Rfunction{gds2mlumi} and \Rfunction{gds2mset} which will build a
\Robject{MethyLumiSet} object and \Robject{MethylSet} object in your
environment.
<<code-block, keep.source=TRUE>>=
gds2mlumi(gfile)
gds2mset(gfile, anno="450k")
@

\section{Adding additional objects to gds objects}
Often, it will be necessary to make use of a transformation while additionally preserving the original betas. This can be done using the add.gdsn which is described in the gdsfmt vignette in great detail.

\section{Finishing an R session}
As this workflow is in its infancy there are some issues that have yet to
be ironed out.
Notably there have been observed instances of data-loss when connection
to a gds file
has been interrupted without proper closure using \Rfunction{closefn.gds}.
As such it is \textbf{imperative}
that once you are ready to exit R, you must close the connection to the
gds file
and then exit R.

<<code-block, keep.source=TRUE>>=
# Closing the connection
closefn.gds(gfile)
@

<<UnseenCodeAndOutput, echo=FALSE>>=
unlink('melon.gds', force = TRUE)
@

\section{Session Info}
<<code-block, keep.source=TRUE>>=
sessionInfo()
@

\section{References}
[1] Pidsley R, Wong CCY, Volta M, Lunnon K, Mill J, Schalkwyk LC (2013)
A data-driven approach to preprocessing Illumina 450K methylation
array data. BMC genomics, 14(1), 293.

[2] Zheng X, Levine D, Shen J, Gogarten SM, Laurie C, Weir BS (2012)
A high-performance computing toolset for relatedness and principal component
analysis of SNP data. Bioinformatics, 28, 3326-3328.
\end{document}

% R CMD Sweave tut.Rnw
% R CMD texi2dvi --pdf --clean tut.tex
% R CMD Stangle tut.rnw

\name{dasenrank}
\alias{dasenrank}
\alias{computebeta.gds}
\title{
Dasen Quantile Normalization by storing ranks
}
\description{
This performs an experimental variant of dasen normalisation for .gds format objects which stores the ranks of the methylated
and unmethylated intensities inside of the normalised values and interpolates the quantiles when they are needed.

Notably this eliminates a secondary re-sorting pass which is required by quantile normalisatoin as it will be performed downstream using \code{computebeta.gds} which will produce normalise betas or manually with '[' which will access the ranks and interpolate the specific quantiles as needed.
}
\usage{
dasenrank(gds, mns, uns, onetwo, roco, calcbeta = NULL, perc = 1)
computebeta.gds(gds, new.node, mns, uns, fudge)
}
\arguments{
\item{gds}{
gds.class object which contains methylated and unmethylated intensities. The function will write two (four) nodes to this object called 'mnsrank' and 'unsrank' which contain the ranks of the given nodes.
}
\item{mns}{
gdsn.class object OR character string that refers to location in gds that relates to the (raw) methylated intensities.
}
\item{uns}{
gdsn.class object OR character string that refers to location in gds that relates to the (raw) unmethylated intensities.
}
\item{onetwo}{
gdsn.class object OR character string that refers to location in gds that contains information relating to probe design OR vector of length equal to the number of rows in the array that contains 'I' and 'II' in accordance to Illumina HumanMethylation micro-array design.
}
\item{roco}{
Sentrix (R0#C0#) position of all samples.
}
\item{calcbeta}{
Default = NULL, if supplied with a string, a new gdsn.node will be made with supplied string, which will contain the calculated betas.
}
\item{perc}{
A number between 0 and 1 that relates to the given proportion of columns that are used to normalise the data. Default is set to 1, but incase there are lots of samples to normalise this number can be reduce to increase speed of code.
}
\item{new.node}{
Character string depicting name of new betas node in given gds object.
}
\item{fudge}{ Arbitrary value to offset low intensities}
}
\details{
calcbeta is a known bottle-neck for this code! Also function is highly experimental.
}
\value{
Nothing is returned to the R environment, however the supplied gds will have 4 or 5 gdsn.nodes added. These are: 'mnsrank', 'unsrank', 'isnamnsrank' (hidden), 'isnaunsrank'(hidden) and calcbeta if supplied. 'mnsrank' and 'unsrank' have been given some attributes - which contain the calculated quantiles from \code{getquantilesandranks}.
}

\author{
Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}
%\seealso{
%}
\examples{
data(melon)
e <- es2gds(melon, "melon.gds")
#dasenrank(gds = e)
closefn.gds(e)
unlink("melon.gds")
}

\name{cantaloupe}
\alias{cantaloupe}
\alias{honeydew}
\docType{data}
\title{
Small MethyLumi 450k data sets for testing
}
\description{
Small MethyLumi 450k data sets intended for testing purposes only.
}
\usage{
data(cantaloupe)
data(honeydew)
}
\value{
Loads data into R
}
\format{
cantaloupe: MethyLumiSet with assayData containing 841 features, 3 samples.
honeydew: MethyLumiSet with assayData containing 841 features, 4 samples.
}

%\references{
%}
%\examples{
%}
\keyword{datasets}

\name{redirect.gds}
\alias{redirect.gds}

\title{
Change the location of the paths for row and column names in a gds file.
}

\description{
Change how a gds object ascribes row and column names by changing the paths node of a gds file.
Although a bit laborious, the row and column information is not preserved inside a node which contains data. Thusly
during accession the row and column names are attributed after data has been accessed.
}

\usage{
redirect.gds(gds, rownames, colnames)
}

\arguments{
\item{gds}{ \code{gds.class} object containing node named "paths".
}
\item{rownames}{ Character string that points to named part of supplied gds
that corresponds to rownames.
e.g. "fData/Target_ID". Default = "fData/Probe_ID"
}
\item{colnames}{ Character string that points to names part of supplied gds 
that corresponds to colnames.
e.g. "pData/Sample_ID". Default = "pData/barcode"
}
}

\value{
Changes the gdsn.class node named "paths" to supplied rownames and colnames 
within supplied gds.class object.
}

\details{
This function is particularly important within many functions inside bigmelon and
may lead to downstream errors if the row and column names are not correctly specified. 
If data is read in through es2gds the path nodex should be correctly set up and all downstream
analysis will carry out as normal.
Will fail noisily if given a pathway that does not exist.
}

\author{
Tyler J. Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

\seealso{
\code{\link[gdsfmt]{add.gdsn}}, \code{\link{app2gds}}, \code{\link{es2gds}}
}

\examples{
data(melon)
e <- es2gds(melon, "melon.gds") # Create gds object
redirect.gds(e, rownames = "fData/TargetID", colnames = "pData/sampleID")
# Deleting Temp files
closefn.gds(e)
unlink("melon.gds")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chainsaw.R
\name{dim.gds.class}
\alias{dim.gds.class}
\title{dim.gds.class  S3 method returning dimensions of data represented by a gds file handle.}
\usage{
\method{dim}{gds.class}(gfile, v = FALSE)
}
\description{
dim.gds.class  S3 method returning dimensions of data represented by a gds file handle.
}

\name{prcomp.gds.class}
\alias{prcomp.gds.class}
\alias{prcomp.gds}
\alias{prcomp, gds.class}
\alias{prcomp, gds.class-method}

\title{
Principal Component Analysis for high-dimensional data
}
\description{
Performs principal components analysis on the given
gds object and returns the results as an object of class "prcomp".
}
\usage{
\method{prcomp}{gds.class}(x, node.name, center = FALSE, scale. = FALSE,
rank. = NULL, retx = FALSE, tol = NULL, perc = 0.01,
npcs = NULL, parallel = NULL, method = c('quick', 'sorted'), verbose = FALSE, ...)
}

\arguments{
\item{x}{
A gds.class object.
}
\item{node.name}{
Name of the gdsn.class node to learn principal components from
}
\item{center}{
Logical value indicating whether variables should be shifted to be zero
centered.
}
\item{scale.}{
Logical value indicating whether the variables should be scaled to have unit
variance
}
\item{tol}{
a value indicating the magnitude below which components
should be omitted.
}
\item{rank.}{
(Still functional) Number of principal components to be returned
}
\item{retx}{
a logical value indicating whether the rotated variables
should be returned.
}
\item{perc}{
The percentage of the number of rows that should be used to calculate principle components. Ranging from 0 to 1, a value of 1 would indicicate all rows will be used.
}
\item{npcs}{
Number of principal components to be returned
}
\item{parallel}{
Can supply either a cluster object (made from makeCluster) or a integer describing the number of cores to be used.
This is only used if method="sorted".
}
\item{method}{
Indicates whhich method to use out of "quick" and "sorted". "quick" stochastically selects number of rows according to perc. And the supplies them to svd.
"sorted" determines the interquartile range for each row then selects the top percentage (according to perc) of probes with the largest interquartile range and supplies selected rows to svd.
}
\item{verbose}{
A logical value indicating whether message outputs are displayed.
}
\item{\dots}{
arguments passed to or from other methods. If "x" is a
formula one might specify "scale." or "tol".
}
}
\details{
The calculation is done by a singular value decomposition of the
(centered and possibly scaled) data matrix, not by using "eigen"
on the covariance matrix. This is generally the preferred method
for numerical accuracy. The "print" method for these objects
prints the results in a nice format and the "plot" method produces
a scree plot.
}
\value{
An object of prcomp class
}

\examples{
data(melon)
e <- es2gds(melon, "melon.gds")
prcomp(e, node.name="betas", perc=0.01, method='quick')
closefn.gds(e)
unlink("melon.gds")
}

\name{bumphunterEngine.gdsn}
\alias{bumphunterEngine.gdsn}
\alias{.getEstimate2}
\title{
Bumphunter using bigmelon
}
\description{
Estimate regions for which a genomic profile deviates from its baseline value. Originally implemented to detect differentially methylated genomic regions between two populations. Functions identically to \code{\link[bumphunter]{bumphunter}}. 
}
\usage{
bumphunterEngine.gdsn(mat, design, chr = NULL, pos, cluster = NULL, coef = 2, cutoff = NULL, pickCutoff = FALSE, pickCutoffQ = 0.99, maxGap = 500, nullMethod=c("permutation","bootstrap"), smooth = FALSE, smoothFunction = locfitByCluster, useWeights = FALSE, B=ncol(permutations), permutations=NULL, verbose = TRUE, ...)
}
\arguments{
  \item{mat}{A gdsn.class object (e.g betas(gfile)}
  \item{design}{Design matrix with rows representing samples and columns
    representing covariates. Regression is applied to each row of mat.}
  \item{chr}{A character vector with the chromosomes of each location.}
  \item{pos}{A numeric vector representing the chromosomal position.}
  \item{cluster}{The clusters of locations that are to be analyzed
    together. In the case of microarrays, the clusters are many times
    supplied by the manufacturer. If not available the function
    \code{\link[bumphunter]{clusterMaker}} can be used to cluster nearby locations.}
  \item{coef}{An integer denoting the column of the design matrix
    containing the covariate of interest. The hunt for bumps will be
    only be done for the estimate of this coefficient.}
  \item{cutoff}{A numeric value. Values of the estimate of the genomic
    profile above the cutoff or below the negative of the cutoff will be
    used as candidate regions. It is possible to give two separate
    values (upper and lower bounds). If one value is given, the lower
    bound is minus the value.}
  \item{pickCutoff}{Should bumphunter attempt to pick a cutoff using the
    permutation distribution?}
  \item{pickCutoffQ}{The quantile used for picking the cutoff using the
    permutation distribution.}
  \item{maxGap}{
    If cluster is not provided this maximum location gap will be used to define cluster
    via the \code{\link[bumphunter]{clusterMaker}} function.}
  \item{nullMethod}{
    Method used to generate null candidate regions, must be one of \sQuote{bootstrap} or
    \sQuote{permutation} (defaults to \sQuote{permutation}). However, if covariates in addition to the 
    outcome of interest are included in the design matrix
  (ncol(design)>2), the \sQuote{permutation} approach is not
  recommended. See vignette and original paper for more information.}
  \item{smooth}{
    A logical value. If TRUE the estimated profile will be smoothed with the
    smoother defined by \code{smoothFunction}}
  \item{smoothFunction}{
    A function to be used for smoothing the estimate of the genomic
    profile. Two functions are provided by the package: \code{loessByCluster}
    and \code{runmedByCluster}.}
  \item{useWeights}{
    A logical value. If \code{TRUE} then the standard errors of the
   point-wise estimates of the profile function will be used as weights
   in the loess smoother \code{loessByCluster}. If the
   \code{runmedByCluster} smoother is used this argument is ignored.}
 \item{B}{An integer denoting the number of resamples to use when computing
   null distributions. This defaults to 0. If \code{permutations} is
  supplied that defines the number of permutations/bootstraps and \code{B} is
  ignored.}
\item{permutations}{ is a matrix with columns providing indexes to be used to
  scramble the data and create a null distribution when
  \code{nullMethod} is set to  permutations. If the bootstrap approach is used this argument is
  ignored. If this matrix is not supplied and \code{B}>0 then
  these indexes are created using the function \code{sample}. }
\item{verbose}{
    logical value. If \code{TRUE}, it writes out some messages
    indicating progress. If \code{FALSE} nothing should be printed.
  }
  \item{\dots}{
    further arguments to be passed to the smoother functions.
}
}
\details{
This function is a direct replication of the \code{\link[bumphunter]{bumphunter}} function by Rafael A. Irizarry, Martin J. Aryee, Kasper D. Hansen, and Shan Andrews.
}
\author{
Original Function by Rafael A. Irizarry, Martin J. Aryee, Kasper D. Hansen, and Shan Andrews.
Bigmelon implementation by Tyler Gorrie-Stone
Who to contact if this all goes horribly wrong: <t.gorrie-stone@qmul.ac.uk>
}

\name{estimateCellCounts}
\alias{estimateCellCounts.gds}
\alias{getquantiles}
\title{
Cell Proportion Estimation using bigmelon
}
\description{
Estimates the relative proprotion of pure cell types within a sample, identical to \code{\link[minfi]{estimateCellCounts}}. Currently, only a reference data-set exists for 450k arrays. As a result, if performed on EPIC data, function will convert gds to 450k array dimensions (this will not be memory efficient).
}
\usage{
    estimateCellCounts.gds(
        gds,
        gdPlatform = c("450k", "EPIC", "27k"),
        mn = NULL,
        un = NULL,
        bn = NULL,
        perc = 1,
        compositeCellType = "Blood",
        probeSelect = "auto",
        cellTypes = c("CD8T","CD4T","NK","Bcell","Mono","Gran"),
        referencePlatform = c("IlluminaHumanMethylation450k",
            "IlluminaHumanMethylationEPIC",
            "IlluminaHumanMethylation27k"),
        returnAll = FALSE,
        meanPlot = FALSE,
        verbose=TRUE,
        ...)
}
\arguments{
\item{gds}{An object of class gds.class, which contains (un)normalised methylated and unmethylated intensities}
\item{gdPlatform}{Which micro-array platform was used to analysed samples}
\item{mn}{
'Name' of gdsn node within gds that contains methylated intensities, if NULL it will default to 'methylated' or 'mnsrank' if \code{\link{dasenrank}} was used prior
}
\item{un}{'Name' of gdsn node within gds that contains unmethylated intensities, if NULL it will default to 'unmethylated' or 'unsrank' if \code{\link{dasenrank}} was used prior}

\item{bn}{'Name' of gdsn node within gds that contains un(normalised) beta intensities. If NULL - function will default to 'betas'.}
\item{perc}{Percentage of query-samples to use to normalise reference dataset. This should be 1 unless using a very large data-set which will allow for an increase in performance}
\item{compositeCellType}{Which composite cell type is being deconvoluted. Should be either "Blood", "CordBlood", or "DLPFC"}
  \item{probeSelect}{How should probes be selected to distinguish cell types? Options include
    "both", which selects an equal number (50) of probes (with F-stat p-value < 1E-8) with the
    greatest magnitude of effect from the hyper- and hypo-methylated sides, and "any", which
    selects the 100 probes (with F-stat p-value < 1E-8) with the greatest magnitude of difference
    regardless of direction of effect. Default input "auto" will use "any" for cord blood and
    "both" otherwise, in line with previous versions of this function and/or our recommendations.
    Please see the references for more details.}
  \item{cellTypes}{Which cell types, from the reference object, should be
    we use for the deconvolution? See details. }
  \item{referencePlatform}{The platform for the reference dataset; if
    the input \code{rgSet} belongs to another platform, it will be
    converted using \code{\link{convertArray}}.}
  \item{returnAll}{Should the composition table and the normalized user
    supplied data be return?}
  \item{verbose}{Should the function be verbose?}
  \item{meanPlot}{
    Whether to plots the average DNA methylation across the cell-type discrimating probes within
    the mixed and sorted samples.
}
\item{...}{Other arguments, i.e arguments passed to plots}
}
\details{
See \code{\link[minfi]{estimateCellCounts}} for more information regarding the exact details. estimateCellCounts.gds differs slightly, as it will impose the quantiles of type I and II probes onto the reference Dataset rather than normalising the two together. This is 1) More memory efficient and 2) Faster - due to not having to normalise out a very small effect the other 60 samples from the reference set will have on the remaining quantiles.

Optionally, a proportion of samples can be used to derive quantiles when there are more than 1000 samples in a dataset, this will further increase performance of the code at a cost of precision.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/inout.R
\name{bigPepo}
\alias{bigPepo}
\title{tea.gds - description and validation for gds objects}
\usage{
bigPepo(path, gds, manifest, chunksize = NULL, force = TRUE, ...)
}
\description{
Checks the validity, file location and read/write status of a gds object
}
\details{
For DNAm use
with the bigmelon package.  For interactive use the default verbose 
option also prints
further details. Returns a list.
}

\name{bigmelon-internal}
\alias{bigmelon-internal}
\alias{newgds}
\alias{handle}
\alias{findgdsobj}
\alias{bmrownames}
\alias{bmrownames,gds.class-method}
\alias{subSet}
\alias{subSet,gds.class-method}
\alias{dasen2}
\alias{dfsfit.gdsn.class.1}
\alias{normalizeQuantiles.gdsn.class}
\alias{zot}
\alias{getTrait}
\alias{[.gds.class}
\alias{[.gdsn.class}


\title{
Internal bigmelon functions

}
\description{
Internal bigmelon functions, not intended for end user. What are you doing here!?
}
\usage{

newgds(file)
handle(gds)
findgdsobj(gds)
subSet(x, i, j, ..., drop = FALSE)

}

\arguments{

\item{file}{
A character string specifying the name of the .gds file to write to.
}

\item{gds}{
Either a gds.class object, or a character string specifying an existing 
.gds file.
}

\item{x}{
A gds.class object
}

\item{i}{
rows (probes) to select for subsetting
}

\item{j}{
columns (samples) to select for subsetting
}

\item{drop}{
passed on to '[' indexing operator.
}

}

\details{
newgds creates a new .gds file stub with the given name.
handle is used by app2gds to return a file handle for the given object.
findgdsobj is used by handle to search the workspace for a gds.class object 
linked to the file name specified.
subSet is used by internal functions to select a subset of rows (probes) and 
columns (samples) from a .gds file (overwriting the existing).

}

\value{
Nothing.
}

\author{
Leonard C Schalkwyk, Ayden Saffari, Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

%\seealso{}

\examples{
data(melon)
gfile <- es2gds(melon, "melon.gds")
betas(gfile)[1:5,1:3]
closefn.gds(gfile)
unlink("melon.gds")
}

\keyword{internal}

\name{iadd}
\alias{iadd}
\alias{iadd2}
\alias{idats2gds}

\title{
Add data from Illumina IDAT files to a gds file.
}
\description{
iadd will add data from multiple, specified, idat files providing '/path/to/barcode' is valid path
to a specified gds file. Barcode here implies the first part of the idat file name i.e without '_(Red|Grn).idat'

iadd2 will add data from all idat files that are stored within a single directory to a gds file.

idats2gds will add data from a set of barcodes into the same gds file, one by one, optionally will 
handle idat files from different maps providing force=TRUE. However, will not combine from arrays 
of differing types e.g. 450k vs EPIC.
}
\usage{
iadd(bar, gds, n = TRUE, force = TRUE, target_cpgs = NULL, ...)
iadd2(path, gds, chunksize = NULL, force=TRUE, ...)
idats2gds(barcodes, gds, n=TRUE, force = FALSE, ...)
}

\arguments{
\item{bar}{
The barcode for an IDAT file OR the file path of the file containing red or
green channel intensities for that barcode (this will automatically
locate and import both files regardless of which one you provide)
}
\item{path}{
The file path where (multiple) IDAT files exist. iadd2 will process every idat
within the specified directory.
}
\item{gds}{

Either:
A gds.class object

Or:
A character string specifying the name of an existing .gds file to write to.

Or:
A character string specifying the name of a new .gds file to write to

}
\item{chunksize}{
If NULL, iadd2 will read in all barcodes in one go. Or if supplied with
a numeric value, iadd2 will read in that number of idat files in batches
}

\item{n}{
Logical, whether or not bead-counts are extracted from idat files.
}

\item{force}{
Logical, whether or not rownames from the first idat file are applied to all idat files. Useful in combining together idat files of differing lengths.
}

\item{target_cpgs}{
    A vector of CpGs to specifically read in and set the dimensions of array to.
}

\item{barcodes}{
    A vector of barcodes to load into an existing gds file.
}

\item{...}{
Additional Arguments passed to wateRmelons methylumIDATepic.
}
}

\value{
returns a gds.class object, which points to the appended .gds file.
}

\author{
Tyler Gorrie-Stone, Leonard C Schalkwyk, Ayden Saffari.
Who to contact: <tyler.gorrie-stone@diamond.ac.uk>
}

\seealso{
\code{\link{es2gds}}, \code{\link{app2gds}}.
}

\examples{
if(require('minfiData')){
bd <- system.file('extdata', package='minfiData')
gfile <- iadd2(file.path(bd, '5723646052'), gds = 'melon.gds')
closefn.gds(gfile)
unlink('melon.gds')
}
}

%%\keyword{ ~kwd1 }
%%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{wm-port}
\alias{wm-port}
\alias{dmrse,gds.class-method}
\alias{dmrse,gdsn.class-method}
\alias{dmrse_col,gds.class-method}
\alias{dmrse_col,gdsn.class-method}
\alias{dmrse_row,gds.class-method}
\alias{dmrse_row,gdsn.class-method}
\alias{genki,gds.class-method}
\alias{genki,gdsn.class-method}
\alias{seabi,gds.class-method}
\alias{qual,gdsn.class,gdsn.class-method}
\alias{predictSex,gdsn.class-method}
\alias{predictSex,gds.class-method}
\alias{predictSex}

\title{
Functions imported from wateRmelon
}
\description{
Manual page for methods for the extraenous functions from wateRmelon. For more details for specific functions see the respective manual pages 
in wateRmelon.
}
\usage{
\S4method{qual}{gdsn.class,gdsn.class}(norm, raw)
\S4method{predictSex}{gds.class}(x, x.probes=NULL, pc=2, plot=TRUE, irlba=TRUE, center=FALSE, scale.=FALSE)
\S4method{predictSex}{gdsn.class}(x, x.probes=NULL, pc=2, plot=TRUE, irlba=TRUE, center=FALSE, scale.=FALSE)
}
\arguments{
\item{norm}{
normalized node (gdsn.class)
}
\item{raw}{
raw node (gdsn.class)
}
\item{x}{gdsclass object or node corresponding to betas}
\item{x.probes}{Default is NULL, is required to be supplied in bigmelon. logical or numeric vector containing indicies of X chromosome probes}
\item{pc}{The principal component to guess sex across (usually the 2nd one in most cases)}
\item{plot}{Logical, indicated whether or not to plot the prediction}
\item{irlba}{Logical, indicate whether or not to use the faster method to generate principal components}
\item{center}{Logical, indicate whether or not to center data around 0}
\item{scale.}{Logical, indicate whether or not to scale data prior to prcomp}
}

\details{
For the full usage and description of any functions that link to this manual page, please visit the respective manual pages from wateRmelon.
}
\value{
Returns expected output of functions from wateRmelon
}

\seealso{
\code{\link{wateRmelon}}
}

%%\examples{
%%}

\keyword{wm-port}

\name{finalreport2gds}
\alias{finalreport2gds}
\title{
Read finalreport files and convert to genomic data structure files
}
\description{
Function to easily load Illumina methylation data into a genomic data 
structure (GDS) file.
}
\usage{
finalreport2gds(finalreport, gds, ...)
}
\arguments{
\item{finalreport}{
A filename of the text file exported from GenomeStudio
}
\item{gds}{
The filename for the gds file to be created
}
\item{\dots}{
Additional arguments passed to \code{\link[methylumi]{methylumiR}}
}
}
\details{
Creates a .gds file.
}
\value{
A gds.class object
}

\author{
Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

\examples{
finalreport <- "finalreport.txt"
\dontrun{finalreport2gds(finalreport, gds="finalreport.gds")}
}

\name{app2gds}
\alias{app2gds}
\title{
Append a MethyLumiSet object to a preexisting gds file
}
\description{
This function will append a MethyLumiSet object to a gds file and return a gds.class object.
}
\usage{
app2gds(m, bmln)
}

\arguments{
\item{m}{
The MethyLumiSet object to be appended to the gds file, with the same number of rows as the gds file.
}
\item{bmln}{

Either:
A gds.class object

Or:
A character string specifying the filepath of an existing .gds file to write to.

Or:
A character string specifying the file path of a new .gds file to write to
}
}

\details{
Currently this function only takes a MethyLumiSet object as the only type of eligible input. This function will also produce unexpected results if the number of rows of the new object does not match the existing .gds file. Hopefully the function will noisily fail if this is the case however to prevent any errors from occuring it is recommended that raw idat files are read in using \code{\link[wateRmelon]{readEPIC}} or appended with \code{\link{iadd}} or \code{\link{iadd2}} to ensure that all rows are of the same length and have the same annotation.
}

\value{
A gds.class object pointed towards the newly appended .gds file.
}

\author{
Leonard C Schalkwyk, Ayden Saffari, Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

\seealso{
\code{\link{es2gds}}, \code{\link{iadd}}, \code{\link{iadd2}}.
}

\examples{
#load example dataset
data(melon)

#split data into halves
melon_1 <- melon[,1:6]
melon_2 <- melon[,7:12]

#convert first half to gds
e <- es2gds(melon_1,'1_half_melon.gds')

#append second half to existing gds file
f <- app2gds(melon_2,e)

unlink("1_half_melon.gds")
}

%% R documentation directory.
%%\keyword{ ~kwd1 }
%%\keyword{ ~kwd2 }

\name{bigmelon-accessors}
\alias{bigmelon-accessors}
\alias{betas,gds.class-method}
\alias{methylated,gds.class-method}
\alias{unmethylated,gds.class-method}
\alias{pvals,gds.class-method}
\alias{fData,gds.class-method}
\alias{pData,gds.class-method}
\alias{QCmethylated,gds.class-method}
\alias{QCunmethylated,gds.class-method}
\alias{QCrownames,gds.class-method}
\alias{QCmethylated}
\alias{QCunmethylated}
\alias{QCrownames}
\alias{getHistory,gds.class-method}
\alias{colnames,gds.class-method}
\alias{rownames,gds.class-method}
\alias{colnames,gdsn.class-method}
\alias{rownames,gdsn.class-method}
\alias{exprs,gds.class-method}
\alias{'[.gds.class'}
\alias{'[.gdsn.class'}
\alias{fot,gds.class-method}
\alias{fot}

\title{
Bigmelon accessors
}

\description{
Functions to access data nodes in gds.class objects.
}

\usage{

\S4method{betas}{gds.class}(object)
\S4method{methylated}{gds.class}(object)
\S4method{unmethylated}{gds.class}(object)
\S4method{pvals}{gds.class}(object)
\S4method{fData}{gds.class}(object)
\S4method{pData}{gds.class}(object)
\S4method{QCmethylated}{gds.class}(object)
\S4method{QCunmethylated}{gds.class}(object)
\S4method{QCrownames}{gds.class}(object)
\S4method{getHistory}{gds.class}(object)
\S4method{colnames}{gds.class}(x, do.NULL=TRUE, prefix=NULL)
\S4method{rownames}{gds.class}(x, do.NULL=TRUE, prefix=NULL)
\S4method{exprs}{gds.class}(object)
\S4method{fot}{gds.class}(x)
}

\arguments{

\item{object}{
A gds.class object.
}


for colnames and rownames:
\item{x}{
A gds.class object.
}

\item{do.NULL}{
logical. If 'FALSE' and names are 'NULL', names are created.
}

\item{prefix}{
prefix: for created names.
}

}

\details{
Each function will return the data stored in the corresponding node as either a gdsn.class 
object, matrix, or data.frame. These are names following the conventions of the 
methylumi package and perform similar functions.

Each function which returns a gdsn.class object can be further index using the '[' 
operators. This includes an additional name argument which optionally returns the named
attributes to the data as these are not stored inside the gdsn.node.

The QC functions will return the QC data as a matrix, these are seperated for methylation and 
unmethylated values and the rownames.

exprs will return a data.frame from beta values for all probes and all samples.
}

\value{
Returns specified node representing the called accessor
}

\author{
Leonard C Schalkwyk, Ayden Saffari, Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

%\seealso{}

\examples{
data(melon)
e <- es2gds(melon,'wat_melon.gds')
betas(e)
head(betas(e)[,])
methylated(e)[1:5, 1:3]
unmethylated(e)[1:3 ,1:5]
pvals(e)[1:5, 1:5]
head(fData(e))
head(pData(e))
head(colnames(e))
head(rownames(e))

closefn.gds(e)
unlink("wat_melon.gds")
}

\name{GEOtoGDS}
\alias{geotogds}
\alias{getpheno}
\title{
Download data from GEO and convert it into a gdsfmt object
}
\description{
Uses the GEOquery R package to download a GSE Accession into the current working directory. This will only work for GSE's that have raw idat files associated with them.
}
\usage{
geotogds(geo, gds, method = "wget", keepidat = F, keeptar = F, ...)
}

\arguments{
\item{geo}{
Either a GEO accession number ('GSE########') or a previously downloaded tarball 'GSE######.tar.gz'
}
\item{gds}{
A character string that specifies the path and name of the .gds file you want to write to.
}
\item{method}{
Character value to indicate which method should be used to download data from GEO. Default is 'wget'
}
\item{keepidat}{Logical, indicate whether or not raw idat files in the working directon should be removed after parsing, if FALSE: idat files will be removed.}
\item{keeptar}{Logical, indicate whether or not the downloaded tarball should be removed after parsing, if FALSE: the tarball will be removed.}
\item{...}{
Additional Arguments to pass to other functions (if any)}
}
\value{
geotogds will return a gds.class object that will point towards a the newly created .gds file with majority of downloaded contents inside.
}

\author{
Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

%\seealso{}
\examples{
#load example dataset
# gfile <- geotogds("GSE*******", "Nameoffile.gds")
# Will not work if gds has no idats submitted. May also fail if idats
# are not deposited in a way readily readable by readEPIC().
# closefn.gds(gfile)
}

\name{getquantilesandranks}
\alias{getquantilesandranks}
\alias{.sortvector}
\title{
Compute the quantiles and ranks for a given gdsn.node
}
\description{
Used inside \code{\link{dasenrank}} to generate the quantiles for both type 'I' and type 'II' probes to normalise DNA methylation data using bigmelon.
}
\usage{
getquantilesandranks(gds, node, onetwo, rank.node = NULL, perc = 1)
}
\arguments{
\item{gds}{
A gds.class object
}
\item{node}{
A gdsn.class object, or a character string that refers to a node within supplied gds.
}
\item{onetwo}{
gdsn.class object OR character string that refers to location in gds that contains information relating to probe design OR vector of length equal to the number of rows in the array that contains 'I' and 'II' in accordance to Illumina HumanMethylation micro-array design. This can be obtained with fot(gds)
}
\item{rank.node}{Default = NULL. If supplied with character string, function will calculate the ranks of given node and store them in gds. Additionally, the computed quantiles will now instead be attributed to rank.node which can be accessed with \code{\link{get.attr.gdsn}}
}
\item{perc}{
A number between 0 and 1 that relates to the given proportion of columns that are used to normalise the data. Default is set to 1, but in cases where there many of samples to normalise this number can be reduced to increase speed of code.
}
}
\details{
Used in \code{\link{dasenrank}}, can be used externally for testing purposes.
}
\value{
If rank.node is NULL. A list containing quantiles, intervals and supplied probe design will be returned.
If rank.node was supplied, nothing will be returned. Instead a new node will be created in given gds that has the otherwise returned list attached as an attribute. Which can be accessed with \code{\link{get.attr.gdsn}}
}

\author{
Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}
%\seealso{
%}
\examples{
data(melon)
e <- es2gds(melon, "melon.gds")
output <- getquantilesandranks(gds = e, 'methylated', onetwo = fot(e), perc = 1, rank.node = NULL)
# with-out put.
#getquantilesandranks(gds = e, 'methylated', onetwo = fot(e), perc = 1, rank.node = 'mnsrank')
closefn.gds(e)
unlink("melon.gds")
}

\name{pwod.gdsn}
\alias{pwod.gdsn}
\alias{pwod, gds.class}
\alias{pwod, gdsn.class}

\title{
Probe-Wise Outlier Detection for DNA methylation data.
}
\description{
Function performed outlier detection for each probe (row) using Tukey's Interquartile Range method.
}
\usage{
pwod.gdsn(node, mul = 4)
}
\arguments{
\item{node}{
gdsn.class node that contains the data matrix to be filtered
}
\item{mul}{
The number of interquartile ranges used to determine outlying
probes. Default is 4 to ensure only very obvious outliers are
removed.
}
}
\details{
Detects outlying probes across arrays in methylumi and minfi
objects.
}
\value{
Nothing is returned. However the supplied gds object (of-which the node is a child of) will have a new node
with NAs interdispersed where outliers are found.
}

\author{
Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

\seealso{
\code{\link[wateRmelon]{pwod}}
}
\examples{
data(melon)
e <- es2gds(melon, "melon.gds")
pwod(e)
closefn.gds(e)
unlink("melon.gds")
}

\name{pfilter.gds}
\alias{pfilter.gds}
\alias{pfilter,gds.class-method}
\alias{pfilter,gds.class}
\title{Basic data filtering for Illumina methylation data in gds objects}
\description{
The pfilter function filters data sets based on bead count and
detection p-values.  The user can set their own thresholds or use
the default pfilter settings. This specific function will take a Genomic Data
Structure (GDS) file as input and perform pfilter similar to how
\code{\link[wateRmelon]{pfilter}} in wateRmelon is performed.
}
\usage{
\S4method{pfilter}{gds.class}(mn, perCount = NULL, pnthresh = NULL,
perc = NULL, pthresh = NULL)
}
\arguments{
\item{mn}{
a gds object OR node corresponding to methylated intensities
}
\item{perCount}{
Threshold specifying which sites should be removed if they have a given percentage of samples with a beadcount <3, default = 5
}
\item{pnthresh}{
cut off for detection p-value, default= 0.05
}
\item{perc}{
remove sample having this percentage of sites with a detection p-value
greater than pnthresh, default = 1
}
\item{pthresh}{
Threshold specifying which sites should be removed if they have a given percentage of samples with a detection p-value greater
than pnthresh, default = 1
}
}
%\details{}
\value{ See \code{\link[wateRmelon]{pfilter}}. If using pfilter.gds, function
If using pfilter.gds function will return a list of containing two locical vectors of length(nrow) and lneght(ncol) which can be used to subset data. Otherwise if called using pfilter data will be subsetted automatically.
}
\author{Tyler Gorrie-Stone, Original (wateRmelon) Function by Ruth Pidsley
Who to Contact: <t.gorrie-stone@qmul.ac.uk}
\seealso{\code{\link[wateRmelon]{pfilter}}}
\examples{
data(melon)
e <- es2gds(melon, "melon.gds")
pfilter(e)
closefn.gds(e)
unlink("melon.gds")
}

\name{bigmelon-package}
\alias{bigmelon-package}
\alias{bigmelon}
\docType{package}
\title{
Write large-scale Illumina array datasets to CoreArray Genomic Data
Structure (GDS) data files for efficient storage, access, and modification.
}
\description{
Functions for storing Illumina array data as CoreArray Genomic Data Structure
(GDS) data files (via the gdsfmt package), appending these files , and
applying array normalization methods from the wateRmelon package.
}
\details{
\tabular{ll}{
Package: \tab bigmelon\cr
Type: \tab Package\cr
Version: \tab 1.13.8\cr
Date: \tab 2020-02-24\cr
License: \tab GPL3\cr
}
}
\author{
Tyler Gorrie-Stone Leonard C Schalkwyk, Ayden Saffari, Karim Malki.
Who to contact: <t.gorrie-stone@qmul.ac.uk>, <lschal@essex.ac.uk>

}
\references{
[1]Tyler J Gorrie-Stone, Melissa C Smart, Ayden Saffari, Karim Malki, Eilis Hannon, Joe Burrage, Jonathan Mill, Meena Kumari, Leonard C Schalkwyk: 
Bigmelon: tools for analysing large DNA methylation datasets, Bioinformatics, Volume 35, Issue 6, 15 March 2019, Pages 981-986.
https://doi.org/10.1093/bioinformatics/bty713

[2]Pidsley R, Wong CCY, Volta M, Lunnon K, Mill J, Schalkwyk LC:
A data-driven approach to preprocessing Illumina 450K methylation array data.
BMC genomics, 14(1), 293.
}

\seealso{
\code{\link{es2gds}}, \code{\link{dasen}}, \code{\link{wateRmelon}},
\code{\link{gdsfmt}}.
}


\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chainsaw.R
\name{chainsaw}
\alias{chainsaw}
\title{Chainsaw -- modify gds file by subsetting all nodes}
\usage{
chainsaw(gfile, i = "", j = "", v = FALSE, cleanup = TRUE)
}
\arguments{
\item{gfile}{A gds.class object.}

\item{i}{Specifies rows (ie probes) in the desired subset, similar to behaviour of `[`}

\item{j}{Specifies columns (ie sampless) in the desired subset, similar to behaviour of `[`}

\item{v}{If true, spew many messages.}

\item{cleanup}{If true, run a cleanup function that can substantially reduce the file size.}
}
\value{
a gds.class object.  This is a handle to the same file that the gfile argument 
points to.  It's not generally useful to have two handles to the same file, but it may make code 
more readable.  In interactive use, if not assigned, the returned object is usefully pretty-printed.
}
\description{
Currently the `[` function for the gds.class objects used by bigmelon only subsets a 
single node. This function does more like what you would normally expect a subsetting function 
to do, it returns a subset of the entire object.  It may in future be a replacement for `[.gds.class`.
}
\details{
This function is intended for use in the preprocessing and QC phase of a DNA methylation workflow.
For efficiency, bigmelon stores data in a file, and the gds.class object is a file handle. 
True to its name, chainsaw chops the underlying file, this is a side affect of the function and 
is not affected by assignment of the return value.
}

\name{backup.gdsn}
\alias{backup.gdsn}

\title{
Copy gds node to a backup folder within gds object
}

\description{
This function will copy a designated gdsn.class object stored inside a gds object to a backup folder (aptly named backup). If the backup folder does not exist, this will be created. This is a wrapper to \code{\link[gdsfmt]{copyto.gdsn}} which should be used if one wishes to copy a gds node to a seperate gds file.
}

\usage{
backup.gdsn(gds = NULL, node)
}

\arguments{
\item{gds}{
If NULL, function will call \code{\link[gdsfmt]{getfolder.gdsn}} to find the
root node. Otherwise, user can specify a separate gds.class object to copy
the specified node to.
}

\item{node}{
gdsn.class object (a gds node) which can be specified using \code{\link[gdsfmt]{index.gdsn}}
}
}

\value{
A gdsobject with an additional folder called backup with supplied node within.
}

\author{
Tyler Gorrie-Stone <t.gorrie-stone@qmul.ac.uk>
}

\seealso{\code{\link[gdsfmt]{copyto.gdsn}}}

\examples{
data(melon)
e <- es2gds(melon, "melon.gds")
nod <- index.gdsn(e, "betas")
backup.gdsn(gds = NULL, node = nod)
closefn.gds(e)
unlink("melon.gds")
}

\keyword{backup}

\name{es2gds}
\alias{es2gds}
\title{
Coersion method for MethyLumiSet, RGChannelSet or MethylSet to CoreArray 
Genomic Data Structure (GDS) data file
}
\description{
The es2gds function takes a MethyLumiSet, RGChannelSet or MethylSet data object
and converts it into a CoreArray Genomic Data Structure (GDS) data file 
(via the gdsfmt package), returning this as a gds.class object for use 
with bigmelon. 
}
\usage{
es2gds(m, file, qc = TRUE)
}

\arguments{
\item{m}{
A MethyLumiSet, RGChannelSet or MethylSet object
}
\item{file}{
A character string specifying the name of the .gds file to write to.
}

\item{qc}{
When set to true (default), data from control probes included.
}
}

\value{
A gds.class object, which points to the newly created .gds file.
}

\author{
Leonard C Schalkwyk, Ayden Saffari, Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}

\seealso{
\code{\link{app2gds}}, \code{\link{iadd}}.

}
\examples{
#load example dataset
data(melon)
#convert to gds
e <- es2gds(melon,'melon.gds')
closefn.gds(e)
unlink('melon.gds')
}

%% Add one or more standard keywords, see file 'KEYWORDS' in the
%% R documentation directory.
%%\keyword{ ~kwd1 }
%%\keyword{ ~kwd2 }

\name{gds2mlumi}
\alias{gds2mlumi}
\alias{gds2mset}

\title{
Convert Genomic Data Structure file to Methylumiset or Methylset object.
}
\description{
Convert a Genomic Data Structure object back into a methylumi object,
with subsetting features.
}
\usage{
gds2mlumi(gds, i, j)
gds2mset(gds, i, j, anno)
}

\arguments{
\item{gds}{
a gds object
}
\item{i}{
Index of rows
}
\item{j}{
Index of Columns
}
\item{anno}{
If NULL, function will attempt to guess the annotation to be used. 
Otherwise can be specified with either "27k", "450k", "epic" or "unknown".
}
}
\value{
A methylumi object
}

\author{
Tyler Gorrie-Stone
Who to contact: <t.gorrie-stone@qmul.ac.uk>
}
\examples{
data(melon)
e <- es2gds(melon, "melon.gds")
gds2mlumi(e)
closefn.gds(e)
unlink("melon.gds")
}

\name{bigmelon-normalization}
\alias{dasen.gds}
\alias{dasen,gds.class-method}
\alias{danen.gds}
\alias{danen,gds.class-method}
\alias{naten.gds}
\alias{naten,gds.class-method}
\alias{daten1.gds}
\alias{daten1,gds.class-method}
\alias{daten2.gds}
\alias{daten2,gds.class-method}
\alias{nasen.gds}
\alias{nasen,gds.class-method}
\alias{nanet.gds}
\alias{nanet,gds.class-method}
\alias{danet.gds}
\alias{danet,gds.class-method}
\alias{nanes.gds}
\alias{nanes,gds.class-method}
\alias{danes.gds}
\alias{danes,gds.class-method}
\alias{qn.gdsn}
\alias{db.gdsn}
\alias{dfsfit.gdsn}
\alias{betaqn,gds.class-method}

\title{
Bigmelon Quantile Normalization methods.
}

\description{
Set of functions that are used to perform quantile normalization methods on gds.class objects.
}

\usage{
\S4method{dasen}{gds.class}(mns, fudge = 100, ret2 = FALSE, node="betas",...)
dasen.gds(gds, node, mns, uns, onetwo, roco, fudge, ret2)
qn.gdsn(gds, target, newnode)
db.gdsn(gds, mns, uns)
dfsfit.gdsn(gds, targetnode, newnode, roco, onetwo)
}

\arguments{
\item{gds}{ A gds.class object
}
\item{node}{ The "name" of desired output \code{\link[gdsfmt]{gdsn.class}} node
}
\item{mns}{ The \code{gdsn.class} node that corresponds to "methylated"
intensities.
}
\item{uns}{ The \code{gdsn.class} node that corresponds to "unmethylated"
intensities.
}
\item{onetwo}{ The \code{gdsn.class} node that corresponds to probe designs
(in reference to 450k and EPIC arrays)
OR
character string pointing to location of \code{gdsn.class} node. e.g.
"fData/DESIGN"
OR
vector containing probe design types of length > 1.
}
\item{roco}{ This allows a background gradient model to be fit.
This is split from data column names by default.  roco=NULL
disables model fitting (and speeds up processing), otherwise
roco can be supplied as a character vector of strings like
'R01C01' (only 3rd and 6th characters used).
}
\item{fudge}{ The value added to total intensity to prevent denominactors close
to zero when calculation betas. default = 100
}
\item{ret2}{ if TRUE, appends the newly calculated methylated and
unmethylated intensities to original gds (as specified in gds arguement).
Will overwrite the raw intensities.
}
\item{target}{ Target \code{gdsn.class} node to perform normalization on.
If using "*****.gds" method you do not need to specify this.
}
\item{targetnode}{ Target \code{gdsn.class} node to perform normalization
on. If using "*****.gds" method you do not need to specify this.
}
\item{newnode}{ "name" of desired output \code{gdsn.class} node.
If using "*****.gds" method you do not need to specify this.
}
\item{...}{Additional args such as roco or onetwo.}
}

\details{
Each function performs a normalization method described within the wateRmelon
package. Functions: \code{qn.gdsn}, \code{design.qn.gdsn}, \code{db.gdsn} and
\code{dfsfit.gdsn} are described to allow users to create their own custom
normalization methods. Otherwise calling \code{dasen} or \code{dasen.gds}
e.t.c will perform the necessary operations for quantile normalization.

Each 'named' normalization method will write a temporary gds object called
"temp.gds" into the current working directory and it is removed
when normalization is complete. Current methods supplied by default arguments
will replace the raw betas with normalized betas, but leave the methylated and unmethylated intensities unprocessed.
}

\value{
Normalization methods return nothing but will affect the gds file and
replace/add nodes given to the function.
}

\author{
Tyler J Gorrie-Stone <t.gorrie-stone@qmul.ac.uk>
}
\seealso{
\code{\link{wateRmelon}}, \code{\link[wateRmelon]{dasen}}
}
\examples{
data(melon)
e <- es2gds(melon,'wat_melon.gds')
dasen(e)
closefn.gds(e) # Close gds object
unlink('wat_melon.gds') # Delete Temp file
}

\name{combo.gds}
\alias{combo.gds}

\title{
Combine two different gds objects together
}

\description{
Function will attempt to combine together the shared gdsn.class nodes between two gds object 
depending on the dimensions of the primary gds.class object.
}

\usage{
combo.gds(file, primary, secondary)
}

\arguments{
\item{file}{
Name of the new gds file to be created.
}
\item{primary}{
A gds.class object.
}
\item{secondary}{
A gds.class object.
}
}

\details{
--EXPERIMENTAL--
Will crudely combine shared nodes between primary and secondary based on the
dimensions / rownames of the primary node. NAs will be coerced where probes
are missing from secondary gds.

Currently will only look for nodes with the names "betas", "methylated", "unmethylated",
"pvals" and "NBeads".
}

\note{
Will lose information relating to "pData". Therefore we recommend compiling
separate pData object manually and adding combined pData post-function
}

\author{
Tyler Gorrie-Stone <t.gorrie-stone@qmul.ac.uk>
}

\value{
Returns (and creates) as new gds file in the specified location with the combination
of two gds objects together.
}

\examples{
data(melon)
a <- es2gds(melon[,1:6], "primary.gds")
b <- es2gds(melon[,7:12], "secondary.gds")

ab <- combo.gds("combo.gds", primary = a, secondary = b)

closefn.gds(a)
unlink("primary.gds")
closefn.gds(b)
unlink("secondary.gds")
closefn.gds(ab)
unlink("combo.gds")
}

\keyword{combo}
